<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Customer extends MY_Controller{
    public function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->helper('cookie');
        $this->load->library('curl');
        $this->load->library('pagination');
    }
    function souchUserAccount($uid = '', $mac = ''){
        $data =[];
        $tb = otable::userinfo();
        $mac = urldecode($mac);
        $data['uid'] = $uid;
        $data['mac'] = $mac;
        $where = ' where 1 ';

        if($uid)$where .= ' and uid='.intval($uid);
        if($mac)$where .= "  and mac='{$mac}' ";
        if($uid || $mac){
            $sql = "Select * from {$tb} {$where}";
            $data["list"] = oo::commonOprDb('slavedb')->getAll($sql,1);
        }
        $this->load->view('customer/userAccount', $data);
    }
    //===========好友操作==============
    public function souchFriend($uid = 0){
        $data =[];
        if($uid>0){
            $data['uid'] =$uid;
            $arr = ["game"=>"游戏内好友","fb"=>"fb好友","nopoker_new"=>"fb已解除好友关系(游戏内不展示)"];
            foreach ($arr as $k=>$item){
                $flistArr = oo::commonOprModel('friend')->getUserAllFriend($uid,$k);
                $list[$item]  = json_encode($flistArr,32);
            }
            $data['list'] = $list;
        }
        $this->load->view('customer/souchFriend', $data);
    }
    public function addFriendApi(){
        $postData = $this->input->post();
        if(!$postData['uid']||!$postData['toUid']||$postData['toUid']==$postData['uid']){
            return $this->response(0, '参数不合法');
        }
        $this->addFriend($postData['uid'],$postData['toUid']);
        $this->addFriend($postData['toUid'],$postData['uid']);


        return $this->response(0, '添加成功',["uid"=>$postData["uid"]]);
    }
    public function addFriend($uid,$toUid){
        //建立好友关系缓存
        $key = okeys::userfriends($uid,"game");
        $gameFriendList =oo::commonOprModel('friend')->getUserAllFriend($uid,"game");
        array_push($gameFriendList,$toUid);
        $gameFriendList =is_array($gameFriendList)?$gameFriendList:[];
        $gameFriendList = array_unique($gameFriendList);
        $gamsFriendStr = json_encode($gameFriendList,32);
        oo::commonOprRedis('games')->setex($key,$gamsFriendStr,86400*7);
        //清理过滤好友关系
        $key2 = okeys::userfriends($uid,"nopoker_new");
        $dFriendList =oo::commonOprModel('friend')->getUserAllFriend($uid,"nopoker_new");
        if(in_array($toUid,$dFriendList)){
            if(array_search($toUid,$dFriendList)!==false){
                unset($dFriendList[array_search($toUid,$dFriendList)]);
            }
            $dFriendList=array_values($dFriendList);
            $dFriendStr = json_encode($dFriendList,32);
            oo::commonOprRedis('games')->setex($key2,$dFriendStr,86400*7);
        }
        //设置落地标识
        $key3 =okeys::Landing("USERFRIENDS",$uid);
        oo::commonOprRedis('games')->zAdd($key3,time(),$uid);
    }
    public function delFriendApi(){
        $postData = $this->input->post();
        if(!$postData['uid']||!$postData['toUid']||$postData['toUid']==$postData['uid']){
            return $this->response(0, '参数不合法');
        }
        $this->delFriend($postData['uid'],$postData['toUid']);
        $this->delFriend($postData['toUid'],$postData['uid']);


        return $this->response(0, '添加成功',["uid"=>$postData["uid"]]);
    }
    public function delFriend($uid,$toUid){
        //解除好友关系
        foreach (["game","fb"] as $type){
            $key2 = okeys::userfriends($uid,$type);
            $dFriendList =oo::commonOprModel('friend')->getUserAllFriend($uid,$type);
            if(in_array($toUid,$dFriendList)){
                if(array_search($toUid,$dFriendList)!==false){
                    unset($dFriendList[array_search($toUid,$dFriendList)]);
                }
                $dFriendList=array_values($dFriendList);
                $dFriendStr = json_encode($dFriendList,32);
                oo::commonOprRedis('games')->setex($key2,$dFriendStr,86400*7);
                if($type=="fb"){
                    $key = okeys::userfriends($uid,"nopoker_new");
//                    $gflist = oo::commonOprRedis('games')->get($key);
                    $gameFriendList =oo::commonOprModel('friend')->getUserAllFriend($uid,"nopoker_new");
                    $gameFriendList =is_array($gameFriendList)?$gameFriendList:[];
                    array_push($gameFriendList,$toUid);
                    $gameFriendList = array_unique($gameFriendList);
                    $gamsFriendStr = json_encode($gameFriendList,32);
                    oo::commonOprRedis('games')->setex($key,$gamsFriendStr,86400*7);
                }
            }
        }

        //设置落地标识
        $key3 =okeys::Landing("USERFRIENDS",$uid);
        oo::commonOprRedis('games')->zAdd($key3,time(),$uid);
    }

    //邀请信息查询
    public function inviteQuery()
    {
        $this->load->view("customer/inviteQuery", []);
    }

    //邀请信息查询
    public function searchInviteData()
    {
        return $this->response(0, '操作成功', $this->getInviteData($this->input->post()));
    }
    private function getInviteData($params)
    {
        $info=[];
        switch ($params['type']) {
            case 'invitee':
                $uid = intval($params['invitee']);
                $tb  = "crazygod_api_adjuststa.t_adjust_cliect_data";
                $sql = "select * from {$tb} where uid = {$uid};";
                $results = oo::commonOprDb('slavedb')->getOne($sql);
                $where = " adid='".$results['adid']."'";


                $sql = "select tracker_name,created_at,label,tracker_token from crazygod_api_adjuststa.t_adjust_data where {$where}";
                $info = oo::commonOprDb('slavedb')->getAll($sql);
                foreach ($info as &$oneInfo) {
                    $oneInfo['label'] = !is_null($oneInfo['label']) ? base64_decode($oneInfo['label']) : '';
                    $oneInfo['created_at'] = date('Y-m-d H:i:s', $oneInfo['created_at']);
                }
                break;
            case 'inviter':
                $uid = intval($params['inviter']);

                $sql ="select * from crazygod_api_userinvite.invite_suc where is_senduid = {$uid};";
                $info = oo::commonOprDb('slavedb')->getAll($sql);
                foreach ($info as &$oneInfo) {
                    $oneInfo['is_time'] = date('Y-m-d H:i:s', $oneInfo['is_time']);
                }
                break;
        }

        return $info;
    }
    private function getInviteData_old($params)
    {
        $info=[];
        switch ($params['type']) {
            case 'invitee':
                $uid = intval($params['invitee']);
                $tb  = "crazygod_api_adjuststa.t_adjust_sta_".$uid%100;
                $sql = "select * from {$tb} where uid = {$uid};";
                $results = oo::commonOprDb('slavedb')->getOne($sql);

                $where = "";
                if ($results['android']) {
                    $where .= "gps_adid = '" . $results['android']."'";
                } elseif ($results['ios']) {
                    $where .= "adid = '" . $results['ios']."' or idfa = '".$results['ios']."'";
                }else{
                    $where = "0=1";
                }

                $sql = "select tracker_name,created_at,label,tracker_token from crazygod_api_adjuststa.t_adjust_data where {$where};";
                $info = oo::commonOprDb('slavedb')->getAll($sql);
                foreach ($info as &$oneInfo) {
                    $oneInfo['label'] = !is_null($oneInfo['label']) ? base64_decode($oneInfo['label']) : '';
                    $oneInfo['created_at'] = date('Y-m-d H:i:s', $oneInfo['created_at']);
                }

                break;
            case 'inviter':
                $uid = intval($params['inviter']);

                $sql ="select * from crazygod_api_userinvite.invite_suc where is_senduid = {$uid};";
                $info = oo::commonOprDb('slavedb')->getAll($sql);
                foreach ($info as &$oneInfo) {
                    $oneInfo['is_time'] = date('Y-m-d H:i:s', $oneInfo['is_time']);
                }
                break;
        }

        return $info;
    }

    public function activateInvite(){
        $postData=$this->input->post();
        $uid = abs($postData['uid']);
        $toUid = $postData['toUid'];

        return $this->response(1,"功能暂未开放");
        // 好友进度加进度条
        $tb = otable::userinvitegiftbag();
        $sql1 = "UPDATE {$tb} SET `invitenum` = `invitenum`+1 WHERE uid={$uid}";
        oo::commonOprDb('games')->query($sql1);

        // 设置为邀请成功未领奖
        $tb2 = otable::inviteSuc();
        $insertData = ["is_senduid"=>$uid,"is_backuid"=>$toUid,"is_time"=>time(),"type"=>4];
        $sql2 = funs::db_insertSQL($tb,$insertData);
        oo::commonOprDb('games')->query($sql2);

        //活动加进度
        $key3 = okeys::userBindActivity("time_limit_invite",$uid);
        $aid=oo::commonOprRedis('games')->get($key3);
        if($aid>0){

        }


        return $this->response(0,"",[abs($postData['uid']),$postData['toUid']]);
    }
    //==========活动查询===========
    //锦标赛信息
    public function userActRank($uid=0){
        $data =[];
        if($uid>0){
            $data['uid'] =$uid;
            $aid = oo::commonOprRedis('games')->get(okeys::userBindActivity("rank",$uid));
            if($aid>0){
                $data['userActInfo'] = [
                    "aid"=>$aid,
                    "group"=>oo::commonOprRedis('games')->get(okeys::userBindStageGroup($aid,$uid)),
                    "attrInfo"=>json_encode(oo::commonOprRedis('games')->hGetAll(okeys::activityBindUserAttr($uid,$aid))),
                    "stageInfo"=>json_encode(oo::commonOprRedis('games')->hGetAll(okeys::userActStageRate($uid,$aid)))
                ];
            }
            $now = time();
            $tb = otable::activityConf();
            $sql = "SELECT * FROM {$tb} where type='rank' AND end_time>$now and start_time<=$now limit 6";
            $actList = oo::commonOprDb('slavedb')->getAll($sql,1);
            foreach ($actList as $item){

                $roomId = oo::commonOprRedis('games')->hGet(okeys::userRankRoomIdList($item['id']),$uid);//房间
                $key = okeys::activityUserRankList($aid,$roomId);
                $ranking  = intval(oo::commonOprRedis('games')->zRevRank($key,$uid))+1;//排名
                $score=  intval(oo::commonOprRedis('games')->zScore($key,$uid));//分数
                $wrlist = oo::commonOprRedis('games')->hGetAll(okeys::awardRankEndReward($uid,"rank"));//待领取记录
                $one =[
                    "uid"=>$uid,
                    "aid"=>$item['id'],
                    "ranking"=>$roomId?$ranking:0,
                    "rankNum"=>$score,
                    "isreward"=>in_array($item['id'],array_keys($wrlist))?"待领取":($roomId?"可能已领取":"尚未获得积分"),
                    "etime"=>0,
                    "stage"=>1,
                ];
                if(in_array($item['id'],array_keys($wrlist))){
                    $one["etime"] = $wrlist[$item['id']];
                }
                $data['list'][] = $one;
            }

        }
        $this->load->view('customer/actRank', $data);
    }
    //体力大师信息
    public function userActSpinsMaster($uid=0){
        $data =[];
        if($uid>0) {
            $data['uid'] = $uid;
            $aid = oo::commonOprRedis('games')->get(okeys::userBindActivity("spins_master", $uid));
            if ($aid > 0) {
                $data['userActInfo'] = [
                    "aid" => $aid,
                    "group" => oo::commonOprRedis('games')->get(okeys::userBindStageGroup($aid, $uid)),
                    "attrInfo" => json_encode(oo::commonOprRedis('games')->hGetAll(okeys::activityBindUserAttr($uid, $aid))),
                    "score" => json_encode(oo::commonOprRedis('games')->get(okeys::userSpinsMasterScore($aid,$uid)))
                ];
                $data["list"] = oo::commonOprRedis('games')->hGetAll(okeys::userSpinsMasterReceiveLog($aid,$uid));//领取记录
            }
        }
        $this->load->view('customer/actSpinsMaster', $data);
    }
    //收集信息
    public function userActSuperCollect($uid=0){
        $data =[];
        if($uid>0) {
            $data['uid'] = $uid;
            $aid = oo::commonOprRedis('games')->get(okeys::userBindActivity("super_collect", $uid));
            if ($aid > 0) {
                $data['userActInfo'] = [
                    "aid" => $aid,
                    "group" => oo::commonOprRedis('games')->get(okeys::userBindStageGroup($aid, $uid)),
                    "attrInfo" => json_encode(oo::commonOprRedis('games')->hGetAll(okeys::activityBindUserAttr($uid, $aid))),
                    "stageInfo" => json_encode(oo::commonOprRedis('games')->hGetAll(okeys::userActStageRate($uid, $aid)))
                ];
            }
        }
        $this->load->view('customer/actCollect', $data);
    }
    //俱乐部锦标赛信息
    public function userActClubRank(){
        echo "<h1>敬请期待</h1>";
    }

    //通行证信息
    public function userActGamePass($uid = 0)
    {
        $data = [];
        if ($uid > 0) {
            $data['uid'] = $uid;
            $aid = oo::commonOprRedis('games')->get(okeys::userBindActivity(TRAFFIC_PERMIT, $uid));
            if ($aid > 0) {
                $data['userActInfo'] = oo::commonOprRedis('games')->hGetAll(okeys::GamePassInfo($aid, $uid));
            }
            $passInfo = $this->findPassRewardConfByLvRange($uid, $aid) ?? [];
            if ($passInfo) {
                $levelConf = $passInfo['levels'] ?? [];

                $list = array_column($levelConf, "max", "levelId");

                $userExp = $data['userActInfo']["exp"];
                $maxLv = max(array_keys($list));
                $maxExp = $list[$maxLv];

                $thisLv = 0;
                $thisLvExp = 0;

                // 超过配置的最大经验值
                if ($userExp > $maxExp) {
                    $thisLv = $maxLv + floor(($userExp - $maxExp) / $passInfo['basic']['maxLevelExpGap']);
                    $thisLvExp = ($userExp - $maxExp) % $passInfo['basic']['maxLevelExpGap'];
                } else {
                    foreach ($levelConf as $row) {
                        if ($row['max'] > $userExp) {
                            break;
                        }
                        $thisLv = $row['levelId'];
                        $thisLvExp = $userExp - $row['max'];
                    }
                }

                $data['userActInfo']['thisLv'] = $thisLv;
                $data['userActInfo']['thisLvExp'] = $thisLvExp;

                $receiveList = [
                    'receive_special', 'receive_normal'
                ];
                foreach ($receiveList as $type){
                    if(strpos($data['userActInfo'][$type], ',') !== false){
                        $arr = explode(',', $data['userActInfo'][$type]);
                        sort($arr);
                        $data['userActInfo'][$type] = implode(',', $arr);
                    }
                }
            }
        }
        $this->load->view('customer/actGamePass', $data);
    }

    // 通过等级范围获取通行证奖励
    public function findPassRewardConfByLvRange($uid, $aid)
    {
        $stage = oo::commonOprRedis('games')->get(okeys::activityUserStageKey($uid, $aid));
        $reward_conf = oo::commonOprRedis('games')->hget(okeys::activityInfo($aid), 'reward_pro');
        $reward_conf = json_decode($reward_conf ?: "[]", true);
        return $reward_conf[$stage] ?? [];
    }
    // ========查询======
    // 小丑卡记录查询
    public function userJokerLog($uid=0,$page=0){
        $data = [];
        if($uid){
            $data['page'] = $page;
            $limitStr = " limit $page, 20";
            $tb2 = otable::userJokerLog();
            $sql= "Select * from {$tb2}  where uid={$uid} order by id desc {$limitStr}";
            $data['list'] = oo::commonOprDb('slavedb')->getAll($sql,1);
            //获取总数
            $totalSql = " SELECT COUNT(*) AS t FROM {$tb2} where uid={$uid}";
            $totalRet = oo::commonOprDb('slavedb')->getOne($totalSql, MYSQLI_ASSOC);
            $data['total'] = (int)$totalRet['t'];


            //分页
            $pageConfig = $this->pageConfig;
            $pageConfig['base_url'] = base_url('#Customer/userJokerLog/'.$uid);
            $pageConfig['total_rows'] = $data['total'];
            $pageConfig['per_page'] = 20;
            $this->pagination->initialize($pageConfig);
            $pageurl = $this->pagination->create_links();
            $data['pageurl'] = $pageurl;
        }
        $this->load->view('customer/userJokerLog', $data);
    }
    //=========奖励邮件发放============
    // 获取历史发送记录
    public function sendUserGameMailIndex($page = 0){
//        var_dump(get_cookie('username'));
//        var_dump($_COOKIE);

        $data = [];
        $data['page'] = $page;
        $limitStr = " limit $page, 30";
        $tb2 = otable::gmSendUserMsgLog();
        $sql= "Select * from {$tb2} order by id desc {$limitStr}";
        $list = oo::commonOprDb('statistics')->getAll($sql,1);
        foreach ($list as &$item){
            if($item['umids']){
                $umids=json_decode($item['umids'],true);
                foreach ($umids as $uid=>$ck){
                    $msgOneJson = oo::commonOprRedis('games')->hGet(okeys::sysMsgGet($uid),$ck);
                    $msgOne = json_decode($msgOneJson,true);
                    $umids[$uid] = $msgOne?$msgOne['got']:1;
                }
                $item['umids'] = $umids;
            }
        }
        $data['list'] =$list;
        //获取总数
        $totalSql = " SELECT COUNT(*) AS t FROM {$tb2}";
        $totalRet = oo::commonOprDb('statistics')->getOne($totalSql, MYSQLI_ASSOC);
        $data['total'] = (int)$totalRet['t'];


        //分页
        $pageConfig = $this->pageConfig;
        $pageConfig['base_url'] = base_url('#Customer/sendUserGameMailIndex');
        $pageConfig['total_rows'] = $data['total'];
        $pageConfig['per_page'] = 30;
        $this->pagination->initialize($pageConfig);
        $pageurl = $this->pagination->create_links();
        $data['pageurl'] = $pageurl;

        $this->load->view('customer/userMsg', $data);
    }
    //发放奖励
    public function sendGameMailReward(){
        $postData = $this->input->post();
        $uids = explode(',',$postData['uids']);
        $msgId = $postData['mid'];
        $rewards = $postData['rewards'];
        if(empty($uids)||!is_array($uids)){
            return $this->response(1, '添加失败,uid 异常',$postData);
        }
        if(empty($msgId)){
            return $this->response(1, '添加失败,模板id不为空',$postData);
        }
        if(empty($rewards)||!is_array($rewards)){
            return $this->response(1, '添加失败,奖励异常异常',['reward'=>$rewards]);
        }
        $key = "sendGameMailReward".$postData['uids'].md5(json_encode($rewards));
        if(!oo::commonOprRedis('games')->setnxex($key,1,60)){
            return $this->response(1, '添加失败：相同uid,相同奖励-冷却时间60秒',['reward'=>$rewards]);
        }
        $umids =[];
        foreach ($uids as $uid){
            $tb = otable::userSysMail($uid);
            $key = okeys::sysMsgGet($uid);
            $rewardNew = [];
            foreach ($rewards as $k=>$v){
                if($v['propsId']==9&&$v['num']>100){
                    return $this->response(1, '添加失败，宠物食物不能超过100',["uid"=>$postData["uid"]]);
                }
                if($v['propsId']==15&&$v['num']>1000000){
                    return $this->response(1, '添加失败，体力不能超过100W',["uid"=>$postData["uid"]]);
                }
                //go fox 结构体
                $one = [
                    "propsId"=>$v['propsId'],
                    "num"=>$v['num'],
                    "rtype"=>1,
//                    "jokerCardExpireTime"=>0,
//                    "cards"=>null,
//                    "chestProps"=>null,
//                    "skinResourceId"=>0,
                    "skin"=>intval($v['skin']),
                ];
//                if($v["propsId"]==19){
//                    $one["skin"] = $v['skin'];
//                    //通过skin 获取皮肤资源id
//                    $conf = oo::commonOprModel('config')->getChestSkinConfig($v['skin']);
//                    $one["skinResourceId"] = $conf['skinResourceId']>0?$conf['skinResourceId']:$one["skin"];
//                }
                array_push($rewardNew,$one);
            }
            $data = [
                "uid"=>$uid,
                "msgid"=>$msgId,
                "got"=>0,
                "rewards"=>json_encode($rewardNew),
                "expire"=>time()+86400*3,
                "create_time"=>time(),
            ];
            $sql = funs::db_insertSQL($tb,$data);
            $ret = oo::commonOprDb('games')->query($sql,1);
            if($ret){
                $eid = oo::commonOprDb('games')->insertID();
                $data['id'] = $eid;
                $data['rewards'] = json_decode($data['rewards'],true);
                $field = "{$msgId}_{$eid}";
                $umids[$uid] = $field;
                oo::commonOprRedis('games')->hSet($key,$field,json_encode($data));
                oo::commonOprRedis('games')->expireAt($key,time()+86400*16);
                //推送
                $this->SendNsqMsg2(TopicPHPPush,[],["uid"=>$uid,"cmd"=>0x401b,"data"=>$data]);
            }else{
                return $this->response(0, '添加失败',["ret"=>$ret]);
            }
        }
        $insertLog = [
            "uids"=>$postData['uids'],
            "mid"=>$msgId,
            "rewards"=>json_encode($rewards,32),
            "optuser"=>get_cookie('username'),
            "creat_ts"=>time(),
            "umids"=>json_encode($umids)
        ];
        $tb2 = otable::gmSendUserMsgLog();
        $sql2 = funs::db_insertSQL($tb2,$insertLog);
        oo::commonOprDb('statistics')->query($sql2,1);
        return $this->response(1, '添加成功',["uid"=>$postData["uid"]]);
    }
    // 召回发放的奖励
    function callBackSendReward(){
        $postData = $this->input->post();
        $tb = otable::gmSendUserMsgLog();
        $sendId = $postData['id'];
        $sql= "Select * from {$tb} where id={$sendId}";
        $info = oo::commonOprDb('statistics')->getOne($sql,1);
        if($info){
            $umids=json_decode($info['umids'],true);
            foreach ($umids as $uid=>$item){
                $tb2 = otable::userSysMail($uid);
                $key = okeys::sysMsgGet($uid);
                $uminfoStr=oo::commonOprRedis('games')->hGet($key,$item);
                $uminfo = json_decode($uminfoStr,true);
                if($uminfo['got']==2){
                    continue;
                }
                $res =false;
                if($uminfo['id']){
                    $sql2 = "DELETE FROM {$tb2} WHERE `id`=".$uminfo['id'];
                    $res = oo::commonOprDb('games')->query($sql2);
                }
                if($res){
                    oo::commonOprRedis('games')->hDel($key,$item);
                    unset($umids[$uid]);
                }else{
                    return $this->response(1, '撤回失败',[$postData,$umids,$sql2]);
                }
            }
            if($res){
                $umids_str =$umids?json_encode($umids):"";
                $update['umids'] = $umids_str;
                $sql3 = funs::db_updateSQL($tb,$update," id={$sendId}");
                oo::commonOprDb('games')->query($sql3);
            }
        }

        return $this->response(0, '撤回成功',[$postData,$sql2,$sql3]);
    }
    //========宠物激活===========
    public function getUserPet($uid,$petId = 0,$orig = false){
        $cacheKey = okeys::UserPet2($uid);
        $userPetArr = oo::commonOprRedis('games')->hGetAll($cacheKey);
        if(empty($userPetArr)){
            $tb         = otable::UserPet($uid);
            $userPetArr = oo::commonOprDb('games')->getAll("SELECT * FROM {$tb} WHERE uid={$uid}", MYSQLI_ASSOC);
            if(!empty($userPetArr)){
                oo::commonOprRedis('games')->expire($cacheKey,oo::redisRandomExpire(7*24*60*60));
            }
        }else{
            $userPetArr = array_values($userPetArr);
            foreach ($userPetArr as $key=>$row){
                $userPetArr[$key] = json_decode($row,true);
                if($petId&&$petId==$row['petId']){
                    $petId2 = $userPetArr[$key];
                }
            }
        }
        if($petId2){
            $userPetArr = $petId2;
        }else if($petId){
            $userPetArr = [];
        }
//        echo "<pre>";
//        print_r($userPetArr);
        return $userPetArr;
    }

    public function showUserPet($uid=0){
        $data =[];
        $data['pet'] = ["1"=>"偷宠物","2"=>"盾牌宠物(游戏内位置3)","3"=>"攻击宠物(游戏内位置2)"];
        if($uid>0){
            $data['list'] =[];
            $data['uid'] = $uid;
            $list = $this->getUserPet($uid);
            $arr =  array_column($list,null,'petId');
            foreach ($data['pet'] as $pid=>$item){
                $one = [
                    "status"=>isset($arr[$pid])?1:0,
                    "showName"=>$item,
                    "petId"=>$pid,
                    "lv"=>isset($arr[$pid])?$arr[$pid]["lv"]:0
                ];
                array_push($data['list'],$one);
            }
        }
//        var_dump($data);
        $this->load->view('customer/petShow', $data);
    }
    public function openUserPet(){
        $postData = $this->input->post();
        $uid = $postData['uid'];
        $petId = intval($postData['pid']);
        if($uid<1||!in_array($petId,[1,2,3])){
            return $this->response(-1, '激活失败，uid 或宠物id 异常');
        }
//        return $this->response(1, '激活成功',$postData);
        $petInfo = $this->getUserPet($uid,$petId);
        if($petInfo){
            return oo::response(-1,[],"已经激活过:{$petId}");
        }
        $tb  = otable::UserPet($uid);
        $time = time();
        oo::commonOprDb('games')->query("INSERT INTO {$tb} (uid,petId,nick,getTime,star) VALUES ('{$uid}','{$petId}','pet','{$time}',-1)", false);
        $userPet = oo::commonOprDb('games')->getOne("SELECT * FROM {$tb} WHERE uid={$uid} AND petId={$petId} LIMIT 1", MYSQLI_ASSOC);
        oo::commonOprRedis('games')->hSet(okeys::UserPet2($uid),$petId,json_encode($userPet));

        return $this->response(0, '激活成功',$postData);
    }
    //======账号变更=======
    public function showUserInfo($uid,$toUid){
        $data=[];
        if ($uid>0&&$toUid){
            $tb =otable::userinfo();
            $sql = "SELECT * FROM {$tb} where uid in({$uid},{$toUid})";
            $data["info"]=oo::commonOprDb('slavedb')->getAll($sql,1);

            $tb2 = otable::taccount();
            $sql2 = "SELECT * FROM {$tb2} where uid in({$uid},{$toUid})";
            $account=oo::commonOprDb('slavedb')->getAll($sql2,1);
            $arr = array_column($account,null,'uid');
            $data["account"] = $arr;
            $data['uid']= $uid;
            $data['toUid']= $toUid;
//            var_dump($data['account']);
        }
        $this->load->view('customer/userAccount', $data);
    }
    public function changeUserAccount(){
        $postData = $this->input->post();
        $uid = $postData['uid'];
        $toUid = intval($postData['toUid']);
        $tb = otable::taccount();
        $sql = "SELECT * FROM {$tb} where uid in({$uid},{$toUid})";
        $account=oo::commonOprDb('games')->getAll($sql,1);
        $arr = array_column($account,null,'uid');

        $res2 = $res3 = $res4 =false;
        $w1 = "uid = {$uid}";
        $n1 = $arr[$toUid]['siteuid']."1";
        $sql2 = "UPDATE {$tb} SET `siteuid`={$n1} where {$w1}";
        $res2=oo::commonOprDb('games')->query($sql2);
        if($res2){
            $w2 = "uid = {$toUid}";
            $n2 = $arr[$uid]['siteuid'];
            $sql3 = "UPDATE {$tb} SET `siteuid`={$n2} where {$w2}";
            $res3=oo::commonOprDb('games')->query($sql3);
            if($res3){
                $n3 = $arr[$toUid]['siteuid'];
                $sql4 = "UPDATE {$tb} SET `siteuid`={$n3} where {$w1}";
                $res4=oo::commonOprDb('games')->query($sql4);
            }
        }
        oo::commonOprRedis('games')->delete(okeys::account($arr[$uid]['siteuid']));
        oo::commonOprRedis('games')->delete(okeys::account($arr[$toUid]['siteuid']));
        $rets =[
            "res2"=>$res2,
            "res3"=>$res3,
            "res4"=>$res4,
        ];
        if($res3){
            return $this->response(0, '变更成功',$rets);
        }else{
            return $this->response(0, '变更失败',$rets);
        }

    }

    public function appleOrder($orderId = ''){
//        date_default_timezone_get('UTC');
        if(empty($orderId))
            return $this->load->view('customer/appleOrder', []);
        $headers = [
            'Superant: shenzhen'
        ];
        $response = funs::sendCurl("http://platform.superant.cc/common/apple/lookup?game=cf&order_id={$orderId}", [], 'get', $headers);
        $response = @json_decode($response, true) ?? [];
        if($response['data']){
            foreach ($response['data'] as &$item){
                $item['purchaseDate'] = date('Y-m-d H:i:s', $item['purchaseDate']/1000);
            }
        }
        $this->response(0, '666', [$response]);
    }

    // 删除账号申请列表
    public function delAccountApplies(){
        include_once APPPATH . '/libraries/Ip2Region.class.php';
        $dbfile = APPPATH."/libraries/ipdb/ip2region.db";
        $obj = new Ip2Region($dbfile);
        $headers = [
            'id' => 'ID',
            'uid' => 'UID',
            'nick' => '昵称',
            'reason' => '理由',
            'sumMoney' => '付费金额',
            'ip' => '提交IP',
            'country' => '国家',
            'time' => '提交时间',
        ];
        $tbl = otable::userClearLog();
        $config = oo::commonOprDb('games')->getAll("select * from {$tbl} order by create_ts desc");

        $uids = array_column($config, 'uid');
        $uids = empty($uids) ? [0] : $uids;
        $uidsStr = implode(',', $uids);

//      付费信息
        $tb = otable::paidStat();
        $rows = oo::commonOprDb('slavedb')->getAll("Select `amount`,`uid` From {$tb} Where `uid` in ({$uidsStr})");
        $paymentMap = array_column($rows, 'amount', 'uid');

//        地址信息
        $tb = otable::useraddress();
        $rows = oo::commonOprDb('slavedb')->getAll("Select * From {$tb} Where `uid` in ({$uidsStr})");
        $userCountryMap = array_column($rows, 'country_code', 'uid');

//        国家码信息
        $tb = otable::TCountryCode();
        $countryCode = oo::commonOprDb('report')->getAll("Select * From {$tb} ");
        $countryCodeMap = array_column($countryCode, 'country_name', 'code');

        foreach ($config as &$item){
            $item['country'] = $countryCodeMap[$userCountryMap[$item['uid']]] ?? '';
            if(empty($item['country'])){
                $country = $obj->memorySearch($item['ip'])['region'];
                $item['country'] = explode('|', $country)[0] ?? '';
            }
            $item['sumMoney'] = $paymentMap[$item['uid']] ?? 0.00;
            $item['time'] = date('Y-m-d H:i:s', $item['create_ts']);
        }
        $data = [
            'title' => '删除账号申请列表',
            'headers' => $headers,
            'config' => $config,
            'js' => 'customer/delAccount.js',
            'topOperators' => [
//                '<input type="file" style="display: none" id="import-file" onchange="commonImport(this)" data-href="/import/timeLimitedIsland">',
//                '<button type="button" class="btn btn-outline btn-success" onclick="$(\'#import-file\').click()"  >导入</button>',
//                '<a type="button" class="btn btn-outline btn-primary"  href="/export/timeLimitedIsland" target="_blank">导出</a>',
            ],
            'operators' => [
                '<button type="button" class="btn btn-outline btn-primary" onclick="operate(this, 1)"  >拒绝</button>',
                '<button type="button" class="btn btn-outline btn-danger" onclick="operate(this, 2)"  >通过</button>',
            ],
        ];
        $this->load->view('common/commonTable', $data);
    }

    // 删除账号审核操作
    public function delAccountOperate(){
        $postData = $this->input->post();
        $userid = intval($postData['uid']);
        $status = intval($postData['status']);
        if ( empty($userid) || empty($status) ) $this->response(-1 * __LINE__, '异常操作', $postData);
        $tbl = otable::userClearLog();

        $sql = " update  {$tbl} set status={$status} where uid='{$userid}'";
        $res = oo::commonOprDb('games')->query($sql);

        if($status == 2){
            $url = $this->config->item('officialUrl');
            $postData = array('frombg' => 1, 'mod' => '', 'act' => '', 'lid' => 1, 'sid' => 1);;
            $postData['mod'] = 'user';
            $postData['act'] = 'clearAccount';
            $postData['uid'] = $userid;
            $postData['demo'] = 1;
            $res = $this->curl->req($url, $postData);
            $retData = json_decode($res, TRUE);
            if($retData['code'] == 1){
                $tbl = otable::userChannel();
                oo::commonOprDb('games')->query("delete from {$tbl} where uid={$userid}");
            }
            else
                $this->response(-1 * __LINE__, '删除失败');
        }

        $this->response(1, '操作成功');
    }

    public function FBLoginFailedUidSet20231201(){
        $columns = [
            'uid' => $this->inputField('uid','uid',  MY_Controller::$inputFieldTypeText),
        ];
        $data = [
            'columns' => $columns,
            'saveUrl' => '/customer/saveFBLoginFailedUidSet20231201',
        ];
        $this->load->view('common/commonForm', $data);
    }

    public function saveFBLoginFailedUidSet20231201(){
        $postData = $this->input->post();
        $uid = intval($postData['uid']);
        if(empty($uid)){
            $this->response(-1 * __LINE__, 'uid异常');
        }

        $redisKey = 'FBLoginFailedUidSet20231201';
        $res = oo::commonOprRedis('games')->sAdd($redisKey, $uid);
        if ($res)$this->response(-1 * __LINE__, '添加成功');
        else if($res === 0) $this->response(-1 * __LINE__, '已存在白名单');
        else $this->response(-1 * __LINE__, '添加失败');
    }
}