<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/**
 * 测试
 */
class Test extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->helper('cookie');
        $this->load->model('oo');
        $this->load->library('curl');
        if (file_exists(APPPATH.'config/reason.php')) {
            $this->reason = include APPPATH.'config/reason.php';
        }
    }

    public function test(){
        $param = $this->input->get();
        $uid   = max(intval($param['uid']),0);
        if(!empty($uid)){
            $actionGroupId = oo::commonOprModel('member')->updateUserGroup2($uid);
            if($actionGroupId){
                $tb  = otable::Polymerization(2);
                $ret = oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb}",MYSQLI_ASSOC);
                foreach ($ret as $key=>$row){
                    $ret[$row['id']] = array_column(json_decode($row['group_pro'],true),null,'id');
                }
            }else{
                $ret = [];
            }
            $postData = array('lid' => 1, 'sid' => 1,'service'=>1);
            $postData['mod'] = 'Config';
            $postData['act'] = 'polymerization';
            $postData['uid'] = $uid;
            $res = $this->curl->req($this->config->item('officialUrl'), $postData);
            $res = json_decode($res,true)['data']['config'];
            echo "最新数据：<br/>";
            foreach ($res as $row){
                echo "广告点：".$row['name']."，广告次数：".$row['max']."，广告概率：".$row['probability']."，广告开放等级：".$ret[$row['id']][$actionGroupId]['levelId'].'<br/>';
            }
        }
    }

    function sendJosnPost($url,$dataArr){
        $data_string = json_encode($dataArr);
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS,$data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($data_string))
        );

        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }

    public function index(){
        set_time_limit(0);
        ini_set('memory_limit', '2024M');

        //oo::commonOprModel('member')->updateUserDynamicsData(283598,["groupId3"=>"101"]);
        $userDynamicsData = oo::commonOprModel('member')->getUserDynamicsData(283598);
        $curGroupId = explode(',',$userDynamicsData['groupId3']);
        var_dump($curGroupId);
        var_dump($userDynamicsData['groupId3']);
        exit();
        /*
        $userDynamicsData = oo::commonOprModel('member')->getUserDynamicsData(2237911);
        $curGroupId = explode(',',$userDynamicsData['groupId3']);
        var_dump($curGroupId);
        var_dump($userDynamicsData['groupId3']);
        */


        //$res = oo::commonOprRedis('statistics')->zrange(okeys::EmailRecall(3),0,-1);
        //var_dump($res);
        //
        //        $cache    = oo::commonOprRedis('games')->get($cacheKey);
        //$res = oo::commonOprRedis('Statistics')->get(okeys::SendMailSta());
        //var_dump($res);

        $ret = oo::commonOprModel('statistics')->getAllPlayer("20210621", 2);
        $out = [];
        foreach($ret as $uid){
            $deviceID = oo::commonOprModel('member')->getAdjustDeviceIDByUid($uid);
            $cacheKey = okeys::UserAdjustGroup($uid);
            $cache    = oo::commonOprRedis('games')->ttl($cacheKey);
            $out[$cache/60]++;
        }
        arsort($out);
        $out = array_slice($out,0,20,true);
        var_dump($out);
        /*
        $cacheKey = okeys::UserAdjustGroup(2237911);
        $cache    = oo::commonOprRedis('games')->ttl($cacheKey);
        var_dump($cache);
        */
        exit();

        /*
        $data = oo::commonOprModel('SSdata')->getGroupList();
        var_dump($data);

        exit();

        */

        //oo::commonOprModel('member')->getUserListFromSS();

        //$uidList = oo::commonOprModel('SSdata')->getUidListByGroupName('cohort_20210616_2');
        //var_dump(count($uidList));

        /*
        $config = oo::commonOprModel('config')->getUserGroupConfigByCid(5);
        foreach ($config as $v) {
            if($v['groupId'] == 0 || $v['name'] == '数数-默认分组'){
                continue;
            }
            $key = okeys::userListSSGroup($v['groupId']);
            var_dump($key);
            var_dump($v['name']);
            $uidList = oo::commonOprModel('SSdata')->getUidListByGroupName($v['name']);
            var_dump(count($uidList));
        }
        $key = okeys::userListSSGroup(22);
        //oo::commonOprRedis('statistics')->zAdd($key,1,2251036);
        //$res = oo::commonOprRedis('statistics')->zScore($key,2251036);
        $res = oo::commonOprRedis('statistics')->zrange($key,0,-1);
        var_dump($res);
        */
        //$key = okeys::userListSSGroup(22);
        //$res = oo::commonOprRedis('statistics')->zrange($key,0,-1);
        //var_dump($res);
        //oo::commonOprModel('ssdata')->updateSGroup(2251036);
        //$userDynamicsData = oo::commonOprModel('member')->getUserDynamicsData(2251036);
        //$curGroupId = explode(',',$userDynamicsData['groupId3']);
        //var_dump($curGroupId);
        //var_dump($userDynamicsData['groupId3']);
        exit();
        $dataArr = [
            "clusterCatalog"=>"catalog_cluster",
            "clusterTypes"=>["cluster_by_dynamic_condition","cluster_by_static_condition","cluster_by_result","tag_by_dynamic_condition","tag_by_static_condition"],
            "pagerHeader"=>["pageNum"=>1,"pageSize"=>100],
            "projectId"=>3,
        ];
        $url = "http://172.22.107.114:8992/open/user-cluster-list?token=B30rBC3RjPks0spLCOX4ybYWUS9UTVIIA55vJnJ3BpwUxzqNRMeO7QBeAZNPfqjF";
        $ret = $this->sendJosnPost($url,$dataArr);
//        $retData = json_decode($ret,true);
        $retData = $ret;
        if(!empty($retData)&&is_array($retData)){
            $groupListInfo = $retData['data']['userClusters'];
        }
        var_dump($retData);
        exit();
        $data = oo::commonOprModel('SSdata')->getGroupList();
        var_dump($data);
        foreach ($data as $k=>$v){
            $datas[$k] =[
                'cid'=>5,
                'groupId'=>$v['id'],
                'name'=>$v['clusterName'],
                'remark'=>$v['displayName'],
                'update'=>1,
                'count'=>$v['usersNum']
            ];
        }
        $tb = otable::UserGroupConfig(2);
        $tb = str_replace("crazyGod_","crazygod_",$tb);
        foreach ($datas as $k=>$v){
            $ret = oo::commonOprDb('games')->getOne("SELECT * FROM {$tb} WHERE (groupId={$v["groupId"]} AND cid={$v["cid"]}) OR (`name`='{$v['name']}' AND cid={$v["cid"]}) limit 1",1);
            var_dump("SELECT * FROM {$tb} WHERE (groupId={$v["groupId"]} AND cid={$v["cid"]}) OR (`name`='{$v['name']}' AND cid={$v["cid"]}) limit 1");
            var_dump($ret);
            if(!empty($ret)){
                $w = "cid={$v["cid"]} AND groupId={$v["groupId"]} AND `name`='{$v['name']}'";
                $sql = funs::db_updateSQL($tb,$v,$w);
            }else{
                $sql = funs::db_insertSQL($tb,$v);
            }
//            $ret = $sql?oo::commonOprDb('games')->query($sql):false;
            var_dump($sql);
            var_dump(oo::commonOprDb('games')->query($sql));
        }
var_dump(intval(oo::commonOprRedis('games')->hGet(otable::basicConfig(),'basic-curMaxLevel')));
var_dump(otable::basicConfig());
        exit();
        $arr = [0];
        if($arr){
//          var_dump(1);
        }

        //$uidList = [283000];
        //$key = okeys::userListSSGroup(12);
        //foreach ($uidList as $uid){
        //    oo::commonOprRedis('statistics')->zAdd($key,1,$uid);
        //}


        //oo::commonOprModel('ssdata')->updateSGroup(283000);
        oo::commonOprModel('member')->updateUserDynamicsData(283000,["groupId3"=>"101"]);

        $userDynamicsData = oo::commonOprModel('member')->getUserDynamicsData(283000);
        $curGroupId = explode(',',$userDynamicsData['groupId3']);
        var_dump($curGroupId);
        var_dump($userDynamicsData['groupId3']);
        var_dump($userDynamicsData['groupId3']!==NULL);

//        $key = okeys::userListSSGroup(1);
//        oo::commonOprRedis('statistics')->delete($key);
        date_default_timezone_set('UTC');
        var_dump(date("Y-m-d H:i:s",1602764913));
        exit();
        $array = [
            'uid'=>280451,
            'type'=>'spins',
            'num'=>30,
            'crease'=>'+',
            'reason'=>'8',
            'time'=>1619403761,
            'last_num'=>4927,
            'rid'=>16,
            'levelId'=>31,
        ];
        $out = [];
        for($i = 1; $i <= 1000000; $i++){
            $out[] = $array;
        }
        $data = json_encode($out);
        var_dump("记录数：".count($data));
        var_dump("长度：".strlen($data));
        $sql = "INSERT INTO crazygod_roport_statistics.t_test (id,data) VALUES(1,'{$data}')";
        $res = oo::commonOprDb('statistics')->query($sql);
        var_dump($res);
        exit();
        oo::commonOprModel('Crontab')->coinsValue();
//        oo::commonOprModel('Crontab')->monitorFileToCDN();
    }


}
