<?php

class SlotModel extends CI_Model
{


    public static function getSlotItemByIdx($idx, $oldData){
        $idx = intval($idx);
        $id = $idx+1;
        $v = 0;
        switch ($idx){
            case  0:$type = 4;$prize = '攻击';break;
            case  1:$type = 3;$prize = '偷袭';break;
            case  2:$type = 2;$prize = '体力';break;
            case  3:$type = 5;$prize = '护盾';break;
            case  4:$type = 1;$prize = $oldData['prize'] ?? '0';$rewardId = 1;break;
            case  5:$type = 1;$prize = $oldData['prize'] ?? '0';$rewardId = 2;break;
            case  6:$type = 1;$prize = $oldData['prize'] ?? '0';$rewardId = 3;break;
            case  7:$type = 1;$prize = $oldData['prize'] ?? '0';$rewardId = 4;break;
            case  8:$type = 1;$prize = $oldData['prize'] ?? '0';$rewardId = 5;break;
            case  9:$type = 1;$prize = $oldData['prize'] ?? '0';$rewardId = 6;break;
            case 10:$type = 0;$prize = '没有奖励';break;
            case 11:$type = 6;$prize = '活动物品1';break;
            case 12:$type = 6;$prize = '活动物品2';break;
            case 13:$type = 6;$prize = '活动物品3';break;
            case 14:$type = 7;$prize = '小玩法物品1';break;
            case 15:$type = 7;$prize = '小玩法物品2';break;
            case 16:$type = 7;$prize = '小玩法物品3';break;
            case 17:$type = 8;$prize = '一个偷';break;
            case 18:$type = 8;$prize = '两个偷';break;
            case 19:$type = 9;$prize = '一个打';break;
            case 20:$type = 9;$prize = '两个打';break;
            case 21:$type = 10;$prize = '1个体力瓶';break;
            case 22:$type = 10;$prize = '2个体力瓶';break;
        }
        $reward = [];
        if(isset($id))$reward['id'] = $id;
        if(isset($type))$reward['type'] = $type;
        if(isset($prize))$reward['prize'] = $prize;
        if(isset($rewardId))$reward['rewardId'] = $rewardId;
        if(isset($v))$reward['v'] = $oldData['prize'] ?? $v;
        return $reward;
    }

    public static function saveSlotWeightGroupsCfg($file, $gid){
        $tb = otable::slotWeightGroupsCfg();
        $sql = "SELECT * from {$tb} where gid={$gid}";
        $rs = oo::commonOprDb('slavedb')->getAll($sql,1);
        $arr = [];
        $temp = [];
        foreach ($rs as $k=>$v){
            $arr[$v['levelId']] = json_decode($v['slotpro'],true);
            array_push($temp,(int)$v['levelId']);
        }

        $retData = $arr;
        $length  = count($retData);
        $macData = $retData[max(count($retData) - 1,0)];
        $xlsReader = IOFactory::createReader('Excel2007');
        $xlsReader->setReadDataOnly(true);
        $xlsReader->setLoadSheetsOnly(true);
        $Sheets = $xlsReader->load($file);
        $dataArray = $Sheets->getSheet(0)->toArray();
        unset($dataArray[0]);
        foreach ($dataArray as $key=>$row){
            if($key >= $length){
                $retData[$key] = $macData;
            }
            for($j=0;$j<23;$j++){
                $t = $j + 1;
                $tempItem = self::getSlotItemByIdx($j, $retData[$row[0]][$j] ?? []);
                $tempItem['v'] = $row[$t];
                $retData[$row[0]][$j] = $tempItem;
            }
        }
        foreach ($retData as $key=>$row){
            $upload[] = [
                'level'=>$key,
                'slotpro' =>$row,
            ];
        }
        $upload = json_decode(json_encode($upload));
        foreach ($upload as $row){
            $tempData = json_encode($row->slotpro,JSON_UNESCAPED_UNICODE);
            if(in_array($row->level,$temp)){
                $sql = "UPDATE {$tb} SET slotpro='{$tempData}' WHERE levelId={$row->level} and gid={$gid}";
            }else{
                $sql = "INSERT INTO {$tb} (gid,levelId,slotpro) VALUES ({$gid},{$row->level},'{$tempData}')";
            }
            $rs2 = oo::commonOprDb('games')->query($sql);

            oo::commonOprRedis('games')->hset(okeys::slotWeightGroupsCfg(),$gid . '_'.$row->level, $tempData);
        }
        $res = $rs2?$rs2:0;
        if($res == 0){
            return false;
        }else{
            return true;
        }
    }
}