<link rel="stylesheet" href="<?php echo base_url(); ?>public/css/vendor/bootstrap/bootstrap-table.css">
<link rel="stylesheet" href="<?php echo base_url(); ?>public/css/vendor/bootstrap/table-fix-column.css">

<script src="<?php echo base_url(); ?>public/js/vendor/bootstrap/src/bootstrap-table.js"></script>
<script src="<?php echo base_url(); ?>public/js/vendor/bootstrap/src/table-fix-column.js"></script>

<style type="text/css">
    /*table {*/
    /*    table-layout: fixed !important;*/
    /*}*/

    th {
        background: rgb(146, 208, 80);
    }

    td, th {
        max-width: 400px;
        word-wrap: break-word;
    }

    .table-hover > tbody > tr:hover {
        background-color: #c8bd6d;
    }

    input {
        width: 60px;
    }

    .fixed-table-toolbar {
        display: none;
    }

    .fileinput-button {
        position: relative;
        top: -5px;
    }

    .fileinput-button input {
        position: absolute;
        right: 0px;
        top: 0px;
        opacity: 0;
        -ms-filter: 'alpha(opacity=0)';
    }
</style>
<div class="content_wrapper">
    <div id="msg-tip"></div>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i><?php echo $cgid; ?>号卡组卡片配置</header>
                    <section>
                        <div class="container-fluid">
                            <button type="button" style="margin-bottom: 10px;width: 80px;" class="btn btn-danger" id="commitBtn">提交</button>
                            <div class="row">

                                <div class="col-sm-12">
                                    <div class="table-responsive">
                                        <table id="roleTable" class="table table-bordered table-hover"
                                               data-toggle="table"
                                               data-classes="table table-hover"
                                               data-show-columns="true"
                                               data-striped="true"
                                               data-height="700">
                                            <thead>
                                            <tr>
                                                <?php if (!empty($title)) {
                                                    foreach ($title as $val) { ?>
                                                        <th title="<?= $val ?>"><?php echo $val; ?></th>
                                                    <?php }

                                                } ?>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            <?php
                                            if (is_array($list) && !empty($list)) {
                                                foreach ($list as $key => $vl) { ?>
                                                    <tr>
                                                        <td><?php echo $vl['ciid']; ?></td>

                                                        <?php foreach ($_langList as $langk => $langv) { ?>
                                                            <td alt="<?= $vl[$langk] ?? $vl['ci_name'] ?>"><?= $vl[$langk] ?? $vl['ci_name'] ?></td>
                                                        <?php } ?>

                                                        <td><?php echo $vl['cgposition']; ?></td>
                                                        <td><?php echo $vl['ci_star_rank']; ?></td>
                                                        <td><?php echo $vl['ci_lockRank']; ?></td>
                                                        <td><?php echo $vl['ci_picture']; ?></td>
                                                        <td><?php echo $vl['grade']; ?></td>
                                                        <td><?php echo $vl['weights']; ?></td>
                                                        <td><img style="width: 100%;" src="<?php echo base_url(); ?>public/game/image/newcard/<?php echo $vl['ci_picture']; ?>.jpg" alt=""/></td>
                                                        <td class="propsRewardsTag" data-value='<?php echo $vl['reward']; ?>'></td>
                                                        <td>
                                                            <button type="button"
                                                                    class="btn btn-outline btn-success"
                                                                    onclick="propsJs.initEdit(this, 'propsRewardsTag',[15])">
                                                                奖励配置
                                                            </button>
                                                        </td>
                                                    </tr>
                                                <?php }
                                            } else { ?>
                                                <tr>
                                                    <td colspan="14">暂无数据</td>
                                                </tr>
                                            <?php } ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>


<script src="<?php echo base_url(); ?>public/js/common.js"></script>

<script>
    propsJs.initTag('propsRewardsTag')

    var obj;
    var levelId = 0;

    $("#submit").click(function () {
        var formData = new FormData();
        var file = document.getElementById("imgfile").files[0];
        if (file == "" || file == undefined) {
            $('#myModal').modal('hide');
            msgTip = $('#msg-tip');
            msgTip.messager().warn('请选择图片');
            return false;
        }
        formData.append("file", file);
        formData.append("ciid", levelId);
        $.ajax({
            type: "POST",
            url: "Upload/cardUpload",
            data: formData,
            async: true,
            processData: false, //
            contentType: false, //
            success: function (data) {
                data = JSON.parse(data);
                if (data.ret == 0) {
                    $('#myModal').modal('hide');
                    msgTip = $('#msg-tip');
                    msgTip.messager().success('上传成功');
                    setTimeout(function () {
                        window.location.reload();
                    }, 2000)
                } else {
                    msgTip = $('#msg-tip');
                    msgTip.messager().warn('上传失败');
                }
            }
        });
    });

</script>

<script>

    $('#roleTable').on('dblclick', 'td', function () {
        var _this = $(this),//保存td
            tdText = _this.text();
        var cellIndex = _this[0].cellIndex;
        if (cellIndex == 0) return false;


        if (!_this.is('.input')) {
            _this.addClass('input').html('<input type="text" value="' + tdText + '" />').find('input').focus().blur(function () {
                var _input = $(this); //保存input对象
                var thisvalue = $(this).val();
                _input.parent().removeClass('input').html(thisvalue || '');
                if ($('#commitBtn').prop('disabled')) {
                    $('#commitBtn').attr('disabled', false);
                }
            });
        }

    });


    $('#roleTable').on('blur', '.add-row', function () {
        var _that = $(this);
        var thisval = _that.find('input').val();
        console.log(thisval);
        _that.removeClass('input').html(thisval || 0);
    });

    let tableColumnsMapping = '<?=json_encode($tableColumnMapping)?>';
    if (typeof tableColumnsMapping == 'string') tableColumnsMapping = JSON.parse(tableColumnsMapping)

    //提交表格数据
    $('#commitBtn').click(function () {
        msgTip = $('#msg-tip');
        //如果还有添加未编辑的，则不能提交
        if ($('#roleTable td').hasClass('input')) {
            msgTip.messager().warn('列表中还有未编辑的');
            return;
        }

        var tr = $('#roleTable tr');
        var arr = [];
        for (var i = 1; i < tr.length; i++) {
            var tempData = {};
            var arrayTemp = {};
            td = $(tr[i]).find('td');
            for (var j = 0; j < td.length; j++) {
                if (j === 22 || j === 24) {
                    continue
                }
                switch (j) {
                    case 0:
                        tempData[tableColumnsMapping[j]] = $(td[j]).html();
                        break;
                    case 23:
                        tempData['reward'] = $(td[j]).data('value')
                        break;
                    default:
                        arrayTemp[tableColumnsMapping[j]] = $(td[j]).html();
                        break;
                }
            }
            tempData['data'] = arrayTemp;
            arr.push(tempData)
        }

        $.ajaxSetup({
            async: true
        });


        $.ajax({
            type: 'POST',
            dataType: 'json',
            data: {
                data: JSON.stringify(arr)
            },
            url: 'card/actionCard',
            success: function (data) {
                if (data.ret == 0) {
                    window.location.reload()
                    $('#commitBtn').attr('disabled', true);
                } else {
                    msgTip.messager().error(data.msg);
                }
            }
        });
    });


</script>

