<div class="content_wrapper">
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>广告下载奖励配置</header>
                    <section>
                        <form action="" id="adDLRewardForm">
                            <div class="container-fluid">
                                <button type="button" style="width: 80px;" class="btn btn-primary" id="commitBtn">提交</button>
                                <hr>
                                <div class="form-group">
                                    <label class="col-sm-1 control-label m-b">开关:</label>
                                    <div class="col-sm-2 input-group">
                                        <label class="checkbox-inline">
                                            <input type="radio" name="switch" <?php if ($switch == 0) echo "checked"; ?> value="0"> 关闭
                                        </label>
                                        <label class="checkbox-inline">
                                            <input type="radio" name="switch" <?php if ($switch == 1) echo "checked"; ?> value="1"> 开启
                                        </label>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-1 control-label m-b">奖励:</label>
                                    <table class="col-sm-4">
                                        <tr>
                                            <td class="propsRewardsTag" data-value='<?php echo json_encode($reward ?? []); ?>'></td>
                                            <td class="text-right">
                                                <button type="button"
                                                        class="btn btn-outline btn-success"
                                                        onclick="propsJs.initEdit(this, 'propsRewardsTag')">
                                                    奖励配置
                                                </button>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                        </form>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>


<script>
    showLoading()
    propsJs.initTag('propsRewardsTag')
    hideLoading()
    //提交表格数据
    $('#commitBtn').click(function () {
        const datas = $('#adDLRewardForm').toObject();
        datas['reward'] = $('.propsRewardsTag').data('value')

        showLoading()
        $.ajax({
            type: 'POST',
            dataType: 'json',
            data: datas,
            url: 'config/saveAdDownloadRewardConf',
            success: function (data) {
                hideLoading()
                if (data.ret === 0) {
                    window.location.reload()
                } else {
                    msgTip.messager().error(data.msg);
                }
            },
            error: function (xhr, error) {
                alert('请求失败！')
                hideLoading()
                console.log(xhr, error);
            }
        });
    });

</script>

