<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>主页背景配置</title>
    <!-- 最新版本的 Bootstrap 核心 CSS 文件 -->
    <link rel="stylesheet" href="<?php echo base_url();?>public/js/bootstrap/bootstrap.min.css" >
    <link rel="stylesheet" href="<?php echo base_url();?>public/js/vendor/bootstrap-datepicker/css/bootstrap-datepicker.standalone.min.css">
    <link rel="stylesheet" href="<?php echo base_url();?>public/css/jquery.timepicker.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="<?php echo base_url();?>public/js/vendor/select2/select2.min.css">

    <style type="text/css">
        .thumbnail {
            margin:10px;
        }

        .lang-name {
            margin-left:42px;
        }

        .upimg {
            cursor: pointer;
        }

    </style>
</head>
<body>
<div id="msg-tip">

</div>
<div class="content_wrapper">
    <div class="container-fluid">
        <aside>
            <form class="form-horizontal" role="form" method="post" enctype="multipart/form-data"  id="form" action="#" style="margin-top: 20px">
                <header><i class="fa fa-fw fa-file"></i>登录弹框配置</header>
                <section>
                    <div class="container-fluid">
                        <div class="row">
                            <div class="col-sm-12">
                                <button type="button" class="btn btn-success" id="submitBtn">提交</button>
                            </div>
                        </div>
                    </div>
                    <div class="container-fluid">
                        <?php foreach ($list as $key => $vl) { ?>
                            <div class="row" style="border: 1px solid #CCC;margin:10px 5px;padding: 5px 0;">
                                <div class="form-group" >
                                    <label class="col-sm-1 control-label">弹框ID</label>
                                    <div class="col-sm-1">
                                        <input type="text" class="form-control" readonly name="config[<?php echo $vl['id'];?>][id]" value="<?php echo $vl['id'];?>">
                                    </div>
                                    <label class="col-sm-1 control-label">名称</label>
                                    <div class="col-sm-1">
                                        <input type="text" class="form-control"  name="config[<?php echo $vl['id'];?>][name]" value="<?php echo $vl['name'];?>">
                                    </div>
                                    <label class="col-sm-1 control-label">说明</label>
                                    <div class="col-sm-2">
                                        <input type="text" class="form-control"  name="config[<?php echo $vl['id'];?>][desc]" value="<?php echo $vl['desc'];?>">
                                    </div>
                                    <label class="col-sm-1 control-label">排序</label>
                                    <div class="col-sm-1">
                                        <input type="text" class="form-control"  name="config[<?php echo $vl['id'];?>][sort]" value="<?php echo $vl['sort'];?>">
                                    </div>
                                    <label class="col-sm-1 control-label">状态</label>
                                    <div class="col-sm-1">
                                        <select class="form-control" name="config[<?php echo $vl['id'];?>][status]"">
                                            <option value="0" <?php if($vl['status'] == 0) echo 'selected'; ?>>关</option>
                                            <option value="1" <?php if($vl['status'] == 1) echo 'selected'; ?>>开</option>
                                        </select>
                                    </div>
                                    <label class="col-sm-1 control-label">主题资源目录</label>
                                    <div class="col-sm-2">
                                        <input type="text" class="form-control"  name="config[<?php echo $vl['id'];?>][thematic]" value="<?php echo $vl['thematic'];?>">
                                    </div>
                                </div>
                            </div>
                        <?php } ?>
                    </div>
                </section>
            </form>
        </aside>
    </div>
</div>
</body>

<script>
    $(function () {
        $('#submitBtn').click(function () {
            var data = new FormData(document.getElementById("form"));
            $.ajax({
                url: rootPath + 'Config/actionLoginBulletBox',
                type: 'POST',
                data: data,
                dataType: 'json',
                contentType: false, //必须
                processData: false, //必须
                success: function (data) {
                    alert(data.msg);
                    window.location.reload();
                },
                error: function (msg) {
                    alert(data.msg);
                }
            });
        });
    });
</script>
</html>
