<link rel="stylesheet" href="<?php echo base_url(); ?>public/css/vendor/bootstrap/bootstrap-table.css">
<link rel="stylesheet" href="<?php echo base_url(); ?>public/css/vendor/bootstrap/table-fix-column.css">

<script src="<?php echo base_url(); ?>public/js/vendor/bootstrap/src/bootstrap-table.js"></script>
<script src="<?php echo base_url(); ?>public/js/vendor/bootstrap/src/table-fix-column.js"></script>
<!-- Select2 -->
<link rel="stylesheet" href="<?php echo base_url(); ?>public/js/vendor/select2/select2.min.css">
<link rel="stylesheet" href="<?php echo base_url(); ?>public/node_modules/bootstrap-select/dist/css/bootstrap-select.min.css">
<script src="<?php echo base_url(); ?>public/node_modules/bootstrap-select/dist/js/bootstrap-select.min.js"></script>

<style type="text/css">
    table {
        table-layout: fixed !important;
    }

    th {
        background: rgb(146, 208, 80);
    }

    td, th {
        max-width: 400px;
        word-wrap: break-word;
    }

    .table-hover > tbody > tr:hover {
        background-color: #c8bd6d;
    }

    input {
        width: 60px;
    }

    #roleTable tr:nth-child(5n) {
        background: rgb(198, 239, 206);
    }

    /**隔五行*/

    .fixed-table-toolbar {
        display: none;
    }

    .fileinput-button {
        position: relative;
        top: -5px;
    }

    .fileinput-button input {
        position: absolute;
        right: 0px;
        top: 0px;
        opacity: 0;
        -ms-filter: 'alpha(opacity=0)';
    }
</style>
<div class="content_wrapper">
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>社交媒体配置</header>
                    <section>
                        <div class="container-fluid">
                            <div style="margin-bottom: 10px;">
                                <button type="button" style="width: 80px;" class="btn btn-primary commitBtn" id="commitBtn">提交</button>
                            </div>
                            <form action="" id="socialMediaConf">
                                <table id="roleTable_1" class="table table-bordered table-hover roleTable" data-height="1000">
                                    <thead>
                                    <tr>
                                        <td width="100">序号</td>
                                        <td width="200">KEY</td>
                                        <td width="200">名称</td>
                                        <td width="200">顺序</td>
                                        <td>跳转链接</td>
                                    </tr>
                                    </thead>
                                    <tbody id="popWindowsConf">
                                    <?php
                                    if (is_array($list) && !empty($list)) {
                                        foreach ($list as $idx => $item) {
                                            $index = $idx + 1;
                                            echo '<tr>';
                                            echo '<td><input readonly class="form-control" value="' . $index . '"></td>';
                                            echo '<td><input readonly class="form-control" name="conf[' . $idx . '][key]" value="' . $item['key'] . '"></td>';
                                            echo '<td><input readonly class="form-control" name="conf[' . $idx . '][name]" value="' . $item['name'] . '"></td>';
                                            echo '<td><input type="number" class="form-control" name="conf[' . $idx . '][order]" value="' . $item['order'] . '"></td>';
                                            echo "<td><input class='form-control' name='conf[" . $idx . "][link]' value='" . $item['link'] . "'></td>";
                                            echo '</tr>';
                                        }
                                    }
                                    ?>
                                    </tbody>
                                </table>
                            </form>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>

<script>
    //提交表格数据
    $('.commitBtn').click(function () {
        const datas = $('#socialMediaConf').toObject();
        showLoading()
        $.ajax({
            type: 'POST',
            dataType: 'json',
            data: datas,
            url: 'config/updateSocialMedia',
            success: function (data) {
                hideLoading()
                if (data.ret == 0) {
                    window.location.reload()
                } else {
                    msgTip.messager().error(data.msg);
                }
            },
            error: function (xhr, error) {
                alert('请求失败！')
                hideLoading()
                console.log(xhr, error);
            }
        });
    });

</script>

