<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>修改活动</title>
    <!-- 最新版本的 Bootstrap 核心 CSS 文件 -->
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/js/bootstrap/bootstrap.min.css">
    <link rel="stylesheet"
          href="<?php echo base_url(); ?>public/js/vendor/bootstrap-datepicker/css/bootstrap-datepicker.standalone.min.css">
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/css/jquery.timepicker.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/js/vendor/select2/select2.min.css">
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/css/vendor/bootstrap/bootstrap-table.css">
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/css/vendor/bootstrap/table-fix-column.css">
    <link rel="stylesheet"
          href="<?php echo base_url(); ?>public/node_modules/bootstrap-select/dist/css/bootstrap-select.min.css">
    <script src="<?php echo base_url(); ?>public/node_modules/bootstrap-select/dist/js/bootstrap-select.min.js"></script>

    <style type="text/css">
        table {
            table-layout: fixed !important;
        }

        th {
            background: rgb(146, 208, 80);
        }

        td, th {
            max-width: 400px;
            word-wrap: break-word;
        }

        .table-hover > tbody > tr:hover {
            background-color: #c8bd6d;
        }

        input {
            width: 60px;
        }

        #roleTable tr:nth-child(5n) {
            background: rgb(198, 239, 206);
        }

        /**隔五行*/

        .fixed-table-toolbar {
            display: none;
        }

        .fileinput-button {
            position: relative;
            top: -5px;
        }

        .fileinput-button input {
            position: absolute;
            right: 0px;
            top: 0px;
            opacity: 0;
            -ms-filter: 'alpha(opacity=0)';
        }
    </style>
</head>

<body>
<div class="content_wrapper">
    <div id="msg-tip"></div>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>七天签到配置</header>
                    <section>
                        <div class="container-fluid">
                            <div>
                                <span id="filespanXml" class="btn btn-success fileinput-button">
                                    <span>导入</span>
                                    <input type="file" id="uploadXml">
                                </span>
                                <input type="button" style="display: none;margin-bottom: 10px;width: 80px;"
                                       class="btn btn-success" value="上传" id="uploadConfigFileBtn"/>
                                <!--                                <a type="button" href="/Export/skucoin" style="margin-bottom: 10px;width: 80px;"-->
                                <!--                                   class="btn btn-success">导出</a>-->
                            </div>

                            <div class="row">
                                <div class="col-sm-12">
                                    <div class="table-responsive ">
                                        <table id="roleTable" class="table table-bordered table-hover"
                                               data-toggle="table"
                                               data-classes="table table-hover"
                                               data-show-columns="true"
                                               data-striped="true"
                                               data-height="700">
                                            <thead>
                                            <tr>
                                                <th>ID</th>
                                                <th>活动名</th>
                                                <th>资源文件夹名</th>
                                                <th>活动开始日期</th>
                                                <th>活动结束日期</th>
                                                <th>操作</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            <?php
                                            if (is_array($list) && !empty($list)) {
                                                foreach ($list as $key => $vl) { ?>
                                                    <tr>
                                                        <td><?php echo $vl['id']; ?></td>
                                                        <td><?php echo $vl['name']; ?></td>
                                                        <td><?php echo $vl['resource']; ?></td>
                                                        <td><?php echo $vl['start_at']; ?></td>
                                                        <td><?php echo $vl['end_at']; ?></td>
                                                        <td>
                                                            <button type="button" class="btn btn-primary active"
                                                                    onclick="openEdit(this)"
                                                                    data-toggle="modal"
                                                                    data-target="#goodsEditBtn"
                                                                    data-value='<?php echo json_encode($vl); ?>'>编辑
                                                            </button>
                                                        </td>
                                                    </tr>
                                                <?php }
                                            } else { ?>
                                                <tr>
                                                    <td colspan="6">暂无数据</td>
                                                </tr>
                                            <?php } ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>
</body>

<div class="modal fade" id="goodsEditBtn" style="overflow-y: auto" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog" style="width: 60%">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span
                            class="sr-only">Close</span></button>
                <h4 class="modal-title" id="myModalLabel">修改配置</h4>
            </div>
            <form class="form-horizontal" method="post" id="goodForm" action="">
                <div class="modal-body">
                    <div class="form-group">
                        <label class="col-sm-2 control-label">ID:</label>
                        <div class="col-sm-2">
                            <input type="text" readonly class="form-control" name="id">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-2 control-label">活动名:</label>
                        <div class="col-sm-3">
                            <input type="text" class="form-control" name="name">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-2 control-label">资源文件夹名:</label>
                        <div class="col-sm-3">
                            <input type="text" class="form-control" name="resource">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-2 control-label">活动开始日期:</label>
                        <div class="col-sm-3">
                            <input id="start_at_date" type="text" class="form-control" name="start_at">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-2 control-label">活动结束日期:</label>
                        <div class="col-sm-3">
                            <input id="end_at_date" type="text" class="form-control" name="end_at">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-2 control-label">奖励配置:</label>
                        <div id="dailyFreeConfList" style="margin-top: 30px"></div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">关闭</button>
                    <button type="button" class="btn btn-primary" id="goodsSubmitBtn">提交</button>
                </div>
            </form>
        </div>
    </div>
</div>

<script src="<?php echo base_url(); ?>public/js/common.js"></script>
<script src="<?php echo base_url(); ?>public/js/vendor/bootstrap/src/bootstrap-table.js"></script>
<script src="<?php echo base_url(); ?>public/js/vendor/bootstrap/src/table-fix-column.js"></script>

<script>
    var msgTip = $('#msg-tip');

    $(function () {
        $('#goodsSubmitBtn').click(function () {
            const data = $('#goodForm').toObject()

            for (const stageIdx in data.stages) {
                for (const stageKey in data.stages[stageIdx].stages) {
                    data.stages[stageIdx].stages[stageKey].prize = $(`#DailyFreeRewardInfo_${stageIdx}_${stageKey}`).find(`.propsRewardsTag`).data("value")
                }
            }
            $.ajax({
                url: rootPath + 'newShop/dailyFreeRewardUpdate',
                type: 'POST',
                data: data,
                dataType: 'json',
                success: function (data) {
                    alert(data.msg);

                    if (data.ret == 0) {
                        window.location.reload();
                    }
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

        //导入配置
        $("#uploadConfigFileBtn").click(function () {
            var formData = new FormData();
            formData.append("file", document.getElementById("uploadXml").files[0]);

            $.ajax({
                type: "POST", // 数据提交类型
                url: "newShop/dailyFreeRewardImport", // 发送地址
                data: formData, //发送数据
                async: true, // 是否异步
                processData: false, //processData 默认为false，当设置为true的时候,jquery ajax 提交的时候不会序列化 data，而是直接使用data
                contentType: false, //
                success: function (data) { // 成功回调
                    data = JSON.parse(data);
                    if (data.ret == 0) {
                        // console.log(data)
                        msgTip.messager().success(data.msg);
                        window.location.reload();
                    } else {
                        // msgTip = $('#msg-tip');
                        alert(data.msg);
                        // window.location.reload();
                    }
                }
            });
        });

        $("#filespanXml").on("change", "input[type='file']", function () {
            var filePath = $(this).val();
            //如果仅上传图片 if(filePath.indexOf("jpg") != -1 || filePath.indexOf("png") != -1) {
            if (filePath) {
                $('#filespanXml').hide();
                $('#uploadConfigFileBtn').show();
            } else {
                return false
            }
        });

    });

    function openEdit(even) {
        let formData = $(even).data('value')

        $.ajax({
            type: "POST", // 数据提交类型
            url: "newShop/dailyFreeRewardDetail",
            data: {id: formData.id},
            async: false,
            success: function (data) {
                data = JSON.parse(data);
                if (Number(data.ret) !== 0) {
                    alert(data.msg);
                } else {
                    formData['stages'] = data.data.list
                }
            }
        });
        for (let key in formData) {
            if (formData.hasOwnProperty(key)) {
                $("[name=" + key + "]").val(formData[key]);
            }
        }

        $("#dailyFreeConfList").empty();
        initDailyFreeWrap();

        $.each(formData['stages'], (lvIdx, item) => {
            $('#addDailyFreeLvWrapBtn').click()
            $(`input[name="stages[${lvIdx}][lvStart]"]`).val(item.lvStart)
            $(`input[name="stages[${lvIdx}][lvEnd]"]`).val(item.lvEnd)

            $.each(item.stages, (stageKey, rewardItem) => {
                $('.addDailyFreeRewardTrBtn:last').click()

                $('.propsRewardsTag:last').data("value", rewardItem.prize)
            })
        })

        propsJs.initTag('propsRewardsTag')

        laydate.render({
            elem: '#start_at_date',
            type: 'date',
            format: 'yyyy-MM-dd'
        });
        laydate.render({
            elem: '#end_at_date',
            type: 'date',
            format: 'yyyy-MM-dd'
        });
    }

    function initDailyFreeWrap() {
        DailyFreeLvCnt = 0;
        DailyFreeRewardStages = {}

        var html = DailyFreeWrapStageTable();
        $("#dailyFreeConfList").append(html);
    }

    function DailyFreeWrapStageTable() {
        return `
         <div class="text-center" style="margin:5px;padding:5px;border:solid 1px lightgray;">
            <button style="margin-top: 20px" id="addDailyFreeLvWrapBtn" class="btn btn-primary" onclick="addDailyFreeLvWrap(this)" type="button">添加等级区间</button>
            <button style="margin-top: 20px" class="btn btn-danger" onclick="delDailyFreeLvWrap()" type="button">删除等级区间</button>
         </div>`
    }

    function addDailyFreeLvWrap(obj) {
        var lvIdx = ++DailyFreeLvCnt

        DailyFreeRewardStages[lvIdx] = 0
        var html = `
        <div class="DailyFreeLvWrap" id="DailyFreelvWrap_${lvIdx}" data-idx="${lvIdx}" style="margin:10px;padding:5px;border:solid 1px goldenrod;">
            <table class="table table-bordered" >
                <thead>
                    <tr>
                        <td colspan="3">
                             <div class="form-group">
                                <label class="col-sm-2 control-label m-b">等级区间: </label>
                                <div class="col-sm-3 input-group">
                                    <input type="text" style="text-align: center" class="form-control" name="stages[${lvIdx}][lvStart]" value="0">
                                    <span class="input-group-addon">-</span>
                                    <input type="text" style="text-align: center" class="form-control" name="stages[${lvIdx}][lvEnd]" value="0">
                                </div>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <th>天数</th>
                        <th>奖励</th>
                        <th width="120">奖励设置</th>
                    </tr>
                </thead>
                <tbody id="DailyFreeRewardBody_${lvIdx}"></tbody>
                <tr>
                    <td colspan="3">
                        <div class="text-center" style="margin-top: 20px">
                            <botton class="btn btn-primary addDailyFreeRewardTrBtn" onclick="addDailyFreeRewardTr(this)">添加</botton>
                            <botton class="btn btn-danger del-tr" onclick="delDailyFreeRewardTr(this)">删除</botton>
                        </div>
                    </td>
                </tr>
           </table>
        </div>`
        $(obj).before(html)
    }

    function delDailyFreeLvWrap(obj) {

        if (DailyFreeLvCnt < 1) {
            return;
        }
        $('#DailyFreelvWrap_' + DailyFreeLvCnt).remove();
        DailyFreeLvCnt--;
    }

    function addDailyFreeRewardTr(obj) {
        var lvIdx = $(obj).parents('.DailyFreeLvWrap').data('idx')
        var rewardStage = ++DailyFreeRewardStages[lvIdx]
        var rewardKey = lvIdx + '_' + rewardStage

        var prize = '[]';
        var html = `
        <tr class="DailyFreeRewardInfoTr" id="DailyFreeRewardInfo_${rewardKey}" data-idx="${rewardStage}">
            <td><input readonly name="stages[${lvIdx}][stages][${rewardStage}][day]" type="number"  class="form-control" value="${rewardStage}"></td>
            <td class="propsRewardsTag" data-value='${prize}'></td>
            <td><button type="button" class="btn btn-outline btn-success" onclick="propsJs.initEdit(this, 'propsRewardsTag')">奖励配置</button></td>
        </tr>`;

        $('#DailyFreeRewardBody_' + lvIdx).append(html)
    }

    function delDailyFreeRewardTr(obj) {
        var lvIdx = $(obj).parents('.DailyFreeLvWrap').data('idx')
        var rewardKey = lvIdx + '_' + DailyFreeRewardStages[lvIdx]

        if (DailyFreeRewardStages[lvIdx] < 1) return;
        $('#DailyFreeRewardInfo_' + rewardKey).remove()
        DailyFreeRewardStages[lvIdx]--
    }

</script>
