let hiddenTreasuresLvCnt = 0
let hiddenTreasuresSpinsStages = {}
let hiddenTreasuresShushuStages = {}
let hiddenTreasuresProbStages = {}
let hiddenTreasuresOutsideRewardStages = {}
let hiddenTreasuresInsideRewardStages = {}
let hiddenTreasuresTaskStages = {}
let hiddenTreasuresScoreStages = {}
let hiddenTreasuresLowStages = {}
let hiddenTreasuresLowStagesGrids = {}
let hiddenTreasuresHighStages = {}
let hiddenTreasuresHighStagesGrids = {}
let hiddenTreasuresTaskTypeOptionHtml = ""


function initRewardHiddenTreasures() {
    getActBasicConfig(act_type).then(()=>{
        let html = hiddenTreasuresStageTable();
        $("#reward_info").html(html);

        // 奖励回写
        if (!reward_conf || !activity_extra_data) {
            return
        }

        reward_conf.baseConf && $.each( reward_conf.baseConf,(field,  value)=>{
            $(`input[name="hiddenTreasuresConf[baseConf][${field}]"]`).val(value)
        })

        reward_conf.stageConf && $.each(reward_conf.stageConf, function (i, o) {
            $('#addHiddenTreasuresLvWrapBtn').click()
            $(`input[name="hiddenTreasuresConf[stageConf][${i}][lvStart]"]`).val(o.lvStart)
            $(`input[name="hiddenTreasuresConf[stageConf][${i}][lvEnd]"]`).val(o.lvEnd)

            $(`#hiddenTreasuresLvWrap_${i}`).find(`button`).remove()
            $(`#hiddenTreasuresLvWrap_${i}`).append(`<button class="btn btn-primary asyncLoadConfigBtn" style="" type="button" onclick="asyncLoadHiddenTreasuresConfig(${i})">加载配置</button>`)
            $('#submitBtn').hide();

        })
        $('.select2').select2({})
    })


}

function changeTypeToHiddenTreasures() {
    hiddenTreasuresLvCnt = 0
    hiddenTreasuresSpinsStages = {}
    hiddenTreasuresShushuStages = {}
    hiddenTreasuresProbStages = {}
    hiddenTreasuresOutsideRewardStages = {}
    hiddenTreasuresInsideRewardStages = {}
    hiddenTreasuresTaskStages = {}

    getActBasicConfig(act_type).then(()=>{
        let html = hiddenTreasuresStageTable();
        $("#reward_info").html(html);
    })
}

function hiddenTreasuresStageTable() {
    return `
        <div class="form-group">
            <h4 style="font-weight: bold" class="text-left">基础配置*:</h4>
            <label class="col-xs-1 control-label">积分基础值:</label>
            <div class="col-sm-1"><input type="number" name="hiddenTreasuresConf[baseConf][getScore]" value="" class="form-control"></div>
        </div>
        <div class="form-group text-center">
            <h4 style="font-weight: bold" class="text-left">阶段奖励配置*:</h4>
            <button class="btn btn-primary" id="addHiddenTreasuresLvWrapBtn" onclick="addHiddenTreasuresLvWrap(this)" type="button">添加等级层级</button>
            <button class="btn btn-white"   id="delHiddenTreasuresLvWrapBtn" onclick="delHiddenTreasuresLvWrap()" type="button">删除等级层级</button>
        </div>
        <hr style=" height:2px;border:none;border-top:2px dotted #0b0;">
    `;
}

function addHiddenTreasuresLvWrap(obj) {
    hiddenTreasuresLvCnt++
    hiddenTreasuresSpinsStages[hiddenTreasuresLvCnt] = 0

    let html = `
        <div class="hiddenTreasuresLvWrap table-border-blue" id="hiddenTreasuresLvWrap_${hiddenTreasuresLvCnt}" data-idx="${hiddenTreasuresLvCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="hiddenTreasuresConf[stageConf][${hiddenTreasuresLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="hiddenTreasuresConf[stageConf][${hiddenTreasuresLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <button type="button" class="btn btn-primary addHiddenTreasuresSpinsWrapBtn" onclick="addHiddenTreasuresSpinsWrap(this)">添加体力层级</button>
            <button type="button" class="btn btn-danger del-tr delHiddenTreasuresSpinsWrapBtn" onclick="delHiddenTreasuresSpinsWrap(this)">删除体力层级</button>
        </div>
`

    $(obj).before(html)
    $('.select2').select2({})
}

function addHiddenTreasuresSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.hiddenTreasuresLvWrap').data('idx')
    let hiddenTreasuresSpinsCnt = ++hiddenTreasuresSpinsStages[lvIdx]
    let spinsIdx = `${lvIdx}_${hiddenTreasuresSpinsCnt}`
    hiddenTreasuresShushuStages[spinsIdx] = 0

    let html = `
        <div class="hiddenTreasuresSpinsWrap table-border-blue" id="hiddenTreasuresSpinsWrap_${spinsIdx}" data-idx="${hiddenTreasuresSpinsCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">体力区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${hiddenTreasuresSpinsCnt}][spinsStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${hiddenTreasuresSpinsCnt}][spinsEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <button type="button" class="btn btn-primary addHiddenTreasuresShushuWrapBtn" onclick="addHiddenTreasuresShushuWrap(this)">添加数数分组层级</button>
            <button type="button" class="btn btn-danger del-tr delHiddenTreasuresShushuWrapBtn" onclick="delHiddenTreasuresShushuWrap(this)">删除数数分组层级</button>
        </div>
    `

    $(obj).before(html)
    $('.select2').select2({})
}


function addHiddenTreasuresShushuWrap(obj) {
    let lvIdx = $(obj).parents('.hiddenTreasuresLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.hiddenTreasuresSpinsWrap').data('idx')

    let ssIdx = ++hiddenTreasuresShushuStages[`${lvIdx}_${spinsIdx}`]

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    hiddenTreasuresProbStages[rewardIdx] = 0
    hiddenTreasuresOutsideRewardStages[rewardIdx] = 0
    hiddenTreasuresInsideRewardStages[rewardIdx] = 0
    hiddenTreasuresTaskStages[rewardIdx] = 0
    hiddenTreasuresScoreStages[rewardIdx] = 0
    hiddenTreasuresLowStages[rewardIdx] = 0
    hiddenTreasuresHighStages[rewardIdx] = 0
    hiddenTreasuresLowStagesGrids[rewardIdx] = 0

    let arr = JSON.parse($hideSSGroup);

    let optionsHtml = ''
    $.each(arr, function (i, o) {
        optionsHtml += '<option value="' + i + '">' + o + '</option>'
    });

    let html = `
        <div class="hiddenTreasuresShushuWrap table-border-blue" id="hiddenTreasuresShushuWrap_${rewardIdx}" data-idx="${ssIdx}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">数数分组 </label>
                <div class="col-sm-3 input-group"> 
                    <select class=" select2" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][shushu][]"  multiple  style="min-width: 100%"> 
                        ${optionsHtml}
                    </select> 
                </div>
            </div> 
            <hr style="border:solid 1px black;">
            
                   
<!--            积分概率配置-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">概率配置: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">#</th> 
                            <th width="100px">倍率</th>
                            <th width="100px">消耗体力值</th> 
                            <th>概率</th>
                        </tr>
                    </thead> 
                    <tbody id="hiddenTreasuresProbBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="4">
                            <div class="text-center">
                                <button type="button" class="btn btn-primary addHiddenTreasuresProbTrBtn" onclick="addHiddenTreasuresProbTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>
                                <button type="button" class="btn btn-danger del-tr" onclick="delHiddenTreasuresProbTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
<!--            积分获取代币配置-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">积分获取代币配置: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="100px">阶段</th>
                            <th>积分</th> 
                            <th>代币数</th> 
                        </tr>
                    </thead> 
                    <tbody id="hiddenTreasuresScoreBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="4">
                            <div class="text-center">
                                <button type="button" class="btn btn-primary addHiddenTreasuresProbTrBtn" onclick="addHiddenTreasuresScoreTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>
                                <button type="button" class="btn btn-danger del-tr" onclick="delHiddenTreasuresScoreTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
<!--            普通场-->
            
                <div class="table-border-yellow hiddenTreasuresLowStageWrap">
                    <div class="form-group">
                        <label class="col-sm-1 control-label m-b">宝藏配置: </label>
            
                    </div>
                    <table class="table table-bordered" > 
                        <thead>
                            <tr>
                                <th width="120">#</th> 
                                <th>格子总数</th> 
                                <th>有效步数</th> 
                                <th>操作</th> 
                                <th>奖励</th> 
                            </tr>
                        </thead> 
                        <tbody id="hiddenTreasuresLowStageBody_${rewardIdx}"> </tbody>
                        <tr>
                            <td colspan="5">
                                <div class="text-center">
                                    <button type="button" class="btn btn-primary " onclick="addHiddenTreasuresLowStageTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>
                                    <button type="button" class="btn btn-danger "  onclick="delHiddenTreasuresLowStageTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> 
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
             
        
<!--            进度条1-->
<!--            <div class="table-border-yellow">-->
<!--                <div class="form-group">-->
<!--                    <label class="col-sm-1 control-label m-b">进度条1: </label>-->
<!--                </div>-->
<!--                <table class="table table-bordered" > -->
<!--                    <thead>-->
<!--                        <tr>-->
<!--                            <th width="120">阶段</th> -->
<!--                            <th width="100px">阶段值</th> -->
<!--                            <th width="100px">奖励设置</th>-->
<!--                            <th>奖品</th> -->
<!--                        </tr>-->
<!--                    </thead> -->
<!--                    <tbody id="hiddenTreasuresOutsideRewardBody_${rewardIdx}"> </tbody>-->
<!--                    <tr>-->
<!--                        <td colspan="5">-->
<!--                            <div class="text-center">-->
<!--                                <button type="button" class="btn btn-primary addHiddenTreasuresOutsideRewardTrBtn" onclick="addHiddenTreasuresOutsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>-->
<!--                                <button type="button" class="btn btn-danger del-tr" onclick="delHiddenTreasuresOutsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> -->
<!--                            </div>-->
<!--                        </td>-->
<!--                    </tr>-->
<!--                </table>-->
<!--            </div>-->
<!--            -->
<!--&lt;!&ndash;            进度条2&ndash;&gt;-->
<!--            <div class="table-border-yellow">-->
<!--                <div class="form-group">-->
<!--                    <label class="col-sm-1 control-label m-b">进度条2: </label>-->
<!--                </div>-->
<!--                <table class="table table-bordered" > -->
<!--                    <thead>-->
<!--                        <tr>-->
<!--                            <th width="120">阶段</th> -->
<!--                            <th width="100px">阶段值</th> -->
<!--                            <th width="100px">奖励设置</th>-->
<!--                            <th>奖品</th> -->
<!--                        </tr>-->
<!--                    </thead> -->
<!--                    <tbody id="hiddenTreasuresInsideRewardBody_${rewardIdx}"> </tbody>-->
<!--                    <tr>-->
<!--                        <td colspan="5">-->
<!--                            <div class="text-center">-->
<!--                                <button type="button" class="btn btn-primary addHiddenTreasuresInsideRewardTrBtn" onclick="addHiddenTreasuresInsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>-->
<!--                                <button type="button" class="btn btn-danger del-tr" onclick="delHiddenTreasuresInsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> -->
<!--                            </div>-->
<!--                        </td>-->
<!--                    </tr>-->
<!--                </table>-->
<!--            </div>-->
<!--            -->
<!--        </div>-->
`;

    $(obj).before(html)
    $(`#hiddenTreasuresShushuWrap_${rewardIdx}`).append(noTokenAlert(rewardIdx, 135))
    $('.select2').select2({})
}


function delHiddenTreasuresLvWrap() {
    if (hiddenTreasuresLvCnt < 1) {
        return;
    }
    $('#hiddenTreasuresLvWrap_' + hiddenTreasuresLvCnt).remove();
    hiddenTreasuresLvCnt--;
}

function delHiddenTreasuresSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.hiddenTreasuresLvWrap').data('idx')

    if (hiddenTreasuresSpinsStages[lvIdx] < 1) return
    $(obj).parents('.hiddenTreasuresLvWrap').find('.hiddenTreasuresSpinsWrap:last').remove()
    hiddenTreasuresSpinsStages[lvIdx]--
}

function delHiddenTreasuresShushuWrap(obj) {
    let lvIdx = $(obj).parents('.hiddenTreasuresLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.hiddenTreasuresSpinsWrap').data('idx')

    if (hiddenTreasuresShushuStages[`${lvIdx}_${spinsIdx}`] < 1) return
    $(obj).parents('.hiddenTreasuresSpinsWrap').find('.hiddenTreasuresShushuWrap:last').remove()
    hiddenTreasuresShushuStages[`${lvIdx}_${spinsIdx}`]--
}

function addHiddenTreasuresProbTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = hiddenTreasuresProbStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="hiddenTreasuresProbInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input style="width: 120px" type="number" class="form-control" readonly  value="${rIdx + 1}">
            </td> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][bet]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][costSpin]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][prob]" value="0">
            </td> 
        </tr> 
    `;

    $('#hiddenTreasuresProbBody_' + lsrIdx).append(html)
}
function delHiddenTreasuresProbTr(lvIdx, spinsIdx, ssIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    hiddenTreasuresProbStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + hiddenTreasuresProbStages[rewardIdx]

    if (hiddenTreasuresProbStages[rewardIdx] < 0) return;
    $('#hiddenTreasuresProbInfo_' + rewardKey).remove()
}

function addHiddenTreasuresScoreTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = hiddenTreasuresScoreStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="hiddenTreasuresScoreInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][tokenRewardConf][${rIdx}][stageId]" readonly  value="${rIdx + 1}"  style="width: 120px" >
            </td> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][tokenRewardConf][${rIdx}][dst]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][tokenRewardConf][${rIdx}][tokens]" value="0">
            </td> 
        </tr> 
    `;

    $('#hiddenTreasuresScoreBody_' + lsrIdx).append(html)
}
function delHiddenTreasuresScoreTr(lvIdx, spinsIdx, ssIdx) {
    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    hiddenTreasuresScoreStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + hiddenTreasuresScoreStages[rewardIdx]

    if (hiddenTreasuresScoreStages[rewardIdx] < 0) return;
    $('#hiddenTreasuresScoreInfo_' + rewardKey).remove()
}

// 进度条1
function addHiddenTreasuresOutsideRewardTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = hiddenTreasuresOutsideRewardStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="hiddenTreasuresOutsideRewardInfo_${rewardKey}" class="commonStageRewardTr" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfA][${rIdx}][stageId]" value="${rIdx+1}" readonly>
            </td> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfA][${rIdx}][dst]" value="0">
            </td> 
            <td>
                <input type="hidden" class="prizeInput" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfA][${rIdx}][prize]" value="{}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow"></td>
        </tr> 
    `;

    $('#hiddenTreasuresOutsideRewardBody_' + lsrIdx).append(html)
}
function delHiddenTreasuresOutsideRewardTr(lvIdx, spinsIdx, ssIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    hiddenTreasuresOutsideRewardStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + hiddenTreasuresOutsideRewardStages[rewardIdx]

    if (hiddenTreasuresOutsideRewardStages[rewardIdx] < 0) return;
    $('#hiddenTreasuresOutsideRewardInfo_' + rewardKey).remove()
}


function addHiddenTreasuresLowStageTr(lvIdx, spinsIdx, ssIdx){
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = hiddenTreasuresLowStagesGrids[rewardKey]++
    let HiddenTreasuresGridsTypeOptionHtml = '<option value="0">格子数</option>'
    let lsrIdx = `${rewardKey}_${rIdx}`
    $.each(actBasicConf[act_type], function(i,o){
        HiddenTreasuresGridsTypeOptionHtml += `<option value="${i}">${i}</option>`
    })
    let html = `
        <tr id="hiddenTreasuresLowGridInfo_${lsrIdx}" data-idx="${rIdx}" class="HiddenTreasuresGridsTr commonStageRewardTr"> 
            <td>
                <input type="number" class="form-control" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][maps][${rIdx}][stage]" readonly value="${rIdx + 1}">
            </td> 
            <td>
                <select class="form-control" onchange="HiddenTreasuresGridsTypeChanged(this)" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][maps][${rIdx}][mapSize]">
                    ${HiddenTreasuresGridsTypeOptionHtml}
                </select>
            </td> 
            <td>
                <select class="form-control HiddenTreasuresEffectiveSteps" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][maps][${rIdx}][steps]">
                </select>
            </td> 
            <td>
                <input type="hidden" class="prizeInput" name="hiddenTreasuresConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][maps][${rIdx}][prize]" value="{}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow"></td>
        </tr> 
    `;
    $('#hiddenTreasuresLowStageBody_' + rewardKey).append(html)
}
function delHiddenTreasuresLowStageTr(lvIdx, spinsIdx, ssIdx){

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = hiddenTreasuresLowStagesGrids[rewardKey]-1
    let lsrIdx = `${rewardKey}_${rIdx}`
    console.log($(`#hiddenTreasuresLowGridInfo_${lsrIdx}`));
    if( $(`#hiddenTreasuresLowGridInfo_${lsrIdx}`).length > 0 ){
        hiddenTreasuresLowStagesGrids[rewardKey]--
        $(`#hiddenTreasuresLowGridInfo_${lsrIdx}`).remove()
    }
}


asyncLoadHiddenTreasuresConfig = (i)=>{
    showLoading()
    console.log(reward_conf.stageConf[i]);
    $(`#hiddenTreasuresLvWrap_${i}`).find(`.asyncLoadConfigBtn`).remove()
    $(`#hiddenTreasuresLvWrap_${i}`).append(`
            <button type="button" class="btn btn-primary addHiddenTreasuresSpinsWrapBtn" onclick="addHiddenTreasuresSpinsWrap(this)">添加体力层级</button>
            <button type="button" class="btn btn-danger del-tr delHiddenTreasuresSpinsWrapBtn" onclick="delHiddenTreasuresSpinsWrap(this)">删除体力层级</button>`)
    reward_conf.stageConf[i].stages && $.each(reward_conf.stageConf[i].stages, function (i1, o1) {
        $('.addHiddenTreasuresSpinsWrapBtn:last').click()
        $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][spinsStart]"]`).val(o1.spinsStart)
        $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][spinsEnd]"]`).val(o1.spinsEnd)
        $.each(o1.stages, function (i2, o2) {
            $('.addHiddenTreasuresShushuWrapBtn:last').click()
            $(`select[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][shushu][]"]`).val(o2.shushu)

            o2['betConf'] && $.each(o2['betConf'], function (k, v) {
                addHiddenTreasuresProbTr(i, i1, i2)
                $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][bet]"]`).val(v.bet)
                $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][costSpin]"]`).val(v.costSpin)
                $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][prob]"]`).val(v.prob)
            })

            o2['tokenRewardConf'] && $.each(o2['tokenRewardConf'], function (k, v) {
                addHiddenTreasuresScoreTr(i, i1, i2)
                $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][tokenRewardConf][${k}][stageId]"]`).val(v.stageId)
                $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][tokenRewardConf][${k}][dst]"]`).val(v.dst)
                $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][tokenRewardConf][${k}][tokens]"]`).val(v.tokens)
            })


            o2.maps && $.each(o2.maps,(ig, og)=>{
                addHiddenTreasuresLowStageTr(i, i1, i2)
                let prizeInput = $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][maps][${ig}][prize]"]`)
                prizeInput.val(escape(JSON.stringify(og.prize)))
                prizeInput.parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(og.prize))
                $(`input[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][maps][${ig}][stage]"]`).val(og.stage)
                $(`select[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][maps][${ig}][mapSize]"]`).val(og.mapSize)

                HiddenTreasuresGridsTypeChanged($(`select[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][maps][${ig}][mapSize]"]`))
                $(`select[name="hiddenTreasuresConf[stageConf][${i}][stages][${i1}][stages][${i2}][maps][${ig}][steps]"]`).val(og.steps)
            })

            renderNotokenAlert(`${i}_${i1}_${i2}`, reward_pro)
        })
    })

    $('.select2').select2({})
    updateSubmitBtnStatus()
    hideLoading()
}

HiddenTreasuresGridsTypeChanged = (obj)=>{
    let gridType = $(obj).val()
    let stepOptionHtml = '<option value="0">有效步数</option>'
    actBasicConf[act_type][gridType] && $.each(actBasicConf[act_type][gridType], (i, step)=>{
        stepOptionHtml += `<option value="${step}">${step}</option>`
    })
    $(obj).parents('.commonStageRewardTr').find('.HiddenTreasuresEffectiveSteps').empty().append(stepOptionHtml)
}