let KingOfCardsLvCnt = 0;
let KingOfCardsSpinsStages = {}
let KingOfCardsProgressStages = {}

function initReward_kingOfCards(type) {
    console.log('init ' + type)
    changetypeTo_kingOfCards()

    // 奖励回写
    console.log('reward_info ', reward_info)
    if (!reward_info) {
        return
    }

    $.each(reward_info, function (lvStage, lvItem) {
        $('#addKingOfCardsLvWrapBtn').click()
        $(`input[name="kingOfCardsConfig[${lvStage}][lvStart]"]`).val(lvItem.lvStart)
        $(`input[name="kingOfCardsConfig[${lvStage}][lvEnd]"]`).val(lvItem.lvEnd)

        $.each(lvItem.stages, function (spinsStage, spinsItem) {
            $('.addKingOfCardsSpinsWrapBtn:last').click()
            $(`input[name="kingOfCardsConfig[${lvStage}][stages][${spinsStage}][spinsStart]"]`).val(spinsItem.spinsStart)
            $(`input[name="kingOfCardsConfig[${lvStage}][stages][${spinsStage}][spinsEnd]"]`).val(spinsItem.spinsEnd)

            // 进度奖励
            spinsItem.progress && $.each(spinsItem.progress, function (rewardIndex, rewardItem) {
                $('.addKingOfCardsProgressTrBtn:last').click()

                $(`input[name="kingOfCardsConfig[${lvStage}][stages][${spinsStage}][progress][${rewardIndex}][target]"]`).val(rewardItem.target)
                $(`input[name="kingOfCardsConfig[${lvStage}][stages][${spinsStage}][progress][${rewardIndex}][prize]"]`).val(escape(JSON.stringify(rewardItem.prize)))

                let prizeHtml = ''
                $.each(rewardItem.prize, function (i, prize) {
                    prizeHtml += chestPropsHtml(prize)
                })
                $('.prizeShow:last').html(prizeHtml)
            })
        })
    })
}

function changetypeTo_kingOfCards() {
    $("#reward_info").empty();
    initKingOfCardsWrap();
}

function initKingOfCardsWrap() {
    KingOfCardsLvCnt = 0;
    KingOfCardsSpinsStages = {}
    KingOfCardsProgressStages = {}

    let html = KingOfCardsWrapStageTable();
    $("#reward_info").append(html);
}

function KingOfCardsWrapStageTable() {
    return `
         <div class="text-right" style="margin:5px;padding:5px;border:solid 1px lightgray;">
            <button style="margin-top: 20px" id="addKingOfCardsLvWrapBtn" class="btn btn-primary" onclick="addKingOfCardsLvWrap(this)" type="button">添加等级区间</button>
            <button style="margin-top: 20px" class="btn btn-danger" onclick="delKingOfCardsLvWrap()" type="button">删除等级区间</button>
         </div>
        `
}

function addKingOfCardsLvWrap(obj) {
    KingOfCardsLvCnt++
    KingOfCardsSpinsStages[KingOfCardsLvCnt] = 0
    let html = `
        <div class="form-group text-left KingOfCardsLvWrap" id="KingOfCardsLvWrap_${KingOfCardsLvCnt}" data-idx="${KingOfCardsLvCnt}" style="margin:10px;padding:5px;border:solid 1px black;">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="kingOfCardsConfig[${KingOfCardsLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="kingOfCardsConfig[${KingOfCardsLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton style="margin-top: 10px" class="btn btn-primary  addKingOfCardsSpinsWrapBtn" onclick="addKingOfCardsSpinsWrap( this)">添加体力分组层级</botton>
            <botton style="margin-top: 10px" class="btn btn-danger del-tr delKingOfCardsSpinsWrapBtn" onclick="delKingOfCardsSpinsWrap( this)">删除体力分组层级</botton>
        </div>
        `
    $(obj).before(html)
}

function delKingOfCardsLvWrap() {
    if (KingOfCardsLvCnt < 1) {
        return;
    }
    $('#KingOfCardsLvWrap_' + KingOfCardsLvCnt).remove();
    KingOfCardsLvCnt--;
}

function addKingOfCardsSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsLvWrap').data('idx')
    let spinsCnt = ++KingOfCardsSpinsStages[lvIdx]
    let rewardIdx = `${lvIdx}_${spinsCnt}`

    KingOfCardsProgressStages[rewardIdx] = 0

    let html = `
        <div class="KingOfCardsSpinsWrap" id="KingOfCardsSpinsWrap_${rewardIdx}" data-idx="${spinsCnt}" style="margin:10px;padding:5px;border:solid 1px goldenrod;">
            <table class="table table-bordered">
                <thead>
                    <tr><td colspan="4">
                         <div class="form-group">
                            <label class="col-sm-1 control-label m-b">体力区间: </label>
                            <div class="col-sm-3 input-group">
                                <input type="text" style="text-align: center" class="form-control" name="kingOfCardsConfig[${lvIdx}][stages][${spinsCnt}][spinsStart]" value="0">
                                <span class="input-group-addon">-</span>
                                <input type="text" style="text-align: center" class="form-control" name="kingOfCardsConfig[${lvIdx}][stages][${spinsCnt}][spinsEnd]" value="0">
                            </div>
                        </div>
                    </td></tr>
                    <tr>
                        <th width="120">阶段</th>
                        <th width="140">阶段值</th>
                        <th>奖励</th>
                        <th width="140">奖励设置</th>
                    </tr>
                </thead>
                <tbody id="KingOfCardsProgressBody_${rewardIdx}"></tbody>
                <tr>
                    <td colspan="7">
                        <div class="text-center" style="margin-top: 20px">
                            <botton class="btn btn-primary addKingOfCardsProgressTrBtn" onclick="addKingOfCardsProgressTr(this)">添加阶段奖励</botton>
                            <botton class="btn btn-danger del-tr" onclick="delKingOfCardsProgressTr(this)">删除</botton>
                        </div>
                    </td>
                </tr>
            </table>
        </div>`
    $(obj).before(html)
}

function delKingOfCardsSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsLvWrap').data('idx')
    if (KingOfCardsSpinsStages[lvIdx] < 1) return
    $(obj).parents('.KingOfCardsLvWrap').find('.KingOfCardsSpinsWrap:last').remove()
    KingOfCardsSpinsStages[lvIdx]--
}

function addKingOfCardsProgressTr(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.KingOfCardsSpinsWrap').data('idx')
    let rewardIdx = `${lvIdx}_${spinsIdx}`

    let rewardStage = ++KingOfCardsProgressStages[rewardIdx]
    let rewardKey = `${rewardIdx}_${rewardStage}`
    let prize = escape('[]');

    let html = `
        <tr class="KingOfCardsProgressInfoTr" id="KingOfCardsProgressInfo_${rewardKey}" data-idx=" ${rewardStage} ">
            <td width="120"><input type="text" name="kingOfCardsConfig[${lvIdx}][stages][${spinsIdx}][progress][${rewardStage}][stage]" class="form-control" value="${rewardStage}" readonly ></td>
            <td><input name="kingOfCardsConfig[${lvIdx}][stages][${spinsIdx}][progress][${rewardStage}][target]" type="text"  class="form-control" value="0"></td>
            <td class="prizeShow"></td>
            <td>
                <input type="hidden" class="prizeInput" name="kingOfCardsConfig[${lvIdx}][stages][${spinsIdx}][progress][${rewardStage}][prize]" value="${prize}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'kingOfCards',1)">奖励配置</button>
            </td>
        </tr>`;

    $('#KingOfCardsProgressBody_' + rewardIdx).append(html)
}

function delKingOfCardsProgressTr(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsLvWrap').data('idx')
    let SpinsIdx = $(obj).parents('.KingOfCardsSpinsWrap').data('idx')
    let rewardIdx = `${lvIdx}_${SpinsIdx}`

    let rewardKey = `${rewardIdx}_${KingOfCardsProgressStages[rewardIdx]}`
    if (KingOfCardsProgressStages[rewardIdx] < 1) return;
    $('#KingOfCardsProgressInfo_' + rewardKey).remove()
    KingOfCardsProgressStages[rewardIdx]--
}
