let KingOfCardsNewLvCnt = 0;
let KingOfCardsNewSpinsStages = {}
let KingOfCardsNewSsStages = {}
let KingOfCardsNewProgressStages = {}

function initRewardKingOfCardsNewNew(type) {
    console.log('init ' + type)
    changeTypeToKingOfCardsNew()

    // 奖励回写
    console.log('reward_conf ', reward_conf)
    reward_conf && $.each(reward_conf, function (lvStage, lvItem) {
        $('#addKingOfCardsNewLvWrapBtn').click()
        $(`input[name="kingOfCardsNewConfig[${lvStage}][lvStart]"]`).val(lvItem.lvStart)
        $(`input[name="kingOfCardsNewConfig[${lvStage}][lvEnd]"]`).val(lvItem.lvEnd)

        $.each(lvItem.stages, function (spinsStage, spinsItem) {
            $('.addKingOfCardsNewSpinsWrapBtn:last').click()
            $(`input[name="kingOfCardsNewConfig[${lvStage}][stages][${spinsStage}][spinsStart]"]`).val(spinsItem.spinsStart)
            $(`input[name="kingOfCardsNewConfig[${lvStage}][stages][${spinsStage}][spinsEnd]"]`).val(spinsItem.spinsEnd)

            // 进度奖励
            spinsItem.stages && $.each(spinsItem.stages, function (ssIdx, ssItem) {
                $('.addKingOfCardsNewSsWrapBtn:last').click()
                $(`select[name="kingOfCardsNewConfig[${lvStage}][stages][${spinsStage}][stages][${ssIdx}][shushu][]"]`).val(ssItem.shushu)

                ssItem.progress && $.each(ssItem.progress, (rewardIdx, rewardItem)=>{

                    $('.addKingOfCardsNewProgressTrBtn:last').click()
                    $(`input[name="kingOfCardsNewConfig[${lvStage}][stages][${spinsStage}][stages][${ssIdx}][progress][${rewardIdx}][target]"]`).val(rewardItem.target)
                    $(`input[name="kingOfCardsNewConfig[${lvStage}][stages][${spinsStage}][stages][${ssIdx}][progress][${rewardIdx}][prize]"]`).val(escape(JSON.stringify(rewardItem.prize)))

                    $('.prizeShow:last').html(prizeListHtml(rewardItem.prize))
                })

            })
        })
    })
    $('.select2').select2({})
}

function changeTypeToKingOfCardsNew() {
    $("#reward_info").empty();
    initKingOfCardsNewWrap();
}

function initKingOfCardsNewWrap() {
    KingOfCardsNewLvCnt = 0;
    KingOfCardsNewSpinsStages = {}
    KingOfCardsNewSsStages = {}
    KingOfCardsNewProgressStages = {}

    let html = KingOfCardsNewWrapStageTable();
    $("#reward_info").append(html);
}

function KingOfCardsNewWrapStageTable() {
    return `
         <div class="text-center" style="margin:5px;padding:5px;border:solid 1px lightgray;">
            <button style="margin-top: 20px" id="addKingOfCardsNewLvWrapBtn" class="btn btn-primary" onclick="addKingOfCardsNewLvWrap(this)" type="button">添加等级区间</button>
            <button style="margin-top: 20px" class="btn btn-danger" onclick="delKingOfCardsNewLvWrap()" type="button">删除等级区间</button>
         </div>
        `
}

function addKingOfCardsNewLvWrap() {
    KingOfCardsNewLvCnt++
    KingOfCardsNewSpinsStages[KingOfCardsNewLvCnt] = 0
    let html = `
        <div class="form-group text-center KingOfCardsNewLvWrap" id="KingOfCardsNewLvWrap_${KingOfCardsNewLvCnt}" data-idx="${KingOfCardsNewLvCnt}" style="margin:10px;padding:5px;border:solid 1px black;">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="kingOfCardsNewConfig[${KingOfCardsNewLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="kingOfCardsNewConfig[${KingOfCardsNewLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton style="margin-top: 10px" class="btn btn-primary  addKingOfCardsNewSpinsWrapBtn" onclick="addKingOfCardsNewSpinsWrap( this)">添加体力分组层级</botton>
            <botton style="margin-top: 10px" class="btn btn-danger del-tr delKingOfCardsNewSpinsWrapBtn" onclick="delKingOfCardsNewSpinsWrap( this)">删除体力分组层级</botton>
        </div>
        `
    $("#addKingOfCardsNewLvWrapBtn").before(html)
}
function delKingOfCardsNewLvWrap() {
    if (KingOfCardsNewLvCnt < 1) {
        return;
    }
    $('#KingOfCardsNewLvWrap_' + KingOfCardsNewLvCnt).remove();
    KingOfCardsNewLvCnt--;
}

function addKingOfCardsNewSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsNewLvWrap').data('idx')
    let spinsCnt = ++KingOfCardsNewSpinsStages[lvIdx]
    let ssKey = `${lvIdx}_${spinsCnt}`

    KingOfCardsNewSsStages[ssKey] = 0

    let html = `
        <div class="KingOfCardsNewSpinsWrap" id="KingOfCardsNewSpinsWrap_${ssKey}" data-idx="${spinsCnt}" style="margin:10px;padding:5px;border:solid 1px goldenrod;">
            <table class="table table-bordered">
                <thead>
                    <tr><td colspan="4">
                         <div class="form-group">
                            <label class="col-sm-1 control-label m-b">体力区间: </label>
                            <div class="col-sm-3 input-group">
                                <input type="text" style="text-align: center" class="form-control" name="kingOfCardsNewConfig[${lvIdx}][stages][${spinsCnt}][spinsStart]" value="0">
                                <span class="input-group-addon">-</span>
                                <input type="text" style="text-align: center" class="form-control" name="kingOfCardsNewConfig[${lvIdx}][stages][${spinsCnt}][spinsEnd]" value="0">
                            </div>
                        </div>
                    </td></tr>
                </thead>
                <tr>
                    <td colspan="7">
                        <div class="text-center" style="margin-top: 20px">
                            <botton class="btn btn-primary addKingOfCardsNewSsWrapBtn" onclick="addKingOfCardsNewSsWrap(this)">添加数数分组分层</botton>
                            <botton class="btn btn-danger del-tr" onclick="delKingOfCardsNewSsWrap(this)">删除数数分组分层</botton>
                        </div>
                    </td>
                </tr>
            </table>
        </div>`
    $(obj).before(html)
}
function delKingOfCardsNewSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsNewLvWrap').data('idx')
    if (KingOfCardsNewSpinsStages[lvIdx] < 1) return
    $(obj).parents('.KingOfCardsNewLvWrap').find('.KingOfCardsNewSpinsWrap:last').remove()
    KingOfCardsNewSpinsStages[lvIdx]--
}

function addKingOfCardsNewSsWrap(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsNewLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.KingOfCardsNewSpinsWrap').data('idx')
    let ssIdx = ++KingOfCardsNewSsStages[`${lvIdx}_${spinsIdx}`]
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    KingOfCardsNewProgressStages[rewardKey] = 0

    let ssOptionsHtml = getShushuSelectorOptions()
    let html = `
        <div class="KingOfCardsNewSsWrap" id="KingOfCardsNewSsWrap_${rewardKey}" data-idx="${ssIdx}" style="margin:10px;padding:5px;border:solid 1px goldenrod;">
            <table class="table table-bordered">
                <thead>
                    <tr><td colspan="4">
                         <div class="form-group">
                            <label class="col-sm-1 control-label m-b">数数分组: </label>
                            <div class="col-sm-3 input-group">
                                <select class=" select2 " multiple name="kingOfCardsNewConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][shushu][]"  style="width: 100%">
                                    ${ssOptionsHtml}
                                </select>
                            </div>
                        </div>
                    </td></tr>
                    <tr>
                        <th width="120">阶段</th>
                        <th width="140">阶段值</th>
                        <th>奖励</th>
                        <th width="140">奖励设置</th>
                    </tr>
                </thead>
                <tbody id="KingOfCardsNewProgressBody_${rewardKey}"></tbody>
                <tr>
                    <td colspan="7">
                        <div class="text-center" style="margin-top: 20px">
                            <botton class="btn btn-primary addKingOfCardsNewProgressTrBtn" onclick="addKingOfCardsNewProgressTr(this)">添加阶段奖励</botton>
                            <botton class="btn btn-danger del-tr" onclick="delKingOfCardsNewProgressTr(this)">删除</botton>
                        </div>
                    </td>
                </tr>
            </table>
        </div>`
    $(obj).before(html)
    $('.select2').select2({})
}
function delKingOfCardsNewSsWrap(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsNewLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.KingOfCardsNewSpinsWrap').data('idx')
    if (KingOfCardsNewSsStages[`${lvIdx}_${spinsIdx}`] < 1) return
    $(obj).parents('.KingOfCardsNewSpinsWrap').find('.KingOfCardsNewSsWrap:last').remove()
    KingOfCardsNewSsStages[`${lvIdx}_${spinsIdx}`]--
}

function addKingOfCardsNewProgressTr(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsNewLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.KingOfCardsNewSpinsWrap').data('idx')
    let ssIdx = $(obj).parents('.KingOfCardsNewSsWrap').data('idx')
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`

    let rewardStage = ++KingOfCardsNewProgressStages[rewardKey]
    let rewardIdx = `${rewardKey}_${rewardStage}`
    let prize = escape('[]');

    let html = `
        <tr class="KingOfCardsNewProgressInfoTr commonStageRewardTr" id="KingOfCardsNewProgressInfo_${rewardIdx}" data-idx=" ${rewardStage} ">
            <td width="120"><input type="text" name="kingOfCardsNewConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][progress][${rewardStage}][stage]" class="form-control" value="${rewardStage}" readonly ></td>
            <td><input name="kingOfCardsNewConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][progress][${rewardStage}][target]" type="text"  class="form-control" value="0"></td>
            <td class="prizeShow"></td>
            <td>
                <input type="hidden" class="prizeInput" name="kingOfCardsNewConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][progress][${rewardStage}][prize]" value="${prize}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
        </tr>`;

    $('#KingOfCardsNewProgressBody_' + rewardKey).append(html)
}
function delKingOfCardsNewProgressTr(obj) {
    let lvIdx = $(obj).parents('.KingOfCardsNewLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.KingOfCardsNewSpinsWrap').data('idx')
    let ssIdx = $(obj).parents('.KingOfCardsNewSsWrap').data('idx')
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`

    let rewardIdx = `${rewardKey}_${KingOfCardsNewProgressStages[rewardKey]}`
    if (KingOfCardsNewProgressStages[rewardKey] < 1) return;
    $('#KingOfCardsNewProgressInfo_' + rewardIdx).remove()
    KingOfCardsNewProgressStages[rewardKey]--
}
