let mysteryMineLvCnt = 0
let mysteryMineSpinsStages = {}
let mysteryMineShushuStages = {}
let mysteryMineProbStages = {}
let mysteryMineOutsideRewardStages = {}
let mysteryMineInsideRewardStages = {}
let mysteryMineTaskStages = {}
let mysteryMineScoreStages = {}
let mysteryMineLowStages = {}
let mysteryMineLowStagesGrids = {}
let mysteryMineHighStages = {}
let mysteryMineHighStagesGrids = {}
let mysteryMineTaskTypeOptionHtml = ""

function initRewardMysteryMine() {
    getActBasicConfig(act_type).then(()=>{
        let html = mysteryMineStageTable();
        $("#reward_info").html(html);

        // 奖励回写
        if (!reward_conf || !activity_extra_data) {
            return
        }

        reward_conf.baseConf && $.each( reward_conf.baseConf,(field,  value)=>{
            $(`input[name="mysteryMineConf[baseConf][${field}]"]`).val(value)
        })

        reward_conf.stageConf && $.each(reward_conf.stageConf, function (i, o) {
            $('#addMysteryMineLvWrapBtn').click()
            $(`input[name="mysteryMineConf[stageConf][${i}][lvStart]"]`).val(o.lvStart)
            $(`input[name="mysteryMineConf[stageConf][${i}][lvEnd]"]`).val(o.lvEnd)

            $(`#mysteryMineLvWrap_${i}`).find(`button`).remove()
            $(`#mysteryMineLvWrap_${i}`).append(`<button class="btn btn-primary asyncLoadConfigBtn" style="" type="button" onclick="asyncLoadMysteryMineConfig(${i})">加载配置</button>`)
            $('#submitBtn').hide();

        })
        $('.select2').select2({})
    })


}

function changeTypeToMysteryMine() {
    mysteryMineLvCnt = 0
    mysteryMineSpinsStages = {}
    mysteryMineShushuStages = {}
    mysteryMineProbStages = {}
    mysteryMineOutsideRewardStages = {}
    mysteryMineInsideRewardStages = {}
    mysteryMineTaskStages = {}

    getActBasicConfig(act_type).then(()=>{
        let html = mysteryMineStageTable();
        $("#reward_info").html(html);
    })
}

function mysteryMineStageTable() {
    return `
        <div class="form-group">
            <h4 style="font-weight: bold" class="text-left">基础配置*:</h4>
            <label class="col-xs-1 control-label">积分基础值:</label>
            <div class="col-sm-1"><input type="number" name="mysteryMineConf[baseConf][getScore]" value="" class="form-control"></div>
        </div>
        <div class="form-group text-center">
            <h4 style="font-weight: bold" class="text-left">阶段奖励配置*:</h4>
            <button class="btn btn-primary" id="addMysteryMineLvWrapBtn" onclick="addMysteryMineLvWrap(this)" type="button">添加等级层级</button>
            <button class="btn btn-white"   id="delMysteryMineLvWrapBtn" onclick="delMysteryMineLvWrap()" type="button">删除等级层级</button>
        </div>
        <hr style=" height:2px;border:none;border-top:2px dotted #0b0;">
    `;
}

function addMysteryMineLvWrap(obj) {
    mysteryMineLvCnt++
    mysteryMineSpinsStages[mysteryMineLvCnt] = 0

    let html = `
        <div class="mysteryMineLvWrap table-border-blue" id="mysteryMineLvWrap_${mysteryMineLvCnt}" data-idx="${mysteryMineLvCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="mysteryMineConf[stageConf][${mysteryMineLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="mysteryMineConf[stageConf][${mysteryMineLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <button type="button" class="btn btn-primary addMysteryMineSpinsWrapBtn" onclick="addMysteryMineSpinsWrap(this)">添加体力层级</button>
            <button type="button" class="btn btn-danger del-tr delMysteryMineSpinsWrapBtn" onclick="delMysteryMineSpinsWrap(this)">删除体力层级</button>
        </div>
`

    $(obj).before(html)
    $('.select2').select2({})
}

function addMysteryMineSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.mysteryMineLvWrap').data('idx')
    let mysteryMineSpinsCnt = ++mysteryMineSpinsStages[lvIdx]
    let spinsIdx = `${lvIdx}_${mysteryMineSpinsCnt}`
    mysteryMineShushuStages[spinsIdx] = 0

    let html = `
        <div class="mysteryMineSpinsWrap table-border-blue" id="mysteryMineSpinsWrap_${spinsIdx}" data-idx="${mysteryMineSpinsCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">体力区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${mysteryMineSpinsCnt}][spinsStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${mysteryMineSpinsCnt}][spinsEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <button type="button" class="btn btn-primary addMysteryMineShushuWrapBtn" onclick="addMysteryMineShushuWrap(this)">添加数数分组层级</button>
            <button type="button" class="btn btn-danger del-tr delMysteryMineShushuWrapBtn" onclick="delMysteryMineShushuWrap(this)">删除数数分组层级</button>
        </div>
    `

    $(obj).before(html)
    $('.select2').select2({})
}


function addMysteryMineShushuWrap(obj) {
    let lvIdx = $(obj).parents('.mysteryMineLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.mysteryMineSpinsWrap').data('idx')

    let ssIdx = ++mysteryMineShushuStages[`${lvIdx}_${spinsIdx}`]

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    mysteryMineProbStages[rewardIdx] = 0
    mysteryMineOutsideRewardStages[rewardIdx] = 0
    mysteryMineInsideRewardStages[rewardIdx] = 0
    mysteryMineTaskStages[rewardIdx] = 0
    mysteryMineScoreStages[rewardIdx] = 0
    mysteryMineLowStages[rewardIdx] = 0
    mysteryMineHighStages[rewardIdx] = 0

    let arr = JSON.parse($hideSSGroup);

    let optionsHtml = ''
    $.each(arr, function (i, o) {
        optionsHtml += '<option value="' + i + '">' + o + '</option>'
    });

    let html = `
        <div class="mysteryMineShushuWrap table-border-blue" id="mysteryMineShushuWrap_${rewardIdx}" data-idx="${ssIdx}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">数数分组 </label>
                <div class="col-sm-3 input-group"> 
                    <select class=" select2" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][shushu][]"  multiple  style="min-width: 100%"> 
                        ${optionsHtml}
                    </select> 
                </div>
            </div> 
            <hr style="border:solid 1px black;">
            
            <div class=" form-inline" style="text-align: left">
                <label class="">入场赠送代币数: 
                 <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][giveToken]"  value="0"></label>
            </div>
<!--            概率配置-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">概率配置: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">#</th> 
                            <th width="100px">倍率</th>
                            <th width="100px">消耗体力值</th> 
                            <th>概率</th>
                        </tr>
                    </thead> 
                    <tbody id="mysteryMineProbBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="4">
                            <div class="text-center">
                                <button type="button" class="btn btn-primary addMysteryMineProbTrBtn" onclick="addMysteryMineProbTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>
                                <button type="button" class="btn btn-danger del-tr" onclick="delMysteryMineProbTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
<!--            入场门槛积分配置-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">入场门槛积分配置: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="100px">阶段</th>
                            <th>积分</th> 
                        </tr>
                    </thead> 
                    <tbody id="mysteryMineScoreBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="4">
                            <div class="text-center">
                                <button type="button" class="btn btn-primary addMysteryMineProbTrBtn" onclick="addMysteryMineScoreTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>
                                <button type="button" class="btn btn-danger del-tr" onclick="delMysteryMineScoreTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
<!--            普通场-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">普通场配置: </label>
                </div>
                
                <button type="button" class="btn btn-primary addMysteryMineLowStageWrapBtn_${lvIdx}_${spinsIdx}_${ssIdx}" onclick="addMysteryMineLowStageWrap(${lvIdx},${spinsIdx},${ssIdx})">添加普通场</button>
                <button type="button" class="btn btn-danger del-tr delMysteryMineShushuWrapBtn" onclick="delMysteryMineLowStageWrap(${lvIdx},${spinsIdx},${ssIdx})">删除普通场</button>
            </div>
            
<!--            高级场-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">高级场配置: </label>
                </div>
                <button type="button" class="btn btn-primary addMysteryMineHighStageWrapBtn_${lvIdx}_${spinsIdx}_${ssIdx}" onclick="addMysteryMineHighStageWrap(${lvIdx},${spinsIdx},${ssIdx})">添加高级场</button>
                <button type="button" class="btn btn-danger  " onclick="delMysteryMineHighStageWrap(${lvIdx},${spinsIdx},${ssIdx})">删除高级场</button>
            </div>
             
        
<!--            进度条1-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">进度条1: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">阶段</th> 
                            <th width="100px">阶段值</th> 
                            <th width="100px">奖励设置</th>
                            <th>奖品</th> 
                        </tr>
                    </thead> 
                    <tbody id="mysteryMineOutsideRewardBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="5">
                            <div class="text-center">
                                <button type="button" class="btn btn-primary addMysteryMineOutsideRewardTrBtn" onclick="addMysteryMineOutsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>
                                <button type="button" class="btn btn-danger del-tr" onclick="delMysteryMineOutsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
<!--            进度条2-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">进度条2: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">阶段</th> 
                            <th width="100px">阶段值</th> 
                            <th width="100px">奖励设置</th>
                            <th>奖品</th> 
                        </tr>
                    </thead> 
                    <tbody id="mysteryMineInsideRewardBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="5">
                            <div class="text-center">
                                <button type="button" class="btn btn-primary addMysteryMineInsideRewardTrBtn" onclick="addMysteryMineInsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">添加</button>
                                <button type="button" class="btn btn-danger del-tr" onclick="delMysteryMineInsideRewardTr(${lvIdx},${spinsIdx},${ssIdx})">删除</button> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
        </div>`;

    $(obj).before(html)
    $(`#mysteryMineShushuWrap_${rewardIdx}`).append(noTokenAlert(rewardIdx, 132))
    $('.select2').select2({})
}


function delMysteryMineLvWrap() {
    if (mysteryMineLvCnt < 1) {
        return;
    }
    $('#mysteryMineLvWrap_' + mysteryMineLvCnt).remove();
    mysteryMineLvCnt--;
}

function delMysteryMineSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.mysteryMineLvWrap').data('idx')

    if (mysteryMineSpinsStages[lvIdx] < 1) return
    $(obj).parents('.mysteryMineLvWrap').find('.mysteryMineSpinsWrap:last').remove()
    mysteryMineSpinsStages[lvIdx]--
}

function delMysteryMineShushuWrap(obj) {
    let lvIdx = $(obj).parents('.mysteryMineLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.mysteryMineSpinsWrap').data('idx')

    if (mysteryMineShushuStages[`${lvIdx}_${spinsIdx}`] < 1) return
    $(obj).parents('.mysteryMineSpinsWrap').find('.mysteryMineShushuWrap:last').remove()
    mysteryMineShushuStages[`${lvIdx}_${spinsIdx}`]--
}

function addMysteryMineProbTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = mysteryMineProbStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="mysteryMineProbInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input style="width: 120px" type="number" class="form-control" readonly  value="${rIdx + 1}">
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][bet]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][costSpin]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][prob]" value="0">
            </td> 
        </tr> 
    `;

    $('#mysteryMineProbBody_' + lsrIdx).append(html)
}
function delMysteryMineProbTr(lvIdx, spinsIdx, ssIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    mysteryMineProbStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + mysteryMineProbStages[rewardIdx]

    if (mysteryMineProbStages[rewardIdx] < 0) return;
    $('#mysteryMineProbInfo_' + rewardKey).remove()
}

function addMysteryMineScoreTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = mysteryMineScoreStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="mysteryMineScoreInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][joinStageConf][${rIdx}][stageId]" readonly  value="${rIdx + 1}"  style="width: 120px" >
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][joinStageConf][${rIdx}][dst]" value="0">
            </td> 
        </tr> 
    `;

    $('#mysteryMineScoreBody_' + lsrIdx).append(html)
}
function delMysteryMineScoreTr(lvIdx, spinsIdx, ssIdx) {
    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    mysteryMineScoreStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + mysteryMineScoreStages[rewardIdx]

    if (mysteryMineScoreStages[rewardIdx] < 0) return;
    $('#mysteryMineScoreInfo_' + rewardKey).remove()
}

// 进度条1
function addMysteryMineOutsideRewardTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = mysteryMineOutsideRewardStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="mysteryMineOutsideRewardInfo_${rewardKey}" class="commonStageRewardTr" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfA][${rIdx}][stageId]" value="${rIdx+1}" readonly>
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfA][${rIdx}][dst]" value="0">
            </td> 
            <td>
                <input type="hidden" class="prizeInput" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfA][${rIdx}][prize]" value="{}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow"></td>
        </tr> 
    `;

    $('#mysteryMineOutsideRewardBody_' + lsrIdx).append(html)
}
function delMysteryMineOutsideRewardTr(lvIdx, spinsIdx, ssIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    mysteryMineOutsideRewardStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + mysteryMineOutsideRewardStages[rewardIdx]

    if (mysteryMineOutsideRewardStages[rewardIdx] < 0) return;
    $('#mysteryMineOutsideRewardInfo_' + rewardKey).remove()
}

// 进度条2
function addMysteryMineInsideRewardTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = mysteryMineInsideRewardStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="mysteryMineInsideRewardInfo_${rewardKey}" class="commonStageRewardTr" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfB][${rIdx}][stageId]" value="${rIdx+1}" readonly>
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfB][${rIdx}][dst]" value="0">
            </td> 
            <td>
                <input type="hidden" class="prizeInput" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][collectConfB][${rIdx}][prize]" value="{}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow"></td>
        </tr> 
    `;

    $('#mysteryMineInsideRewardBody_' + lsrIdx).append(html)
}
function delMysteryMineInsideRewardTr(lvIdx, spinsIdx, ssIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    mysteryMineInsideRewardStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + mysteryMineInsideRewardStages[rewardIdx]

    if (mysteryMineInsideRewardStages[rewardIdx] < 0) return;
    $('#mysteryMineInsideRewardInfo_' + rewardKey).remove()
}


function addMysteryMineTaskTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = mysteryMineTaskStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="mysteryMineTaskInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][stages][taskConf][${rIdx}][taskId]" readonly value="${rIdx + 1}">
            </td> 
            <td>
                <select class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][stages][taskConf][${rIdx}][taskType]">
                    ${mysteryMineTaskTypeOptionHtml}
                </select>
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][stages][taskConf][${rIdx}][score]" value="0">
            </td> 
        </tr> 
    `;

    $('#mysteryMineTaskBody_' + lsrIdx).append(html)
}
function delMysteryMineTaskTr(lvIdx, spinsIdx, ssIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    mysteryMineTaskStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + mysteryMineTaskStages[rewardIdx]

    if (mysteryMineTaskStages[rewardIdx] < 0) return;
    $('#mysteryMineTaskInfo_' + rewardKey).remove()
}

function addMysteryMineLowStageWrap(lvIdx, spinsIdx, ssIdx){
    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = mysteryMineLowStages[lsrIdx]++
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`
    mysteryMineLowStagesGrids[rewardKey] = 0
    let html = `
                <div class="table-border-yellow mysteryMineLowStageWrap">
                    <div class="form-group">
                        <label class="col-sm-1 control-label m-b">普通场${rIdx+1}: </label>
                        <input type="hidden" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][stages][${rIdx}][stageId]" readonly value="${rIdx + 1}">
            
                    </div>
                    <table class="table table-bordered" > 
                        <thead>
                            <tr>
                                <th width="120">#</th> 
                                <th>奖励类型</th> 
                                <th>奖励数量</th> 
                                <th>权重</th> 
                                <th>需要消耗代币数</th> 
                            </tr>
                        </thead> 
                        <tbody id="mysteryMineLowStageBody_${rewardKey}"> </tbody>
                        <tr>
                            <td colspan="5">
                                <div class="text-center">
                                    <button type="button" class="btn btn-primary " onclick="addMysteryMineLowStageTr(${lvIdx},${spinsIdx},${ssIdx},${rIdx})">添加</button>
                                    <button type="button" class="btn btn-danger "  onclick="delMysteryMineLowStageTr(${lvIdx},${spinsIdx},${ssIdx},${rIdx})">删除</button> 
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
    `;
    $(`.addMysteryMineLowStageWrapBtn_${lvIdx}_${spinsIdx}_${ssIdx}`).before(html)
}
function delMysteryMineLowStageWrap(lvIdx, spinsIdx, ssIdx){
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    if($(`#mysteryMineShushuWrap_${rewardKey}`).find('.mysteryMineLowStageWrap').length > 1 && mysteryMineLowStages[rewardKey]>1){
        $(`#mysteryMineShushuWrap_${rewardKey}`).find('.mysteryMineLowStageWrap:last').remove()
        mysteryMineLowStages[rewardKey]--
    }
}

function addMysteryMineLowStageTr(lvIdx, spinsIdx, ssIdx, stageIdx){
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${stageIdx}`
    let rIdx = mysteryMineLowStagesGrids[rewardKey]++
    let mysteryMineTaskTypeOptionHtml = '<option value="0">奖励类型</option>'
    let lsrIdx = `${rewardKey}_${rIdx}`
    $.each(actBasicConf[act_type], function(i,o){
        mysteryMineTaskTypeOptionHtml += `<option value="${i}">${o}</option>`
    })
    let html = `
        <tr id="mysteryMineLowGridInfo_${lsrIdx}" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][stages][${stageIdx}][grids][${rIdx}][gridId]" readonly value="${rIdx + 1}">
            </td> 
            <td>
                <select class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][stages][${stageIdx}][grids][${rIdx}][prizeType]">
                    ${mysteryMineTaskTypeOptionHtml}
                </select>
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][stages][${stageIdx}][grids][${rIdx}][prizeNum]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][stages][${stageIdx}][grids][${rIdx}][weight]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][lowStageConf][stages][${stageIdx}][grids][${rIdx}][needCost]" value="0">
            </td> 
        </tr> 
    `;
    $('#mysteryMineLowStageBody_' + rewardKey).append(html)
}
function delMysteryMineLowStageTr(lvIdx, spinsIdx, ssIdx, stageIdx){

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${stageIdx}`
    let rIdx = mysteryMineLowStagesGrids[rewardKey]-1
    let lsrIdx = `${rewardKey}_${rIdx}`
    console.log($(`#mysteryMineLowGridInfo_${lsrIdx}`));
    if( $(`#mysteryMineLowGridInfo_${lsrIdx}`).length > 0 ){
        mysteryMineLowStagesGrids[rewardKey]--
        $(`#mysteryMineLowGridInfo_${lsrIdx}`).remove()
    }
}


function addMysteryMineHighStageWrap(lvIdx, spinsIdx, ssIdx){
    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = mysteryMineHighStages[lsrIdx]++
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`
    mysteryMineHighStagesGrids[rewardKey] = 0
    let html = `
                <div class="table-border-yellow mysteryMineHighStageWrap">
                    <div class="form-group">
                        <label class="col-sm-1 control-label m-b">高级场${rIdx+1}: </label>
                        <input type="hidden" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][highStageConf][stages][${rIdx}][stageId]" readonly value="${rIdx + 1}">
            
                    </div>
                    <table class="table table-bordered" > 
                        <thead>
                            <tr>
                                <th width="120">#</th> 
                                <th width="120">是否大奖</th> 
                                <th width="120">权重</th> 
                                <th width="120">出奖需要挖掘次数</th>
                                <th width="120">奖励配置</th>  
                                <th>奖励</th>  
                            </tr>
                        </thead> 
                        <tbody id="mysteryMineHighStageBody_${rewardKey}"> </tbody>
                        <tr>
                            <td colspan="6">
                                <div class="text-center">
                                    <button type="button" class="btn btn-primary " onclick="addMysteryMineHighStageTr(${lvIdx},${spinsIdx},${ssIdx},${rIdx})">添加</button>
                                    <button type="button" class="btn btn-danger "  onclick="delMysteryMineHighStageTr(${lvIdx},${spinsIdx},${ssIdx},${rIdx})">删除</button> 
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
    `;
    $(`.addMysteryMineHighStageWrapBtn_${lvIdx}_${spinsIdx}_${ssIdx}`).before(html)
}
function delMysteryMineHighStageWrap(lvIdx, spinsIdx, ssIdx){
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    if($(`#mysteryMineShushuWrap_${rewardKey}`).find('.mysteryMineHighStageWrap').length > 1 && mysteryMineHighStages[rewardKey]>1){
        $(`#mysteryMineShushuWrap_${rewardKey}`).find('.mysteryMineHighStageWrap:last').remove()
        mysteryMineHighStages[rewardKey]--
    }
}

function addMysteryMineHighStageTr(lvIdx, spinsIdx, ssIdx, stageIdx){
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${stageIdx}`
    let rIdx = mysteryMineHighStagesGrids[rewardKey]++
    let options = '';
    let prizeDft = escape('{}')
    let lsrIdx = `${rewardKey}_${rIdx}`
    $.each({0:'否',1:'是'}, (i,o)=>{
        options += `<option value="${i}">${o}</option>`
    })


    let html = `
        <tr id="mysteryMineHighGridInfo_${lsrIdx}" data-idx="${rIdx}" class="commonStageRewardTr" > 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][highStageConf][stages][${stageIdx}][grids][${rIdx}][gridId]" readonly value="${rIdx + 1}">
            </td> 
            <td>
                <select class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][highStageConf][stages][${stageIdx}][grids][${rIdx}][isGoldPrize]">
                    ${options}
                </select>
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][highStageConf][stages][${stageIdx}][grids][${rIdx}][weight]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][highStageConf][stages][${stageIdx}][grids][${rIdx}][needCost]" value="0">
            </td> 
            <td>
                <input type="hidden" class="prizeInput" name="mysteryMineConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][highStageConf][stages][${stageIdx}][grids][${rIdx}][prize]" value="${prizeDft}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow"></td>
        </tr> 
    `;
    $('#mysteryMineHighStageBody_' + rewardKey).append(html)
}
function delMysteryMineHighStageTr(lvIdx, spinsIdx, ssIdx, stageIdx){

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${stageIdx}`
    let rIdx = mysteryMineHighStagesGrids[rewardKey]-1
    let lsrIdx = `${rewardKey}_${rIdx}`
    console.log($(`#mysteryMineHighGridInfo_${lsrIdx}`));
    if( $(`#mysteryMineHighGridInfo_${lsrIdx}`).length > 0 ){
        mysteryMineHighStagesGrids[rewardKey]--
        $(`#mysteryMineHighGridInfo_${lsrIdx}`).remove()
    }
}


asyncLoadMysteryMineConfig = (i)=>{
    showLoading()
    console.log(reward_conf.stageConf[i]);
    $(`#mysteryMineLvWrap_${i}`).find(`.asyncLoadConfigBtn`).remove()
    $(`#mysteryMineLvWrap_${i}`).append(`
            <button type="button" class="btn btn-primary addMysteryMineSpinsWrapBtn" onclick="addMysteryMineSpinsWrap(this)">添加体力层级</button>
            <button type="button" class="btn btn-danger del-tr delMysteryMineSpinsWrapBtn" onclick="delMysteryMineSpinsWrap(this)">删除体力层级</button>`)
    reward_conf.stageConf[i].stages && $.each(reward_conf.stageConf[i].stages, function (i1, o1) {
        $('.addMysteryMineSpinsWrapBtn:last').click()
        $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][spinsStart]"]`).val(o1.spinsStart)
        $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][spinsEnd]"]`).val(o1.spinsEnd)
        $.each(o1.stages, function (i2, o2) {
            $('.addMysteryMineShushuWrapBtn:last').click()
            $(`select[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][shushu][]"]`).val(o2.shushu)
            $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][giveToken]"]`).val(o2.giveToken)

            o2['betConf'] && $.each(o2['betConf'], function (k, v) {
                addMysteryMineProbTr(i, i1, i2)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][bet]"]`).val(v.bet)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][costSpin]"]`).val(v.costSpin)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][prob]"]`).val(v.prob)
            })

            o2['joinStageConf'] && $.each(o2['joinStageConf'], function (k, v) {
                addMysteryMineScoreTr(i, i1, i2)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][joinStageConf][${k}][stageId]"]`).val(v.stageId)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][joinStageConf][${k}][dst]"]`).val(v.dst)
            })

            o2.highStageConf['stages'] && $.each(o2.highStageConf['stages'], function (k, v) {
                addMysteryMineHighStageWrap(i, i1, i2)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][highStageConf][stages][${k}][stageId]"]`).val(v.stageId)
                v.grids && $.each(v.grids,(ig, og)=>{
                    addMysteryMineHighStageTr(i, i1, i2, k)
                    let prizeEl = $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][highStageConf][stages][${k}][grids][${ig}][prize]"]`)
                    $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][highStageConf][stages][${k}][grids][${ig}][gridId]"]`).val(og.gridId)
                    $(`select[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][highStageConf][stages][${k}][grids][${ig}][isGoldPrize]"]`).val(og.isGoldPrize)
                    $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][highStageConf][stages][${k}][grids][${ig}][weight]"]`).val(og.weight)
                    $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][highStageConf][stages][${k}][grids][${ig}][needCost]"]`).val(og.needCost)
                    prizeEl.val(escape(JSON.stringify(og.prize)))
                    console.log(prizeEl.parents('.commonStageRewardTr').find('.prizeShow'));
                    prizeEl.parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(og.prize))
                })
            })

            o2.lowStageConf['stages'] && $.each(o2.lowStageConf['stages'], function (k, v) {
                addMysteryMineLowStageWrap(i, i1, i2)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][stages][${k}][stageId]"]`).val(v.stageId)
                v.grids && $.each(v.grids,(ig, og)=>{
                    addMysteryMineLowStageTr(i, i1, i2, k)
                    $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][stages][${k}][grids][${ig}][gridId]"]`).val(og.gridId)
                    $(`select[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][stages][${k}][grids][${ig}][prizeType]"]`).val(og.prizeType)
                    $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][stages][${k}][grids][${ig}][prizeNum]"]`).val(og.prizeNum)
                    $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][stages][${k}][grids][${ig}][weight]"]`).val(og.weight)
                    $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][stages][${k}][grids][${ig}][needCost]"]`).val(og.needCost)
                })
            })
            o2.lowStageConf['collectConfA'] && $.each(o2.lowStageConf['collectConfA'], function (k, v) {
                addMysteryMineOutsideRewardTr(i, i1, i2)
                let prizeEl = $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][collectConfA][${k}][prize]"]`)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][collectConfA][${k}][stageId]"]`).val(v.stageId)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][collectConfA][${k}][dst]"]`).val(v.dst)
                prizeEl.val(escape(JSON.stringify(v.prize)))
                prizeEl.parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(v.prize))
            })
            o2.lowStageConf['collectConfB'] && $.each(o2.lowStageConf['collectConfB'], function (k, v) {
                addMysteryMineInsideRewardTr(i, i1, i2)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][collectConfB][${k}][stageId]"]`).val(v.stageId)
                $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][collectConfB][${k}][dst]"]`).val(v.dst)
                let prizeEl = $(`input[name="mysteryMineConf[stageConf][${i}][stages][${i1}][stages][${i2}][lowStageConf][collectConfB][${k}][prize]"]`)
                prizeEl.val(escape(JSON.stringify(v.prize)))
                prizeEl.parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(v.prize))
            })

            renderNotokenAlert(`${i}_${i1}_${i2}`, reward_pro)
        })
    })

    $('.select2').select2({})
    updateSubmitBtnStatus()
    hideLoading()
}