function initReward_slotWeightFix(type) {
    console.log('init ' + type)
    changetypeTo_slotWeightFix();

    // 奖励回写
    console.log('extraData ', extraData)
    if (!extraData) {
        return
    }

    const extra_data = JSON.parse(extraData)
    $(`input[name="slotWeightFixConf[expendSpins]"]`).val(extra_data['expendSpins'])

    for (const idx in extra_data['alterConf']) {
        $(`input[name="slotWeightFixConf[alterConf][${idx}][v]"]`).val(extra_data['alterConf'][idx]['v'])
    }
}

function changetypeTo_slotWeightFix() {
    $("#reward_info").empty();
    initSlotWeightFixWrap();
}

function initSlotWeightFixWrap() {
    var html = SlotWeightFixWrapStageTable();
    $("#reward_info").append(html);
}

function SlotWeightFixWrapStageTable() {

    const titles = ["攻击", "偷袭", "体力", "护盾", "1个金币", "2个金币", "3个金币", "1个钱袋", "2个钱袋", "3个钱袋", "没有奖励", "活动物品1", "活动物品2", "活动物品3",];

    let thHtml = ""
    let tdHtml = ""

    for (const idx in titles) {
        thHtml += `<th>${titles[idx]}</th>`
        tdHtml += `<td><input type="number" class="form-control"  name="slotWeightFixConf[alterConf][${idx}][v]" value="0"></td>`
    }

    return `
        <div class="form-group">
            <label class="col-sm-1 control-label m-b">消耗体力:</label>
            <div class="col-sm-2">
                <input class="form-control" type="number" name="slotWeightFixConf[expendSpins]" value="0">
            </div>
        </div>

        <div class="form-group">
            <label class="col-sm-1 control-label m-b">权重更改:</label>
            <div class="col-sm-11">
                <table class="table table-bordered" id="setIntervalData">
                    <thead>
                    <tr>
                       ${thHtml}
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                      ${tdHtml}
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
    `;
}


