let spinPiggyLvStagesCnt = 0;
let spinPiggyStagesCnt = {};
let spinPiggyProgressCnt = {};

function changeTypeToSpinPiggyReward() {
    getActBasicConfig(act_type).then(()=>{
        initSpinPiggyRewardWrap()
    })
}
function initRewardSpinPiggyReward() {
    getActBasicConfig(act_type).then(()=>{
        initSpinPiggyRewardWrap()
        reward_info && $.each(reward_info, (i, o)=>{
            o.stages && $.each(o.stages, (i1, o1)=>{
                addSpinPiggyTimeRangeTr(i, o1.timeRange, o1.prizes)
            })
        })
    })
}

function initSpinPiggyRewardWrap() {
    $('#reward_info').empty();
    spinPiggyRewardBasicConfig();
}


// 基础配置
function spinPiggyRewardBasicConfig() {
    spinPiggyLvStagesCnt = 0;
    spinPiggySpinStagesCnt = {};
    spinPiggySsStagesCnt = {};
    spinPiggyStagesCnt = {};
    spinPiggyProgressCnt = {};



    let html = `
            <div class="spinPiggyRewardOuterWrap"   style="top:10px">
                <hr style="border:solid 1px goldenrod;">
                <div style="top:10px;margin: 10px;">
                    <div class="ibox-title" style="border-top: 0;"><h5 style="font-weight: bold">层级配置</h5></div>
                </div>
<!--                <div class="form-group text-center">-->
<!--                    <div class=" ">-->
<!--                        <button class="btn btn-primary" id="addSpinPiggyLvStageWrapBtn" onclick="addSpinPiggyLvStageWrap(this)" type="button">添加等级层级</button>-->
<!--                        <button class="btn btn-white"   id="delSpinPiggyLvStageWrapBtn" onclick="delSpinPiggyLvStageWrap()" type="button">删除等级层级</button>-->
<!--                    </div>-->
<!--                </div>-->
            </div>
    `;

    $("#reward_info").append(html)
    console.log(actBasicConf[act_type]['lvRanges']);
    actBasicConf[act_type]['lvRanges'] && $.each(actBasicConf[act_type]['lvRanges'], (i, o)=>{
        addSpinPiggyLvStageWrap(o.start, o.end)
    })
}



function addSpinPiggyLvStageWrap(start, end) {
    spinPiggyLvStagesCnt++;
    spinPiggyStagesCnt[spinPiggyLvStagesCnt] = 0

    let html = `
        <div class="form-group spinPiggyRewardLvStageWrap " id="spinPiggyRewardLvStageWrap_${spinPiggyLvStagesCnt}" data-idx="${spinPiggyLvStagesCnt}" style="margin:10px;padding:10px;border:solid 1px lightgray;">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="spinPiggyRewardReward[${spinPiggyLvStagesCnt}][lvStart]" value="${start}" readonly>
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="spinPiggyRewardReward[${spinPiggyLvStagesCnt}][lvEnd]" value="${end}" readonly>
                </div>
            </div>
            <table class="table table-bordered" > 
                <thead>
                     <tr>
                        <th> #</th>
                        <th> 时间范围</th>
                        <th> 操作</th>
                        <th> 奖励</th>
                    </tr>
                </thead> 
                <tbody id="spinPiggyRewardRewardBody_${spinPiggyLvStagesCnt}"> </tbody>
                <tr>
                    <td colspan="4">
                        <div class="text-center">
                            <botton class="btn btn-primary addSpinPiggyStageWrapBtn" onclick="addSpinPiggyTimeRangeTr(${spinPiggyLvStagesCnt})" type="button">添加限时奖励</botton>
                            <botton class="btn btn-danger  delSpinPiggyStageWrapBtn" onclick="delSpinPiggyTimeRangeTr(${spinPiggyLvStagesCnt})" type="button">删除限时奖励</botton> 
                        </div>
                    </td>
                </tr>
            </table>
        </div>
`
    $(`.spinPiggyRewardOuterWrap`).append(html)
}





function addSpinPiggyTimeRangeTr(lvIdx, timeRange = '', prizes = []) {
    let rewardIdx =  spinPiggyStagesCnt[lvIdx]++;

    let prizesValue = escape(JSON.stringify(prizes));
    let prizesShow = prizeListHtml(prizes)
    let html = `
        <tr class="SpinPiggyRewardInfoTr commonStageRewardTr" >
            <td width="120"><input type="text" name="spinPiggyRewardReward[${lvIdx}][stages][${rewardIdx}][id]" class="form-control" value="${rewardIdx+1}" readonly ></td>
            <td>
                <input type="text" class="form-control laydate-item" id="" placeholder="时间选择 " name="spinPiggyRewardReward[${lvIdx}][stages][${rewardIdx}][timeRange]" value="${timeRange}" readonly>
            </td>
            <td>
                <input type="hidden" class="prizeInput" name="spinPiggyRewardReward[${lvIdx}][stages][${rewardIdx}][prizes]" value="${prizesValue}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow">${prizesShow}</td>
        </tr>`;

    $(`#spinPiggyRewardRewardBody_${lvIdx}`).append(html)

    lay('.laydate-item').each(function(){
        laydate.render({
            elem: this ,
            trigger: 'click',
            type: 'datetime',
            range: '~',
            // format : 'yyyy-MM-dd HH:mm:ss ~ yyyy-MM-dd HH:mm:ss'
        });
    });

}

function delSpinPiggyTimeRangeTr(lvIdx) {
    let rows = $(`#spinPiggyRewardRewardBody_${lvIdx}`).find('.SpinPiggyRewardInfoTr')
    if (rows.length > 0){
        $(`#spinPiggyRewardRewardBody_${lvIdx}`).find('.SpinPiggyRewardInfoTr:last').remove()
        spinPiggyStagesCnt[lvIdx]--
    }
}
