let surpriseDiceLvCnt = 0
let surpriseDiceSpinsStages = {}
let surpriseDiceShushuStages = {}
let surpriseDiceProbStages = {}
let surpriseDiceCollectRewardStages = {}
let surpriseDiceScoreStages = {}
let surpriseDiceRewardProStages = {}

function initRewardSurpriseDice() {
    getActBasicConfig(act_type).then(()=>{
        let html = surpriseDiceStageTable();
        $("#reward_info").html(html);

        // 奖励回写
        if (!reward_conf || !activity_extra_data) {
            return
        }

        reward_conf.baseConf && $.each( reward_conf.baseConf,(field,  value)=>{
            $(`input[name="surpriseDiceConf[baseConf][${field}]"]`).val(value)
        })

        reward_conf.stageConf && $.each(reward_conf.stageConf, function (i, o) {
            $('#addSurpriseDiceLvWrapBtn').click()
            $(`input[name="surpriseDiceConf[stageConf][${i}][lvStart]"]`).val(o.lvStart)
            $(`input[name="surpriseDiceConf[stageConf][${i}][lvEnd]"]`).val(o.lvEnd)

            $(`#surpriseDiceLvWrap_${i}`).find('botton').remove()
            $(`#surpriseDiceLvWrap_${i}`).append(`<button class="btn btn-primary asyncLoadConfigBtn" style="" type="button" onclick="asyncLoadSurpriseDiceConfig(${i})">加载配置</button>`)
            $('#submitBtn').hide();

        })
    })


}

function changeTypeToSurpriseDice() {
    getActBasicConfig(act_type).then(()=>{
        let html = surpriseDiceStageTable();
        $("#reward_info").html(html);
    })
}

function surpriseDiceStageTable() {
    return `
        <div class="form-group">
            <h4 style="font-weight: bold" class="text-left">基础配置*:</h4>
            <label class="col-xs-1 control-label">积分基础值:</label>
            <div class="col-sm-1"><input type="number" name="surpriseDiceConf[baseConf][getScore]" value="" class="form-control"></div>
        </div>
        <div class="form-group text-center">
            <h4 style="font-weight: bold" class="text-left">阶段奖励配置*:</h4>
            <button class="btn btn-primary" id="addSurpriseDiceLvWrapBtn" onclick="addSurpriseDiceLvWrap(this)" type="button">添加等级层级</button>
            <button class="btn btn-white"   id="delSurpriseDiceLvWrapBtn" onclick="delSurpriseDiceLvWrap()" type="button">删除等级层级</button>
        </div>
        <hr style=" height:2px;border:none;border-top:2px dotted #0b0;">
    `;
}

function addSurpriseDiceLvWrap(obj) {
    surpriseDiceLvCnt++
    surpriseDiceSpinsStages[surpriseDiceLvCnt] = 0

    let html = `
        <div class="surpriseDiceLvWrap table-border-blue" id="surpriseDiceLvWrap_${surpriseDiceLvCnt}" data-idx="${surpriseDiceLvCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="surpriseDiceConf[stageConf][${surpriseDiceLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="surpriseDiceConf[stageConf][${surpriseDiceLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton class="btn btn-primary addSurpriseDiceSpinsWrapBtn" onclick="addSurpriseDiceSpinsWrap(this)">添加体力层级</botton>
            <botton class="btn btn-danger del-tr delSurpriseDiceSpinsWrapBtn" onclick="delSurpriseDiceSpinsWrap(this)">删除体力层级</botton>
        </div>
`

    $(obj).before(html)
    $('.select2').select2({})
}
function delSurpriseDiceLvWrap() {
    if (surpriseDiceLvCnt < 1) {
        return;
    }
    $('#surpriseDiceLvWrap_' + surpriseDiceLvCnt).remove();
    surpriseDiceLvCnt--;
}

function addSurpriseDiceSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.surpriseDiceLvWrap').data('idx')
    let surpriseDiceSpinsCnt = ++surpriseDiceSpinsStages[lvIdx]
    let spinsIdx = `${lvIdx}_${surpriseDiceSpinsCnt}`
    surpriseDiceShushuStages[spinsIdx] = 0

    let html = `
        <div class="surpriseDiceSpinsWrap table-border-blue" id="surpriseDiceSpinsWrap_${spinsIdx}" data-idx="${surpriseDiceSpinsCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">体力区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${surpriseDiceSpinsCnt}][spinsStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${surpriseDiceSpinsCnt}][spinsEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton class="btn btn-primary addSurpriseDiceShushuWrapBtn" onclick="addSurpriseDiceShushuWrap(this)">添加数数分组层级</botton>
            <botton class="btn btn-danger del-tr delSurpriseDiceShushuWrapBtn" onclick="delSurpriseDiceShushuWrap(this)">删除数数分组层级</botton>
        </div>
    `

    $(obj).before(html)
    $('.select2').select2({})
}
function delSurpriseDiceSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.surpriseDiceLvWrap').data('idx')

    if (surpriseDiceSpinsStages[lvIdx] < 1) return
    $(obj).parents('.surpriseDiceLvWrap').find('.surpriseDiceSpinsWrap:last').remove()
    surpriseDiceSpinsStages[lvIdx]--
}

function addSurpriseDiceShushuWrap(obj) {
    let lvIdx = $(obj).parents('.surpriseDiceLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.surpriseDiceSpinsWrap').data('idx')

    let ssIdx = ++surpriseDiceShushuStages[`${lvIdx}_${spinsIdx}`]

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    surpriseDiceProbStages[rewardIdx] = 0
    surpriseDiceScoreStages[rewardIdx] = 0
    surpriseDiceCollectRewardStages[rewardIdx] = 0

    let arr = JSON.parse($hideSSGroup);

    let optionsHtml = ''
    $.each(arr, function (i, o) {
        optionsHtml += '<option value="' + i + '">' + o + '</option>'
    });

    let html = `
        <div class="surpriseDiceShushuWrap table-border-blue" id="surpriseDiceShushuWrap_${rewardIdx}" data-idx="${ssIdx}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">数数分组 </label>
                <div class="col-sm-3 input-group"> 
                    <select class=" select2" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][shushu][]"  multiple  style="min-width: 100%"> 
                        ${optionsHtml}
                    </select> 
                </div>
            </div> 
            <hr style="border:solid 1px black;">
            
            <div class=" form-inline" style="text-align: left">
                <label class="">入场赠送代币数: 
                 <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][giveToken]"  value="0"></label>
            </div>
<!--            概率配置-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">概率配置: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">#</th> 
                            <th width="100px">倍率</th>
                            <th width="100px">消耗体力值</th> 
                            <th>概率</th>
                        </tr>
                    </thead> 
                    <tbody id="surpriseDiceProbBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="4">
                            <div class="text-center">
                                <botton class="btn btn-primary addSurpriseDiceProbTrBtn" onclick="addSurpriseDiceProbTr(${lvIdx},${spinsIdx},${ssIdx})">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delSurpriseDiceProbTr(${lvIdx},${spinsIdx},${ssIdx})">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
<!--            入场门槛积分配置-->
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">入场门槛积分配置: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="100px">阶段</th>
                            <th>积分</th> 
                        </tr>
                    </thead> 
                    <tbody id="surpriseDiceScoreBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="4">
                            <div class="text-center">
                                <botton class="btn btn-primary addSurpriseDiceProbTrBtn" onclick="addSurpriseDiceScoreTr(${lvIdx},${spinsIdx},${ssIdx})">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delSurpriseDiceScoreTr(${lvIdx},${spinsIdx},${ssIdx})">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
            
                         
        </div>`;

    $(obj).before(html)

    // 奖励配置
    let shushuWrapObj = $(`#surpriseDiceShushuWrap_${rewardIdx}`)
    shushuWrapObj.append(surpriseDiceRewardProConfig(lvIdx, spinsIdx, ssIdx))

    // 收集物配置
    let i = 0
    while(i<=3){
        shushuWrapObj.append(supriseDiceCollectConfig(lvIdx, spinsIdx, ssIdx, i))
        i++
    }

    shushuWrapObj.append(noTokenAlert(rewardIdx, 132))
    $('.select2').select2({})
}
function delSurpriseDiceShushuWrap(obj) {
    let lvIdx = $(obj).parents('.surpriseDiceLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.surpriseDiceSpinsWrap').data('idx')

    if (surpriseDiceShushuStages[`${lvIdx}_${spinsIdx}`] < 1) return
    $(obj).parents('.surpriseDiceSpinsWrap').find('.surpriseDiceShushuWrap:last').remove()
    surpriseDiceShushuStages[`${lvIdx}_${spinsIdx}`]--
}


// 入场概率配置
function addSurpriseDiceProbTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = surpriseDiceProbStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="surpriseDiceProbInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input style="width: 120px" type="number" class="form-control" readonly  value="${rIdx + 1}">
            </td> 
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][bet]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][costSpin]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][betConf][${rIdx}][prob]" value="0">
            </td> 
        </tr> 
    `;

    $('#surpriseDiceProbBody_' + lsrIdx).append(html)
}
function delSurpriseDiceProbTr(lvIdx, spinsIdx, ssIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    surpriseDiceProbStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + surpriseDiceProbStages[rewardIdx]

    if (surpriseDiceProbStages[rewardIdx] < 0) return;
    $('#surpriseDiceProbInfo_' + rewardKey).remove()
}

// 入场积分配置
function addSurpriseDiceScoreTr(lvIdx, spinsIdx, ssIdx) {

    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rIdx = surpriseDiceScoreStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="surpriseDiceScoreInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][joinStageConf][${rIdx}][stageId]" readonly  value="${rIdx + 1}"  style="width: 120px" >
            </td> 
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][joinStageConf][${rIdx}][dst]" value="0">
            </td> 
        </tr> 
    `;

    $('#surpriseDiceScoreBody_' + lsrIdx).append(html)
}
function delSurpriseDiceScoreTr(lvIdx, spinsIdx, ssIdx) {
    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    surpriseDiceScoreStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + surpriseDiceScoreStages[rewardIdx]

    if (surpriseDiceScoreStages[rewardIdx] < 0) return;
    $('#surpriseDiceScoreInfo_' + rewardKey).remove()
}

// 骰子概率与大奖配置
function surpriseDiceRewardProConfig(lvIdx, spinsIdx, ssIdx){
    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    surpriseDiceRewardProStages[rewardIdx] = 0
    let thead = '<tr><th></th>'
    let i = 0;
    while(i<3){
        i++
        thead += `<th  class="text-center" colspan='7'>骰子${i}</th>`
    }
    thead += "<th colspan='4'></th></tr>"
    thead += "<tr>"
    thead += "<th style=''>层数</th>"

    i = 0;
    while(i<3){
        i++
        $.each(actBasicConf[act_type], (i,o)=>{
            thead += `<th style=''>${o}</th>`
        })
    }
    thead += "<th style=''>出大奖所需代币数</th>"
    thead += "<th style=''>退场消耗代币上限</th>"
    thead += "<th style=''>奖励配置</th>"
    thead += "<th style=''>本层大奖</th>"
    thead += "</tr>"
    return `
            <div class="table-border-yellow" style="overflow-x: scroll;">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">骰子面收集物权重及大奖配置: </label>
                </div>
                
                <table class="table table-bordered"  style="min-width: 3000px"> 
                    <thead>
                        ${thead}
                    </thead> 
                    <tbody id="surpriseDiceRewardProBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="26">
                            <div class="text-center">
                                <botton class="btn btn-primary addSurpriseDiceOutsideRewardTrBtn" onclick="addSurpriseDiceRewardProTr(${lvIdx},${spinsIdx},${ssIdx})">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delSurpriseDiceRewardProTr(${lvIdx},${spinsIdx},${ssIdx})">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
    `

}
function addSurpriseDiceRewardProTr(lvIdx, spinsIdx, ssIdx){
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let rewardIdx = surpriseDiceRewardProStages[rewardKey]++
    let  prize = escape('[]')
    let diceTds = '';
    let i = 0;
    while(i<3){
        $.each(actBasicConf[act_type], (diceIdx,o)=>{
            diceTds += `<td>
                 <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][layerConf][${rewardIdx}][weights][${i}][${diceIdx}]" value="0" >
            </td>`
        })
        i++
    }
    let html = `
        <tr  class="commonStageRewardTr" >
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][layerConf][${rewardIdx}][layerId]" value="${rewardIdx+1}" readonly>
            </td>
            ${diceTds}
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][layerConf][${rewardIdx}][passNeedCost]" value="0" >
            </td>
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][layerConf][${rewardIdx}][exitNeedCost]" value="0" >
            </td>
            <td>
                <input type="hidden" class="prizeInput" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][layerConf][${rewardIdx}][goldPrize]" value="${prize}" >
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow">
            </td>
        </tr>
    `
    $(`#surpriseDiceRewardProBody_${rewardKey}`).append(html)
}
function delSurpriseDiceRewardProTr(lvIdx, spinsIdx, ssIdx){

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    if(surpriseDiceRewardProStages[rewardKey]<1)return
    surpriseDiceRewardProStages[rewardKey]--
    $(`#surpriseDiceRewardProBody_${rewardKey}`).find('.commonStageRewardTr:last').remove()
}

// 收集物配置
function supriseDiceCollectConfig(lvIdx, spinsIdx, ssIdx, cIdx){
    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}_${cIdx}`
    surpriseDiceCollectRewardStages[lsrIdx] = 0
    return `
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">进度条${cIdx + 1}: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">阶段</th> 
                            <th width="100px">阶段值</th> 
                            <th width="100px">奖励设置</th>
                            <th>奖品</th> 
                        </tr>
                    </thead> 
                    <tbody id="surpriseDiceCollectRewardBody_${lsrIdx}"> </tbody>
                    <tr>
                        <td colspan="5">
                            <div class="text-center">
                                <botton class="btn btn-primary addSurpriseDiceOutsideRewardTrBtn" onclick="addSurpriseDiceCollectRewardTr(${lvIdx},${spinsIdx},${ssIdx},${cIdx})">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delSurpriseDiceCollectRewardTr(${lvIdx},${spinsIdx},${ssIdx},${cIdx})">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
`;
}
function addSurpriseDiceCollectRewardTr(lvIdx, spinsIdx, ssIdx, cIdx) {

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let lsrIdx = `${lvIdx}_${spinsIdx}_${ssIdx}_${cIdx}`
    let rIdx = surpriseDiceCollectRewardStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}_${rIdx}`
    let prize = escape('[]')
    let html = `
        <tr id="surpriseDiceInsideRewardInfo_${rewardKey}" class="commonStageRewardTr" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][collectConf][${cIdx}][${rIdx}][stageId]" value="${rIdx+1}" readonly>
            </td> 
            <td>
                <input type="number" class="form-control" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][collectConf][${cIdx}][${rIdx}][dst]" value="0">
            </td> 
            <td>
                <input type="hidden" class="prizeInput" name="surpriseDiceConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][collectConf][${cIdx}][${rIdx}][prize]" value="${prize}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
            <td class="prizeShow"></td>
        </tr> 
    `;

    $(`#surpriseDiceCollectRewardBody_${rewardIdx}_${cIdx}`).append(html)
}
function delSurpriseDiceCollectRewardTr(lvIdx, spinsIdx, ssIdx, cIdx) {

    let lssKey = `${lvIdx}_${spinsIdx}_${ssIdx}`
    let lssrKey = `${lssKey}_${cIdx}`
    if(surpriseDiceCollectRewardStages[lssrKey]<1)return
    surpriseDiceCollectRewardStages[lssrKey]--
    $(`#surpriseDiceCollectRewardBody_${lssrKey}`).find('tr:last').remove()

}

function asyncLoadSurpriseDiceConfig(i){
    let o = reward_conf.stageConf[i]
    console.log(o)
    $(`#surpriseDiceLvWrap_${i}`).find('hr').after(`
            <botton class="btn btn-primary addSurpriseDiceSpinsWrapBtn" onclick="addSurpriseDiceSpinsWrap(this)">添加体力层级</botton>
            <botton class="btn btn-danger del-tr delSurpriseDiceSpinsWrapBtn" onclick="delSurpriseDiceSpinsWrap(this)">删除体力层级</botton>
`)
    $(`#surpriseDiceLvWrap_${i}`).find('.asyncLoadConfigBtn').remove()
    $.each(o.stages, function (i1, o1) {
        $('.addSurpriseDiceSpinsWrapBtn:last').click()
        $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][spinsStart]"]`).val(o1.spinsStart)
        $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][spinsEnd]"]`).val(o1.spinsEnd)
        $.each(o1.stages, function (i2, o2) {
            $('.addSurpriseDiceShushuWrapBtn:last').click()
            $(`select[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][shushu][]"]`).val(o2.shushu)
            $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][giveToken]"]`).val(o2.giveToken)

            o2['betConf'] && $.each(o2['betConf'], function (k, v) {
                addSurpriseDiceProbTr(i, i1, i2)
                $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][bet]"]`).val(v.bet)
                $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][costSpin]"]`).val(v.costSpin)
                $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][betConf][${k}][prob]"]`).val(v.prob)
            })

            o2['joinStageConf'] && $.each(o2['joinStageConf'], function (k, v) {
                addSurpriseDiceScoreTr(i, i1, i2)
                $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][joinStageConf][${k}][stageId]"]`).val(v.stageId)
                $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][joinStageConf][${k}][dst]"]`).val(v.dst)
            })

            o2.layerConf && $.each(o2.layerConf, function (k, v) {
                addSurpriseDiceRewardProTr(i,i1,i2)
                console.log(v);
                let prizeInput = $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][layerConf][${k}][goldPrize]"]`)
                $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][layerConf][${k}][exitNeedCost]"]`).val(v.exitNeedCost)
                $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][layerConf][${k}][passNeedCost]"]`).val(v.passNeedCost)
                prizeInput.val(escape(JSON.stringify(v.goldPrize)))
                prizeInput.parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(v.goldPrize))
                v.weights && $.each(v.weights, (didx, diceWeights)=>{
                    $.each(diceWeights, (dridx, weight)=>{
                        $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][layerConf][${k}][weights][${didx}][${dridx}]"]`).val(weight)
                    })
                })
            })

            o2.collectConf && $.each(o2.collectConf, function (cid, v) {
                $.each(v,(crid, citem)=>{
                    addSurpriseDiceCollectRewardTr(i,i1,i2, cid)
                    $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][collectConf][${cid}][${crid}][dst]"]`).val(citem.dst)
                    let prizeInput = $(`input[name="surpriseDiceConf[stageConf][${i}][stages][${i1}][stages][${i2}][collectConf][${cid}][${crid}][prize]"]`)
                    prizeInput.val(escape(JSON.stringify(citem.prize)))
                    prizeInput.parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(citem.prize))
                })

            })


            renderNotokenAlert(`${i}_${i1}_${i2}`, reward_pro)
        })
    })

    $('.select2').select2({})
    updateSubmitBtnStatus()
}