
<link rel="stylesheet" href="<?php echo base_url();?>public/js/bootstrap/bootstrap.min.css">
<script src="<?php echo base_url();?>public/js/vendor/jquery.min.js"></script>
<link rel="stylesheet" href="/public/node_modules/bootstrap-select/dist/css/bootstrap-select.min.css">
<script src="/public/node_modules/bootstrap-select/dist/js/bootstrap-select.min.js"></script>
<!-- 引入 layui 组件 -->
<link rel="stylesheet" href="/static/layer/dist/theme/default/layer.css">
<script src="/static/layer/dist/layer.js"></script>


<!-- Select2 -->
<link rel="stylesheet" href="<?php echo base_url();?>public/js/vendor/select2/select2.min.css">
<script src="<?php echo base_url();?>public/js/vendor/select2/select2.full.min.js"></script>

<div class="content_wrapper">
    <div class="container-fluid">

        <input name="id" class="form-control col-sm-8 " type="hidden" value="<?=$avatar['avatar_id']?>">
        <div class="form-group">
            <label class="col-cm-2" style="text-align: right">头像框名</label>
            <input name="name" class="form-control col-sm-8 " value="<?=$avatar['name']?>">
        </div>
        <div class="form-group">
            <label class="col-cm-2" style="text-align: right">头像框类型</label>
            <select name="type" class="select2 form-control" onchange="typeChanged(this)">
                <?php foreach ($avatarTypes as $type => $text){?>
                    <option <?php if( $type == $avatar['type'] ){echo 'selected';}?> value="<?=$type?>"><?=$text?></option>
                <?php } ?>
            </select>
        </div>

        <div class="form-group themeIdSelector" >
            <label class="col-cm-2" style="text-align: right">关联限时主题</label>
            <select name="theme_id" class="select2 form-control" >
                <option  value="0">关联限时主题</option>
                <?php foreach ($themeList as $themeId => $themeName){?>
                    <option <?php if( $themeId == $avatar['theme_id'] ){echo 'selected';}?> value="<?=$themeId?>"><?=$themeName?></option>
                <?php } ?>
            </select>
        </div>
        <div class="form-group">
            <label class="col-cm-2" style="text-align: right">是否激活</label>
            <select name="active" class="select2 form-control" >
                <?php foreach ($statusMap as $status => $text){?>
                    <option <?php if( $status == $avatar['active'] ){echo 'selected';}?> value="<?=$status?>"><?=$text?></option>
                <?php } ?>
            </select>
        </div>
        <div class="form-group">
            <label class="col-cm-2" style="text-align: right">是否随机</label>
            <select name="is_random" class="select2 form-control" >
                <?php foreach ($randomMap as $status => $text){?>
                    <option <?php if( $status == $avatar['is_random'] ){echo 'selected';}?> value="<?=$status?>"><?=$text?></option>
                <?php } ?>
            </select>
        </div>
        <div class="form-group" style="text-align: center">
            <button type="button" onclick="submitForm()" class=" btn btn-info" style="text-align: right">提交</button>
        </div>
    </div>
</div>
<script>
    var typeTheme = '<?php echo AvatarBox::AVATAR_TYPE_THEME;?>'
    if($('select[name=type]').val() != typeTheme ){
        $('.themeIdSelector').hide()
    }
    function typeChanged(obj) {
        var type = $(obj).val()
        console.log(type)
        if(type != typeTheme){
            $('select[name=theme_id]').val(0)
            $('.themeIdSelector').hide()
        }else{
            $('.themeIdSelector').show()
        }
    }
    // $('.select2').select2({})
    function submitForm() {
        parent.showLoading()
        var data = {
            id:$('input[name=id]').val(),
            name:$('input[name=name]').val(),
            type:$('select[name="type"]').val(),
            theme_id:$('select[name="theme_id"]').val(),
            active:$('select[name="active"]').val(),
            is_random:$('select[name="is_random"]').val(),
        };
        if(!data.name){
            parent.hideLoading()
            layer.alert('头像框名称必填')
            return;
        }
        if(data.type == typeTheme && (!data.theme_id || data.theme_id < 1) ){
            parent.hideLoading()
            layer.alert('限时主题头像框必须关联限时卡组主题')
            return;
        }

        $.post('/avatarBox/saveAvatarBox',data, function(res ){
            parent.hideLoading()
            console.log(res)
            if(typeof res == 'string')res = JSON.parse(res)
            layer.alert(res.msg,function(index){
                layer.close(index);
                if(res.ret == 1){
                    parent.location.reload()
                }
            })

        })
    }
</script>