<link rel="stylesheet" href="/public/node_modules/bootstrap-select/dist/css/bootstrap-select.min.css">
<script src="/public/node_modules/bootstrap-select/dist/js/bootstrap-select.min.js"></script>
<!--<script type="text/javascript" src="/public/node_modules/bootstrap-multiselect/dist/js/bootstrap-multiselect.js"></script>-->
<!--<link rel="stylesheet" href="/public/node_modules/bootstrap-multiselect/dist/css/bootstrap-multiselect.css" type="text/css"/>-->

<link rel="stylesheet" href="<?php echo base_url();?>public/css/vendor/bootstrap/bootstrap-table.css">
<link rel="stylesheet" href="<?php echo base_url();?>public/css/vendor/bootstrap/table-fix-column.css">

<script src="<?php echo base_url();?>public/js/vendor/bootstrap/src/bootstrap-table.js"></script>
<script src="<?php echo base_url();?>public/js/vendor/bootstrap/src/table-fix-column.js"></script>

<style type="text/css">
    table {
        table-layout:fixed !important;
    }

    th{
        background: rgb(146, 208, 80);
    }

    td,th{
        /*max-width: 400px;*/
        word-wrap: break-word;
    }
    /*
    .fixed-table-header .table{
        height: 100px;
    }
    */

    table{
        table-layout:auto !important;
    }

    .table-hover > tbody > tr:hover {
        background-color: #c8bd6d;
    }

    input {
        width:60px;
    }

    #roleTable tr:nth-child(5n){
        /*background:rgb(198, 239, 206);*/
    } /**隔五行*/

    .fixed-table-toolbar {
        display: none;
    }
    .fileinput-button {
        position: relative;
        top: -5px;
    }

    .fileinput-button input{
        position:absolute;
        right: 0px;
        top: 0px;
        opacity: 0;
        -ms-filter: 'alpha(opacity=0)';
    }
    #reportBody tr td:nth-child(6),#reportBody tr td:nth-child(11),#reportBody tr td:nth-child(12),#reportBody tr td:nth-child(15){
        color:red !important;
    }
    .fixed-table-body{
        /*overflow-x: visible;*/
        /*overflow-y: visible;*/
        /*height: auto;*/
    }
    .fixed-table-header{
        /*display: none;*/
        /*overflow:visible;*/
    }
    img{
        max-height: 100px;
    }
</style>

<div class="content_wrapper">
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i><?php echo $title; ?></header>
                    <section>
                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-12">
                                    <form class="form-inline" role="form" method="POST" action="" name="stanpform">
                                        <span class="gap"></span>
                                        <div class="form-group">
                                            <label>UID</label>
                                            <input type="text" class="form-control " value="<?=$uid?>" placeholder="UID" name="uid" />
                                        </div>
                                        <span class="gap"></span>
                                        <button type="submit" class="btn btn-primary">查询</button>
                                        <button type="button" class="btn btn-success" data-href="<?=$exportUrl?>" onclick="show(this)">导出</button>
                                    </form>

                                </div>
                            </div>

                        </div>
                    </section>
                </aside>
            </div>
        </div>
        <div class="row hide" >
            <div class="col-sm-12">
                <aside>
                    <a href="#adjuststa/dayReport2/<?php echo $type; ?>/DESC" class="btn btn-success" target="_self">日期降序</a>
                    <a href="#adjuststa/dayReport2/<?php echo $type; ?>/ASC" class="btn btn-success" target="_self">日期升序</a>
                </aside>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <div class="table-responsive">
                        <table id="roleTable" class="table table-bordered table-hover"data-height="700">
                            <thead>
                            <tr>
                                <?php
                                    foreach($headerTable as $key => $head){
                                        echo '<th>'.$head['name'].'</th>';
                                    }
                                ?>
                            </tr>
                            </thead>
                            <tbody id="reportBody">
                            <?php foreach ( $list as  $row) { ?>
                            <tr>
                                <?php foreach ( $headerTable as $k => $head) {?>
                                    <td style="text-align: center;vertical-align: middle;width:200px;">
                                        <?php
                                            switch ($head['type']){
                                                case 'image':echo "<img src='/{$row[$k]}'>" ;break;
                                                default: echo $row[$k] ?? '-';break;
                                            }
                                        ?>
                                    </td>
                                <?php }?>
                            </tr>
                            <?php }?>
                            </tbody>
                        </table>
                    </div>
                </aside>
            </div>
        </div>


    </div>
</div>
</div>
<script src="<?php echo base_url();?>public/js/common.js"></script>
<script>
    $('.selectpicker').on('changed.bs.select',function(e){
        console.log($(this).parents('.form-group').find('.formValue'))
        $(this).parents('.form-group').find('.formValue').val($(this).val())
    });
    function show(obj){
        var url = $(obj).data('href')
        if(!url){
            alert('导出链接未配置！')
            return;
        }
        window.open(url)
    }
</script>
<script type="text/javascript">

        //选择日期
        $('.datetimepicker').datepicker({
            language:'zh-CN',
            format:'yyyy-mm-dd',
            autoclose:true,
            zIndexOffset:906  //控制z-index
        });


</script>