<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>修改活动</title>
    <!-- 最新版本的 Bootstrap 核心 CSS 文件 -->
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/js/bootstrap/bootstrap.min.css">
    <link rel="stylesheet"
          href="<?php echo base_url(); ?>public/js/vendor/bootstrap-datepicker/css/bootstrap-datepicker.standalone.min.css">
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/css/jquery.timepicker.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/js/vendor/select2/select2.min.css">

    <style type="text/css">
        .thumbnail {
            margin: 10px;
        }

        .lang-name {
            margin-left: 42px;
        }

        .upimg {
            cursor: pointer;
        }

    </style>
</head>

<body>
<div class="content_wrapper">
    <div id="msg-tip"></div>
    <div class="container-fluid">
        <aside>
            <form class="form-horizontal" role="form" method="post" enctype="multipart/form-data" id="goodForm"
                  action="#" style="margin-top: 20px">
                <header><i class="fa fa-fw fa-file"></i>首充礼包配置</header>
                <section>
                    <div class="container-fluid">
                        <div class="row">
                            <div class="col-sm-12">
                                <button type="button" class="btn btn-success" id="goodsSubmitBtn">提交</button>
                            </div>
                        </div>
                    </div>
                    <div class="container-fluid">
                        <?php foreach ($shopList as $key => $vl) { ?>
                            <div class="row AllTypeControl"
                                 style="border: 1px solid #CCC;margin:10px 5px;padding: 5px 0;">
                                <div class="form-group">
                                    <label class="col-sm-1 control-label">商品GID*: </label>
                                    <div class="col-sm-1">
                                        <input type="text" class="form-control" readonly
                                               name="good[<?php echo $vl['id']; ?>][gid]"
                                               value="<?php echo $vl['gid']; ?>">
                                    </div>
                                    <label class="col-sm-1 control-label">等级下限*: </label>
                                    <div class="col-sm-1">
                                        <input type="number" class="form-control"
                                               name="good[<?php echo $vl['id']; ?>][min_level]"
                                               value="<?php echo $vl['min_level']; ?>">
                                    </div>
                                    <label class="col-sm-1 control-label">等级上限*: </label>
                                    <div class="col-sm-1">
                                        <input type="number" class="form-control"
                                               name="good[<?php echo $vl['id']; ?>][max_level]"
                                               value="<?php echo $vl['max_level']; ?>">
                                    </div>
                                    <label class="col-sm-2 control-label">存在时间（小时）*: </label>
                                    <div class="col-sm-1">
                                        <input type="number" class="form-control"
                                               name="good[<?php echo $vl['id']; ?>][life_time]"
                                               value="<?php echo $vl['life_time']; ?>">
                                    </div>
                                    <label class="col-sm-1 control-label">商品折扣*: </label>
                                    <div class="col-sm-1">
                                        <input type="number" class="form-control"
                                               name="good[<?php echo $vl['id']; ?>][discount]"
                                               value="<?php echo $vl['discount']; ?>">
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-1 control-label">商品More*: </label>
                                    <div class="col-sm-1">
                                        <input type="number" class="form-control"
                                               name="good[<?php echo $vl['id']; ?>][addRatio]"
                                               value="<?php echo json_decode($vl['other_json'], true)['addRatio'] ?? 0; ?>">
                                    </div>
                                    <label class="col-sm-1 control-label">配图*: </label>
                                    <div class="col-sm-1">
                                        <select class="form-control" name="good[<?php echo $vl['id']; ?>][skin_dir]">
                                            <?php foreach ($imgSkinList as $k1 => $v1) { ?>
                                                <option value="<?php echo $k1; ?>" <?php if ($vl['skin_dir'] == $k1) echo 'selected'; ?>><?php echo $v1; ?></option>
                                            <?php } ?>
                                        </select>
                                    </div>
                                    <label class="col-sm-1 control-label">上下架*: </label>
                                    <div class="col-sm-1">
                                        <select class="form-control" name="good[<?php echo $vl['id']; ?>][status]">
                                            <option value="0" <?php if ($vl['status'] == 0) echo 'selected'; ?>>下架
                                            </option>
                                            <option value="1" <?php if ($vl['status'] == 1) echo 'selected'; ?>>上架
                                            </option>
                                        </select>
                                    </div>
                                    <label class="col-sm-2 control-label">商品价格（美元）*: </label>
                                    <div class="col-sm-1">
                                        <select class="form-control" name="good[<?php echo $vl['id']; ?>][price]">
                                            <?php foreach ($skuList as $oneSku) { ?>
                                                <option value="<?php echo $oneSku['price']; ?>" <?php if ($vl['price'] == $oneSku['price']) echo 'selected'; ?>><?php echo $oneSku['price']; ?></option>
                                            <?php } ?>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-1 control-label">奖励:</label>
                                    <div class="col-sm-10">
                                        <label class="select-inline">
                                            <table class="col-sm-12">
                                                <tr>
                                                    <td class="formPropsRewardsTag" data-value='<?php echo $vl['prize_json']; ?>'></td>
                                                    <td class="text-right">
                                                        <button type="button"
                                                                class="btn btn-outline btn-success"
                                                                onclick="propsJs.initEdit(this, 'formPropsRewardsTag')">
                                                            奖励配置
                                                        </button>
                                                    </td>
                                                </tr>
                                            </table>
                                        </label>
                                    </div>
                                </div>
                            </div>
                        <?php } ?>
                    </div>
                </section>
            </form>
        </aside>
    </div>
</div>
</body>
<script src="<?php echo base_url(); ?>public/js/common.js"></script>

<script>
    var msgTip = $('#msg-tip');
    propsJs.initTag('formPropsRewardsTag')

    $(function () {
        $('#goodsSubmitBtn').click(function () {
            const data = $('#goodForm').toObject()
            const NodeArr = $('.formPropsRewardsTag')

            data['img_name'] = 'firstPay'

            let idx = 0;
            for (const dataKey in data['good']) {
                data['good'][dataKey]['prize_json'] = $(NodeArr[idx]).data('value')
                idx++
            }
            $.ajax({
                url: rootPath + 'newShop/firstPayGoodsUpdate',
                type: 'POST',
                data: data,
                dataType: 'json',
                success: function (data) {
                    msgTip.messager().success(data.msg);
                    // confirm(data.msg);
                    window.location.reload();
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });


        $('#goodsAddBtn2').click(function () {
            var data = new FormData($("#addGoods")[0]);
            data.append('img_name', 'firstPay')

            $.ajax({
                url: rootPath + 'newShop/firstPayGoodsAdd',
                type: 'POST',
                data: data,
                dataType: 'json',
                contentType: false, //必须
                processData: false, //必须
                success: function (data) {
                    alert(data.msg);
                    // confirm(data.msg);
                    window.location.reload();
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

    });
</script>