let collectActCouponLvCnt = 0
let collectActCouponYStages = {}
let collectActCouponShushuStages = {}
let collectActCouponProbStages = {}
let collectActCouponOutsideRewardStages = {}
let collectActCouponInsideRewardStages = {}
let collectActCouponTaskStages = {}
let collectActCouponTaskTypeOptionHtml = ""

function initReward_collectActCoupon(type) {
    console.log('init ' + type)
    changeTypeTo_collectActCoupon()

    // 奖励回写
    const extra_data = JSON.parse(extraData)
    console.log('reward_conf', reward_conf)
    console.log('extra_data', extra_data)

    if (!reward_conf || !extra_data) {
        return
    }

    for (const field in reward_conf) {
        $(`input[name="collectActCouponConf[baseConf][${field}]"]`).val(reward_conf[field])
    }

    $.each(extra_data, function (i, o) {
        $('#addCollectActCouponLvWrapBtn').click()
        $(`input[name="collectActCouponConf[stageConf][${i}][lvStart]"]`).val(o.lvStart)
        $(`input[name="collectActCouponConf[stageConf][${i}][lvEnd]"]`).val(o.lvEnd)
        $.each(o.stages, function (i1, o1) {
            $('.addCollectActCouponYWrapBtn:last').click()
            $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][yStart]"]`).val(o1.yStart)
            $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][yEnd]"]`).val(o1.yEnd)
            $.each(o1.stages, function (i2, o2) {
                $('.addCollectActCouponShushuWrapBtn:last').click()
                $(`select[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][shushu][]"]`).val(o2.shushu)

                o2.stages['betConf'] && $.each(o2.stages['betConf'], function (k, v) {
                    $('.addCollectActCouponProbTrBtn:last').click()
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][betConf][${k}][bet]"]`).val(v.bet)
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][betConf][${k}][costSpin]"]`).val(v.costSpin)
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][betConf][${k}][prob]"]`).val(v.prob)
                })
                o2.stages['stageConfOutside'] && $.each(o2.stages['stageConfOutside'], function (k, v) {
                    $('.addCollectActCouponOutsideRewardTrBtn:last').click()
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][stageConfOutside][${k}][stageId]"]`).val(v.stageId)
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][stageConfOutside][${k}][dst]"]`).val(v.dst)
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][stageConfOutside][${k}][prize]"]`).val(escape(JSON.stringify(v.prize)))
                    let prizeHtml = ''
                    $.each(v.prize, function (i, prize) {
                        prizeHtml += chestPropsHtml(prize)
                    })
                    $('.prizeShow:last').html(prizeHtml)
                })
                o2.stages['stageConfInside'] && $.each(o2.stages['stageConfInside'], function (k, v) {
                    $('.addCollectActCouponInsideRewardTrBtn:last').click()
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][stageConfInside][${k}][stageId]"]`).val(v.stageId)
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][stageConfInside][${k}][dst]"]`).val(v.dst)
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][stageConfInside][${k}][prize]"]`).val(escape(JSON.stringify(v.prize)))
                    let prizeHtml = ''
                    $.each(v.prize, function (i, prize) {
                        prizeHtml += chestPropsHtml(prize)
                    })
                    $('.prizeShow:last').html(prizeHtml)
                })
                o2.stages['taskConf'] && $.each(o2.stages['taskConf'], function (k, v) {
                    $('.addCollectActCouponTaskTrBtn:last').click()
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][taskConf][${k}][taskId]"]`).val(v.taskId)
                    $(`select[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][taskConf][${k}][taskType]"]`).val(v.taskType)
                    $(`input[name="collectActCouponConf[stageConf][${i}][stages][${i1}][stages][${i2}][stages][taskConf][${k}][score]"]`).val(v.score)
                })
            })
        })
    })
}

function changeTypeTo_collectActCoupon() {
    collectActCouponLvCnt = 0
    collectActCouponYStages = {}
    collectActCouponShushuStages = {}
    collectActCouponProbStages = {}
    collectActCouponOutsideRewardStages = {}
    collectActCouponInsideRewardStages = {}
    collectActCouponTaskStages = {}

    const TaskTypeMap = {1: "完成一关", 2: "到达奖励关", 3: "开出障碍物", 4: "复活一次", 5: "通关一次"}

    collectActCouponTaskTypeOptionHtml = ""
    $.each(TaskTypeMap, function (k, v) {
        collectActCouponTaskTypeOptionHtml += `<option value="${k}">${v}</option>`;
    });
    console.log(collectActCouponTaskTypeOptionHtml)

    $('#reward_info').empty()
    let html = collectActCouponStageTable();
    $("#reward_info").append(html);
}

function collectActCouponStageTable() {
    return `
        <div class="form-group">
            <h4 style="font-weight: bold" class="text-left">基础配置*:</h4>
            <label class="col-xs-1 control-label">积分基础值:</label>
            <div class="col-sm-1"><input type="number" name="collectActCouponConf[baseConf][getScore]" value="" class="form-control"></div>
            <label class="col-xs-1 control-label">体力系数:</label>
            <div class="col-sm-1"><input type="number" name="collectActCouponConf[baseConf][spinsRatio]" value="" class="form-control"></div>
        </div>
        <div class="form-group text-center">
            <h4 style="font-weight: bold" class="text-left">阶段奖励配置*:</h4>
            <button class="btn btn-primary" id="addCollectActCouponLvWrapBtn" onclick="addCollectActCouponLvWrap(this)" type="button">添加等级层级</button>
            <button class="btn btn-white"   id="delCollectActCouponLvWrapBtn" onclick="delCollectActCouponLvWrap()" type="button">删除等级层级</button>
        </div>
        <hr style=" height:2px;border:none;border-top:2px dotted #0b0;">
    `;
}

function addCollectActCouponLvWrap(obj) {
    collectActCouponLvCnt++
    collectActCouponYStages[collectActCouponLvCnt] = 0

    let html = `
        <div class="collectActCouponLvWrap table-border-blue" id="collectActCouponLvWrap_${collectActCouponLvCnt}" data-idx="${collectActCouponLvCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="collectActCouponConf[stageConf][${collectActCouponLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="collectActCouponConf[stageConf][${collectActCouponLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton class="btn btn-primary addCollectActCouponYWrapBtn" onclick="addCollectActCouponYWrap(this)">添加Y值层级</botton>
            <botton class="btn btn-danger del-tr delCollectActCouponYWrapBtn" onclick="delCollectActCouponYWrap(this)">删除Y值层级</botton>
        </div>
`

    $(obj).before(html)
    $('.select2').select2({})
}

function addCollectActCouponYWrap(obj) {
    let lvIdx = $(obj).parents('.collectActCouponLvWrap').data('idx')
    let collectActCouponYCnt = ++collectActCouponYStages[lvIdx]
    let yIdx = `${lvIdx}_${collectActCouponYCnt}`
    collectActCouponShushuStages[yIdx] = 0

    let html = `
        <div class="collectActCouponYWrap table-border-blue" id="collectActCouponYWrap_${yIdx}" data-idx="${collectActCouponYCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">Y值区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${collectActCouponYCnt}][yStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${collectActCouponYCnt}][yEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton class="btn btn-primary addCollectActCouponShushuWrapBtn" onclick="addCollectActCouponShushuWrap(this)">添加数数分组层级</botton>
            <botton class="btn btn-danger del-tr delCollectActCouponShushuWrapBtn" onclick="delCollectActCouponShushuWrap(this)">删除数数分组层级</botton>
        </div>
    `

    $(obj).before(html)
    $('.select2').select2({})
}


function addCollectActCouponShushuWrap(obj) {
    let lvIdx = $(obj).parents('.collectActCouponLvWrap').data('idx')
    let yIdx = $(obj).parents('.collectActCouponYWrap').data('idx')

    let ssIdx = ++collectActCouponShushuStages[`${lvIdx}_${yIdx}`]

    let rewardIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    collectActCouponProbStages[rewardIdx] = 0
    collectActCouponOutsideRewardStages[rewardIdx] = 0
    collectActCouponInsideRewardStages[rewardIdx] = 0
    collectActCouponTaskStages[rewardIdx] = 0

    let arr = JSON.parse($hideSSGroup);

    let optionsHtml = ''
    $.each(arr, function (i, o) {
        optionsHtml += '<option value="' + i + '">' + o + '</option>'
    });

    let html = `
        <div class="collectActCouponShushuWrap table-border-blue" id="collectActCouponShushuWrap_${rewardIdx}" data-idx="${ssIdx}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">数数分组 </label>
                <div class="col-sm-3 input-group"> 
                    <select class=" select2" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][shushu][]"  multiple  style="min-width: 100%"> 
                        ${optionsHtml}
                    </select> 
                </div>
            </div> 
            <hr style="border:solid 1px black;">
            
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">概率配置: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">#</th> 
                            <th>倍率</th>
                            <th>消耗体力值</th> 
                            <th>概率</th>
                        </tr>
                    </thead> 
                    <tbody id="collectActCouponProbBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="4">
                            <div class="text-center">
                                <botton class="btn btn-primary addCollectActCouponProbTrBtn" onclick="addCollectActCouponProbTr(this)">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delCollectActCouponProbTr(this)">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">顶部进度条: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">阶段</th> 
                            <th>阶段值</th> 
                            <th>奖品</th> 
                            <th>奖励设置</th>
                        </tr>
                    </thead> 
                    <tbody id="collectActCouponOutsideRewardBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="5">
                            <div class="text-center">
                                <botton class="btn btn-primary addCollectActCouponOutsideRewardTrBtn" onclick="addCollectActCouponOutsideRewardTr(this)">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delCollectActCouponOutsideRewardTr(this)">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">底部进度条: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">阶段</th> 
                            <th>阶段值</th> 
                            <th>奖品</th> 
                            <th>奖励设置</th>
                        </tr>
                    </thead> 
                    <tbody id="collectActCouponInsideRewardBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="5">
                            <div class="text-center">
                                <botton class="btn btn-primary addCollectActCouponInsideRewardTrBtn" onclick="addCollectActCouponInsideRewardTr(this)">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delCollectActCouponInsideRewardTr(this)">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div class="table-border-yellow">
                <div class="form-group">
                    <label class="col-sm-1 control-label m-b">四选一任务: </label>
                </div>
                <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">#</th> 
                            <th>任务类型</th> 
                            <th>获得经验(每次)</th> 
                        </tr>
                    </thead> 
                    <tbody id="collectActCouponTaskBody_${rewardIdx}"> </tbody>
                    <tr>
                        <td colspan="5">
                            <div class="text-center">
                                <botton class="btn btn-primary addCollectActCouponTaskTrBtn" onclick="addCollectActCouponTaskTr(this)">添加</botton>
                                <botton class="btn btn-danger del-tr" onclick="delCollectActCouponTaskTr(this)">删除</botton> 
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>`;

    $(obj).before(html)
    $('.select2').select2({})
}


function delCollectActCouponLvWrap() {
    if (collectActCouponLvCnt < 1) {
        return;
    }
    $('#collectActCouponLvWrap_' + collectActCouponLvCnt).remove();
    collectActCouponLvCnt--;
}

function delCollectActCouponYWrap(obj) {
    let lvIdx = $(obj).parents('.collectActCouponLvWrap').data('idx')

    if (collectActCouponYStages[lvIdx] < 1) return
    $(obj).parents('.collectActCouponLvWrap').find('.collectActCouponYWrap:last').remove()
    collectActCouponYStages[lvIdx]--
}

function delCollectActCouponShushuWrap(obj) {
    let lvIdx = $(obj).parents('.collectActCouponLvWrap').data('idx')
    let yIdx = $(obj).parents('.collectActCouponYWrap').data('idx')

    if (collectActCouponShushuStages[`${lvIdx}_${yIdx}`] < 1) return
    $(obj).parents('.collectActCouponYWrap').find('.collectActCouponShushuWrap:last').remove()
    collectActCouponShushuStages[`${lvIdx}_${yIdx}`]--
}


function getParentIdx(obj) {
    let lvIdx = $(obj).parents('.collectActCouponLvWrap').data('idx')
    let yIdx = $(obj).parents('.collectActCouponYWrap').data('idx')
    let ssIdx = $(obj).parents('.collectActCouponShushuWrap').data('idx')

    return {lvIdx, yIdx, ssIdx}
}

function addCollectActCouponProbTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let lsrIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    let rIdx = collectActCouponProbStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${yIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="collectActCouponProbInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input style="width: 120px" type="number" class="form-control" readonly  value="${rIdx + 1}">
            </td> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][betConf][${rIdx}][bet]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][betConf][${rIdx}][costSpin]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][betConf][${rIdx}][prob]" value="0">
            </td> 
        </tr> 
    `;

    $('#collectActCouponProbBody_' + lsrIdx).append(html)
}

function delCollectActCouponProbTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let rewardIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    collectActCouponProbStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + collectActCouponProbStages[rewardIdx]

    if (collectActCouponProbStages[rewardIdx] < 0) return;
    $('#collectActCouponProbInfo_' + rewardKey).remove()
}

function addCollectActCouponOutsideRewardTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let lsrIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    let rIdx = collectActCouponOutsideRewardStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${yIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="collectActCouponOutsideRewardInfo_${rewardKey}" class="commonStageRewardTr" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][stageConfOutside][${rIdx}][stageId]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][stageConfOutside][${rIdx}][dst]" value="0">
            </td> 
            <td class="prizeShow"></td>
            <td>
                <input type="hidden" class="prizeInput" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][stageConfOutside][${rIdx}][prize]" value="{}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
        </tr> 
    `;

    $('#collectActCouponOutsideRewardBody_' + lsrIdx).append(html)
}

function delCollectActCouponOutsideRewardTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let rewardIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    collectActCouponOutsideRewardStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + collectActCouponOutsideRewardStages[rewardIdx]

    if (collectActCouponOutsideRewardStages[rewardIdx] < 0) return;
    $('#collectActCouponOutsideRewardInfo_' + rewardKey).remove()
}

function addCollectActCouponInsideRewardTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let lsrIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    let rIdx = collectActCouponInsideRewardStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${yIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="collectActCouponInsideRewardInfo_${rewardKey}" class="commonStageRewardTr" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][stageConfInside][${rIdx}][stageId]" value="0">
            </td> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][stageConfInside][${rIdx}][dst]" value="0">
            </td> 
            <td class="prizeShow"></td>
            <td>
                <input type="hidden" class="prizeInput" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][stageConfInside][${rIdx}][prize]" value="{}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
        </tr> 
    `;

    $('#collectActCouponInsideRewardBody_' + lsrIdx).append(html)
}

function delCollectActCouponInsideRewardTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let rewardIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    collectActCouponInsideRewardStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + collectActCouponInsideRewardStages[rewardIdx]

    if (collectActCouponInsideRewardStages[rewardIdx] < 0) return;
    $('#collectActCouponInsideRewardInfo_' + rewardKey).remove()
}


function addCollectActCouponTaskTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let lsrIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    let rIdx = collectActCouponTaskStages[lsrIdx]++

    let rewardKey = `${lvIdx}_${yIdx}_${ssIdx}_${rIdx}`

    let html = `
        <tr id="collectActCouponTaskInfo_${rewardKey}" data-idx="${rIdx}"> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][taskConf][${rIdx}][taskId]" readonly value="${rIdx + 1}">
            </td> 
            <td>
                <select class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][taskConf][${rIdx}][taskType]">
                    ${collectActCouponTaskTypeOptionHtml}
                </select>
            </td> 
            <td>
                <input type="number" class="form-control" name="collectActCouponConf[stageConf][${lvIdx}][stages][${yIdx}][stages][${ssIdx}][stages][taskConf][${rIdx}][score]" value="0">
            </td> 
        </tr> 
    `;

    $('#collectActCouponTaskBody_' + lsrIdx).append(html)
}

function delCollectActCouponTaskTr(obj) {
    const {lvIdx, yIdx, ssIdx} = getParentIdx(obj)

    let rewardIdx = `${lvIdx}_${yIdx}_${ssIdx}`
    collectActCouponTaskStages[rewardIdx]--

    let rewardKey = rewardIdx + '_' + collectActCouponTaskStages[rewardIdx]

    if (collectActCouponTaskStages[rewardIdx] < 0) return;
    $('#collectActCouponTaskInfo_' + rewardKey).remove()
}