let LuckyFoxLvCnt = 0;
let LuckyFoxSpinsStages = {}
let LuckyFoxSsStages = {}
let LuckyFoxRewardStages = {}
let LuckyFoxProgressStages = {}

function initReward_luckyFox(type) {
    console.log('init ' + type)
    getActBasicConfig(type).then(()=>{
        initLuckyFoxWrap();
        // 奖励回写
        console.log('reward_info ', reward_info)
        if (!reward_info) {
            return
        }

        $.each(reward_info, function (lvStage, lvItem) {
            $('#addLuckyFoxLvWrapBtn').click()
            $(`input[name="luckyFoxConfig[${lvStage}][lvStart]"]`).val(lvItem.lvStart)
            $(`input[name="luckyFoxConfig[${lvStage}][lvEnd]"]`).val(lvItem.lvEnd)

            $.each(lvItem.stages, function (spinsStage, spinsItem) {
                $('.addLuckyFoxSpinsWrapBtn:last').click()
                $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][spinsStart]"]`).val(spinsItem.spinsStart)
                $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][spinsEnd]"]`).val(spinsItem.spinsEnd)

                $.each(spinsItem.stages, function (ssStage, ssItem) {
                    $('.addLuckyFoxSsWrapBtn:last').click()
                    $(`select[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][shushu][]"]`).val(ssItem.shushu)

                    // 普通奖励
                    ssItem.list && $.each(ssItem.list, function (rewardIndex, rewardItem) {
                        $('.addLuckyFoxRewardTrBtn:last').click()
                        $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][list][${rewardIndex}][grid]"]`).val(rewardItem.grid)
                        $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][list][${rewardIndex}][layer]"]`).val(rewardItem.layer)
                        $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][list][${rewardIndex}][weight]"]`).val(rewardItem.weight)
                        $(`select[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][list][${rewardIndex}][color]"]`).val(rewardItem.color)
                        $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][list][${rewardIndex}][prize]"]`).val(escape(JSON.stringify(rewardItem.prize)))

                        let prizeHtml = ''
                        $.each(rewardItem.prize, function (i, prize) {
                            prizeHtml += chestPropsHtml(prize)
                        })
                        $('.prizeShow:last').html(prizeHtml)
                    })

                    // 进度奖励
                    ssItem.progress && $.each(ssItem.progress, function (colorType, progressList) {

                        progressList && $.each(progressList, function (rewardIndex, rewardItem) {
                            let ssIdx = `${lvStage}_${spinsStage}_${ssStage}`
                            $(`#LuckyFoxProgressBody_${ssIdx}_${colorType}`).next().find('.addLuckyFoxProgressTrBtn').click()

                            $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][progress][${colorType}][${rewardIndex}][target]"]`).val(rewardItem.target)
                            $(`input[name="luckyFoxConfig[${lvStage}][stages][${spinsStage}][stages][${ssStage}][progress][${colorType}][${rewardIndex}][prize]"]`).val(escape(JSON.stringify(rewardItem.prize)))

                            let prizeHtml = ''
                            $.each(rewardItem.prize, function (i, prize) {
                                prizeHtml += chestPropsHtml(prize)
                            })
                            $('.prizeShow:last').html(prizeHtml)
                        })

                    })

                    renderNotokenAlert(`${lvStage}_${spinsStage}_${ssStage}`, activity_extra_data)
                })
            })
        })
        $('.select2').select2({})
    })

}

function changetypeTo_luckyFox() {
    getActBasicConfig(act_type).then(()=>{
        initLuckyFoxWrap();
    })
}

function initLuckyFoxWrap() {
    LuckyFoxLvCnt = 0;
    LuckyFoxSpinsStages = {}
    LuckyFoxRewardStages = {}
    LuckyFoxProgressStages = {}

    let html = LuckyFoxWrapStageTable();
    $("#reward_info").empty();
    $("#reward_info").append(html);
}

function LuckyFoxWrapStageTable() {
    return `
         <div class="text-right" style="margin:5px;padding:5px;border:solid 1px lightgray;">
            <button style="margin-top: 20px" id="addLuckyFoxLvWrapBtn" class="btn btn-primary" onclick="addLuckyFoxLvWrap(this)" type="button">添加等级区间</button>
            <button style="margin-top: 20px" class="btn btn-danger" onclick="delLuckyFoxLvWrap()" type="button">删除等级区间</button>
         </div>
        `
}

function addLuckyFoxLvWrap(obj) {
    LuckyFoxLvCnt++
    LuckyFoxSpinsStages[LuckyFoxLvCnt] = 0
    let html = `
        <div class="form-group text-left LuckyFoxLvWrap" id="LuckyFoxLvWrap_${LuckyFoxLvCnt}" data-idx="${LuckyFoxLvCnt}" style="margin:10px;padding:5px;border:solid 1px black;">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="luckyFoxConfig[${LuckyFoxLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="luckyFoxConfig[${LuckyFoxLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton style="margin-top: 10px" class="btn btn-primary  addLuckyFoxSpinsWrapBtn" onclick="addLuckyFoxSpinsWrap( this)">添加体力分组层级</botton>
            <botton style="margin-top: 10px" class="btn btn-danger del-tr delLuckyFoxSpinsWrapBtn" onclick="delLuckyFoxSpinsWrap( this)">删除体力分组层级</botton>
        </div>
        `
    $(obj).before(html)
}
function delLuckyFoxLvWrap() {
    if (LuckyFoxLvCnt < 1) {
        return;
    }
    $('#LuckyFoxLvWrap_' + LuckyFoxLvCnt).remove();
    LuckyFoxLvCnt--;
}

function addLuckyFoxSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    let spinsCnt = ++LuckyFoxSpinsStages[lvIdx]
    let spinWrapIdx = `${lvIdx}_${spinsCnt}`
    LuckyFoxSsStages[spinWrapIdx] = 0

    let html = `
        <div class="LuckyFoxSpinsWrap" id="LuckyFoxSpinsWrap_${spinWrapIdx}" data-idx="${spinsCnt}" style="margin:10px;padding:5px;border:solid 1px goldenrod;">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">体力区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="luckyFoxConfig[${LuckyFoxLvCnt}][stages][${spinsCnt}][spinsStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="luckyFoxConfig[${LuckyFoxLvCnt}][stages][${spinsCnt}][spinsEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton style="margin-top: 10px" class="btn btn-primary  addLuckyFoxSsWrapBtn" onclick="addLuckyFoxSsWrap( this)">添加数数分组层级</botton>
            <botton style="margin-top: 10px" class="btn btn-danger del-tr delLuckyFoxSsWrapBtn" onclick="delLuckyFoxSsWrap( this)">删除数数分组层级</botton>
        </div>`
    $(obj).before(html)
}
function delLuckyFoxSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    if (LuckyFoxSpinsStages[lvIdx] < 1) return
    $(obj).parents('.LuckyFoxLvWrap').find('.LuckyFoxSpinsWrap:last').remove()
    LuckyFoxSpinsStages[lvIdx]--
}

function addLuckyFoxSsWrap(obj) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.LuckyFoxSpinsWrap').data('idx')
    let spinWrapIdx = `${lvIdx}_${spinsIdx}`
    let ssCnt = ++LuckyFoxSsStages[spinWrapIdx]
    let ssIdx = `${lvIdx}_${spinsIdx}_${ssCnt}`

    LuckyFoxRewardStages[ssIdx] = 0
    LuckyFoxProgressStages[ssIdx] = {}
    let shushuOptions = getShushuSelectorOptions()
    let html = `
        <div class="LuckyFoxSsWrap" id="LuckyFoxSsWrap_${ssIdx}" data-idx="${ssCnt}" style="margin:10px;padding:5px;border:solid 1px goldenrod;">
            <table class="table table-bordered">
                <thead>
                    <tr><td colspan="7">
                         <div class="form-group">
                            <label class="col-sm-1 control-label m-b">数数分组: </label>
                            <div class="col-sm-3 input-group">
                                <select class="select2" name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssCnt}][shushu][]" multiple>
                                    ${shushuOptions}
                                </select>
                            </div>
                        </div>
                    </td></tr>
                    <tr>
                        <th width="120">Index</th>
                        <th>格数</th>
                        <th>层级</th>
                        <th>颜色</th>
                        <th>权重</th>
                        <th>奖励</th>
                        <th width="120">奖励设置</th>
                    </tr>
                </thead>
                <tbody id="LuckyFoxRewardBody_${ssIdx}"></tbody>
                <tr>
                    <td colspan="7">
                        <div class="text-center" style="margin-top: 20px">
                            <botton class="btn btn-primary addLuckyFoxRewardTrBtn" onclick="addLuckyFoxRewardTr(this)">添加</botton>
                            <botton class="btn btn-danger del-tr" onclick="delLuckyFoxRewardTr(this)">删除</botton>
                        </div>
                    </td>
                </tr>
            </table>
           
        `

    $.each(actBasicConf[act_type].colors, (i, o)=>{
        if(i > 0){
            html += getLuckyFoxColorCollectWrap(ssIdx, i)
        }
    })

    html += '</div>'
    $(obj).before(html)
    $(`#LuckyFoxSsWrap_${ssIdx}`).append(noTokenAlert(ssIdx, 126))
    $('.select2').select2({})
}
function delLuckyFoxSsWrap(obj) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.LuckyFoxSpinsWrap').data('idx')
    let ssIdxKey = `${lvIdx}_${spinsIdx}`
    if (LuckyFoxSsStages[ssIdxKey] < 1) return
    $(obj).parents('.LuckyFoxSpinsWrap').find('.LuckyFoxSsWrap:last').remove()
    LuckyFoxSsStages[ssIdxKey]--
}

function addLuckyFoxRewardTr(obj) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.LuckyFoxSpinsWrap').data('idx')
    let ssIdx = $(obj).parents('.LuckyFoxSsWrap').data('idx')
    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`

    let rewardStage = ++LuckyFoxRewardStages[rewardIdx]
    let rewardKey = `${rewardIdx}_${rewardStage}`
    let prize = escape('[]');
    let colorOptionsHtml = getLuckyFoxColorOptions();
    let html = `
        <tr class="LuckyFoxRewardInfoTr commonStageRewardTr" id="LuckyFoxRewardInfo_${rewardKey}" data-idx=" ${rewardStage} ">
            <td width="120"><input type="text"  class="form-control" value="${rewardStage}" readonly ></td>
            <td><input name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][list][${rewardStage}][grid]" type="text"  class="form-control" value="0"></td>
            <td><input name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][list][${rewardStage}][layer]" type="text"  class="form-control" value="0"></td>
            <td>
                <select name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][list][${rewardStage}][color]" class="form-control">
                    ${colorOptionsHtml}
                </select>
            </td>
            <td><input name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][list][${rewardStage}][weight]" type="text"  class="form-control" value="0"></td>
            <td class="prizeShow"></td>
            <td>
                <input type="hidden" class="prizeInput" name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][list][${rewardStage}][prize]" value="${prize}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
        </tr>`;

    $('#LuckyFoxRewardBody_' + rewardIdx).append(html)
}
function delLuckyFoxRewardTr(obj) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    let SpinsIdx = $(obj).parents('.LuckyFoxSpinsWrap').data('idx')
    let SsIdx = $(obj).parents('.LuckyFoxSsWrap').data('idx')
    let rewardIdx = `${lvIdx}_${SpinsIdx}_${SsIdx}`

    let rewardKey = `${rewardIdx}_${LuckyFoxRewardStages[rewardIdx]}`
    if (LuckyFoxRewardStages[rewardIdx] < 1) return;
    $('#LuckyFoxRewardInfo_' + rewardKey).remove()
    LuckyFoxRewardStages[rewardIdx]--
}

function addLuckyFoxProgressTr(obj, i) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.LuckyFoxSpinsWrap').data('idx')
    let ssIdx = $(obj).parents('.LuckyFoxSsWrap').data('idx')
    let rewardKey = `${lvIdx}_${spinsIdx}_${ssIdx}`


    let rewardStage = ++LuckyFoxProgressStages[rewardKey][i]
    let rewardTrKey = `${rewardKey}_${rewardStage}`
    let prize = escape('[]');

    let html = `
        <tr class="LuckyFoxProgressInfoTr commonStageRewardTr" id="LuckyFoxProgressInfo_${rewardTrKey}" data-idx=" ${rewardStage} ">
            <td width="120"><input type="text" name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][progress][${i}][${rewardStage}][stage]" class="form-control" value="${rewardStage+1}" readonly ></td>
            <td><input name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][progress][${i}][${rewardStage}][target]" type="text"  class="form-control" value="0"></td>
            <td class="prizeShow"></td>
            <td>
                <input type="hidden" class="prizeInput" name="luckyFoxConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][progress][${i}][${rewardStage}][prize]" value="${prize}">
                <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
            </td>
        </tr>`;

    $(`#LuckyFoxProgressBody_${rewardKey}_${i}`).append(html)
}
function delLuckyFoxProgressTr(obj, i) {
    let lvIdx = $(obj).parents('.LuckyFoxLvWrap').data('idx')
    let SpinsIdx = $(obj).parents('.LuckyFoxSpinsWrap').data('idx')
    let SsIdx = $(obj).parents('.LuckyFoxSsWrap').data('idx')
    let rewardKey = `${lvIdx}_${SpinsIdx}_${SsIdx}`

    if (LuckyFoxProgressStages[rewardKey][i] < 1) return;
    $(`#LuckyFoxProgressBody_${rewardKey}_${i}`).find('.LuckyFoxProgressInfoTr:last').remove()
    LuckyFoxProgressStages[rewardKey][i]--
}

// 颜色收集html
function getLuckyFoxColorCollectWrap(ssIdx, i){

    LuckyFoxProgressStages[ssIdx][i] = -1
    return ` 
            <hr style="border:solid 1px goldenrod;">
            颜色${i}收集
            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th width="120">阶段</th>
                        <th width="140">阶段值</th>
                        <th>奖励</th>
                        <th width="140">奖励设置</th>
                    </tr>
                </thead>
                <tbody id="LuckyFoxProgressBody_${ssIdx}_${i}"></tbody>
                <tr>
                    <td colspan="7">
                        <div class="text-center" style="margin-top: 20px">
                            <botton class="btn btn-primary addLuckyFoxProgressTrBtn" onclick="addLuckyFoxProgressTr(this, ${i})">添加阶段奖励</botton>
                            <botton class="btn btn-danger del-tr" onclick="delLuckyFoxProgressTr(this, ${i})">删除</botton>
                        </div>
                    </td>
                </tr>
            </table>
`
}

// 颜色选项html
function getLuckyFoxColorOptions(){
    let html = ''
    $.each(actBasicConf[act_type].colors, (i, o)=>{
        html += `<option value="${i}">${o}</option>`
    })
    return html
}