let superBingoLvCnt = 0
let superBingoSpinsStages = {}
let superBingoShushuStages = {}
let superBingoProbStages = {}
let superBingoOutsideRewardStages = {}
let superBingoInsideRewardStages = {}
let superBingoTaskStages = {}
let superBingoScoreStages = {}
let superBingoLowStages = {}
let superBingoLowStagesGrids = {}
let superBingoHighStages = {}
let superBingoHighStagesGrids = {}
let superBingoTaskTypeOptionHtml = ""

function initRewardSuperBingo() {
    getActBasicConfig(act_type).then(()=>{
        let html = superBingoStageTable();
        $("#reward_info").html(html);

        reward_conf && $.each(reward_conf, function (i, o) {
            $('#addSuperBingoLvWrapBtn').click()
            $(`input[name="superBingoConf[stageConf][${i}][lvStart]"]`).val(o.lvStart)
            $(`input[name="superBingoConf[stageConf][${i}][lvEnd]"]`).val(o.lvEnd)
            $.each(o.stages, function (i1, o1) {
                $('.addSuperBingoSpinsWrapBtn:last').click()
                $(`input[name="superBingoConf[stageConf][${i}][stages][${i1}][spinsStart]"]`).val(o1.spinsStart)
                $(`input[name="superBingoConf[stageConf][${i}][stages][${i1}][spinsEnd]"]`).val(o1.spinsEnd)
                $.each(o1.stages, function (i2, o2) {
                    $('.addSuperBingoShushuWrapBtn:last').click()
                    $(`select[name="superBingoConf[stageConf][${i}][stages][${i1}][stages][${i2}][shushu][]"]`).val(o2.shushu)

                    $.each(o2.rewards, function (ri, ro) {
                        let prizeInput = $(`input[name="superBingoConf[stageConf][${i}][stages][${i1}][stages][${i2}][rewards][${ri}]"]`)
                        prizeInput.val(escape(JSON.stringify(ro)))
                        prizeInput.parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(ro))
                    })
                })
            })
        })
        $('.select2').select2({})
    })


}

function changeTypeToSuperBingo() {
    superBingoLvCnt = 0
    superBingoSpinsStages = {}
    superBingoShushuStages = {}
    superBingoProbStages = {}
    superBingoOutsideRewardStages = {}
    superBingoInsideRewardStages = {}
    superBingoTaskStages = {}

    getActBasicConfig(act_type).then(()=>{
        let html = superBingoStageTable();
        $("#reward_info").html(html);
    })
}

function superBingoStageTable() {
    return `
        <div class="form-group text-center">
            <h4 style="font-weight: bold" class="text-left">奖励配置*:</h4>
            <button class="btn btn-primary" id="addSuperBingoLvWrapBtn" onclick="addSuperBingoLvWrap(this)" type="button">添加等级层级</button>
            <button class="btn btn-white"   id="delSuperBingoLvWrapBtn" onclick="delSuperBingoLvWrap()" type="button">删除等级层级</button>
        </div>
        <hr style=" height:2px;border:none;border-top:2px dotted #0b0;">
    `;
}

function addSuperBingoLvWrap(obj) {
    superBingoLvCnt++
    superBingoSpinsStages[superBingoLvCnt] = 0

    let html = `
        <div class="superBingoLvWrap table-border-blue" id="superBingoLvWrap_${superBingoLvCnt}" data-idx="${superBingoLvCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">等级区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="superBingoConf[stageConf][${superBingoLvCnt}][lvStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="superBingoConf[stageConf][${superBingoLvCnt}][lvEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton class="btn btn-primary addSuperBingoSpinsWrapBtn" onclick="addSuperBingoSpinsWrap(this)">添加体力层级</botton>
            <botton class="btn btn-danger del-tr delSuperBingoSpinsWrapBtn" onclick="delSuperBingoSpinsWrap(this)">删除体力层级</botton>
        </div>
`

    $(obj).before(html)
    $('.select2').select2({})
}
function delSuperBingoLvWrap() {
    if (superBingoLvCnt < 1) {
        return;
    }
    $('#superBingoLvWrap_' + superBingoLvCnt).remove();
    superBingoLvCnt--;
}

function addSuperBingoSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.superBingoLvWrap').data('idx')
    let superBingoSpinsCnt = ++superBingoSpinsStages[lvIdx]
    let spinsIdx = `${lvIdx}_${superBingoSpinsCnt}`
    superBingoShushuStages[spinsIdx] = 0

    let html = `
        <div class="superBingoSpinsWrap table-border-blue" id="superBingoSpinsWrap_${spinsIdx}" data-idx="${superBingoSpinsCnt}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">体力区间: </label>
                <div class="col-sm-3 input-group">
                    <input type="text" style="text-align: center" class="form-control" name="superBingoConf[stageConf][${lvIdx}][stages][${superBingoSpinsCnt}][spinsStart]" value="0">
                    <span class="input-group-addon">-</span>
                    <input type="text" style="text-align: center" class="form-control" name="superBingoConf[stageConf][${lvIdx}][stages][${superBingoSpinsCnt}][spinsEnd]" value="0">
                </div>
            </div>
            <hr style="border:solid 1px black;">
            <botton class="btn btn-primary addSuperBingoShushuWrapBtn" onclick="addSuperBingoShushuWrap(this)">添加数数分组层级</botton>
            <botton class="btn btn-danger del-tr delSuperBingoShushuWrapBtn" onclick="delSuperBingoShushuWrap(this)">删除数数分组层级</botton>
        </div>
    `

    $(obj).before(html)
    $('.select2').select2({})
}
function delSuperBingoSpinsWrap(obj) {
    let lvIdx = $(obj).parents('.superBingoLvWrap').data('idx')

    if (superBingoSpinsStages[lvIdx] < 1) return
    $(obj).parents('.superBingoLvWrap').find('.superBingoSpinsWrap:last').remove()
    superBingoSpinsStages[lvIdx]--
}

function addSuperBingoShushuWrap(obj) {
    let lvIdx = $(obj).parents('.superBingoLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.superBingoSpinsWrap').data('idx')

    let ssIdx = ++superBingoShushuStages[`${lvIdx}_${spinsIdx}`]

    let rewardIdx = `${lvIdx}_${spinsIdx}_${ssIdx}`

    let prizeDft = escape('{}')
    let optionsHtml = getShushuSelectorOptions()

    let rewardHtml = ''
    $.each(actBasicConf[act_type], (i, o)=>{
        rewardHtml += `
            <tr class="commonStageRewardTr">
                <td>${i}</td>
                <td>
                    <input type="hidden" class="prizeInput" name="superBingoConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][rewards][${o}]" value="${prizeDft}">
                    <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this,'setCommonPrize',1)">奖励配置</button>
                </td>
                <td class="prizeShow"></td>
            </tr>
        `
    })
    let html = `
        <div class="superBingoShushuWrap table-border-blue" id="superBingoShushuWrap_${rewardIdx}" data-idx="${ssIdx}">
            <div class="form-group">
                <label class="col-sm-1 control-label m-b">数数分组 </label>
                <div class="col-sm-3 input-group"> 
                    <select class=" select2" name="superBingoConf[stageConf][${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][shushu][]"  multiple  style="min-width: 100%"> 
                        ${optionsHtml}
                    </select> 
                </div>
            </div> 
            <hr style="border:solid 1px black;">
            
            
            <table class="table table-bordered" > 
                    <thead>
                        <tr>
                            <th width="120">位置</th> 
                            <th width="100px">奖励配置</th>
                            <th>奖励</th> 
                        </tr>
                    </thead> 
                    <tbody id="superBingoProbBody_${rewardIdx}">
                        ${rewardHtml}
                    </tbody>
                </table>
            
        </div>`;

    $(obj).before(html)
    $('.select2').select2({})
}
function delSuperBingoShushuWrap(obj) {
    let lvIdx = $(obj).parents('.superBingoLvWrap').data('idx')
    let spinsIdx = $(obj).parents('.superBingoSpinsWrap').data('idx')

    if (superBingoShushuStages[`${lvIdx}_${spinsIdx}`] < 1) return
    $(obj).parents('.superBingoSpinsWrap').find('.superBingoShushuWrap:last').remove()
    superBingoShushuStages[`${lvIdx}_${spinsIdx}`]--
}
