function changeTypeToTimeLimitedIsland() {
    initTimeLimitedIslandWrap().then()
}

function renderTimeLimitedIslandConfig() {
    initTimeLimitedIslandWrap().then(()=>{

        $('input[name="timeLimitedIslandBasicConfig[stars]"]').val(reward_info.stars)
        $('select[name="timeLimitedIslandBasicConfig[theme]"]').val(reward_info.theme)

        activity_extra_data && $.each(activity_extra_data,  function(lvIdx, item1){
            addTimeLimitedIslandLvWrap();
            $(`input[name="timeLimitedIslandConfig[${lvIdx}][start]"]`).val(item1.start);
            $(`input[name="timeLimitedIslandConfig[${lvIdx}][end]"]`).val(item1.end);


            item1.stages && $.each(item1.stages,  function(spinsIdx, item2){
                addTimeLimitedIslandSpinsWrap(lvIdx);
                $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][start]"]`).val(item2.start);
                $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][end]"]`).val(item2.end);

                item2.stages && $.each(item2.stages,  function(ssIdx, item3){
                    addTimeLimitedIslandShushuWrap(lvIdx, spinsIdx);
                    console.log($(`select[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][shushu][]"]`));
                    console.log(item3);
                    $(`select[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][shushu][]"]`).val(item3.shushu);
                    $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][finalPrize]"]`).val(escape(JSON.stringify(item3.finalPrize)));
                    $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][finalPrize]"]`).parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(item3.finalPrize));

                    item3.islands && $.each(item3.islands,  function(iidx, item4){
                        addTimeLimitedIslandStageIsland(lvIdx, spinsIdx, ssIdx)
                        console.log($(`select[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][islands][${iidx}][island]"]`));
                        console.log(item4);
                        $(`select[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][islands][${iidx}][island]"]`).val(item4.island);
                        $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][islands][${iidx}][completePrize]"]`).val(escape(JSON.stringify(item4.completePrize)));
                        $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][islands][${iidx}][completePrize]"]`).parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(item4.completePrize));

                        item4.buildings && $.each(item4.buildings,  function(bidx, item5){
                            $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][islands][${iidx}][buildings][${bidx}][prize]"]`).val(escape(JSON.stringify(item5.prize)));
                            $(`input[name="timeLimitedIslandConfig[${lvIdx}][stages][${spinsIdx}][stages][${ssIdx}][islands][${iidx}][buildings][${bidx}][prize]"]`).parents('.commonStageRewardTr').find('.prizeShow').html(prizeListHtml(item5.prize));

                        })

                    })

                })

            })
        })
        $('.select2').select2()
    })

}

async function initTimeLimitedIslandConfig() {

}

async function initTimeLimitedIslandWrap(){

    timeLimitedIslandLvCnt = 0;
    timeLimitedIslandSpinsMap = {};
    timeLimitedIslandShushuMap = {};
    timeLimitedIslandIslandsMap = {};
    timeLimitedIslandStagesTaskMap = {};

    if (typeof timeLimitedIslands === 'undefined') {
        showLoading()
        await $.get('/activity/getActBasicConfig/time_limited_island',function(response){
            if (typeof response === 'string')response = JSON.parse(response)
            hideLoading()
            timeLimitedIslands = response.data.islands
            timeLimitedIslandThemes = response.data.islandThemes
        })
    }

    let themeOptions = '<option value="0">开放主题</option>'
    $.each(timeLimitedIslandThemes, function(i, o){
        themeOptions += `<option value="${o.iid}">${o.remark}</option>`
    })
    let basicConfHtml = `
        <table class="table table-bordered ">
            <tr class="commonStageRewardTr">
                <td>每个建筑的星星数</td>
                <td><input class="form-control" name="timeLimitedIslandBasicConfig[stars]"></td>
            </tr>
            <tr class="commonStageRewardTr">
                <td>开放主题</td>
                <td>
                    <select class="form-control" name="timeLimitedIslandBasicConfig[theme]">
                        ${themeOptions}
                    </select>
                </td>
            </tr>
        </table>
`
    $("#reward_info").append(basicConfHtml);
    $("#reward_info").append(timeLimitedIslandStagesRewards());

}

// 分阶段奖励配置
function timeLimitedIslandStagesRewards(){
    console.log(110)
    return `<div class="ibox-title" style="border-top: 0;"><h5 style="font-weight: bold">分阶段奖励配置</h5></div>
    <div class="rewardsWrap timeLimitedIslandStagesRewardsWrap" id="timeLimitedIslandStagesRewardsWrap">
        <div class="opBtns">
            <button type="button" class="btn btn-primary addTimeLimitedIslandLvWrap" onclick="addTimeLimitedIslandLvWrap()">添加等级区间</button>
            <button type="button" class="btn btn-danger  delTimeLimitedIslandLvWrap" onclick="delTimeLimitedIslandLvWrap()">删除等级区间</button>
        </div>
    </div>`;
}


// 等级区间配置
function addTimeLimitedIslandLvWrap(){
    timeLimitedIslandLvCnt++;
    timeLimitedIslandSpinsMap[timeLimitedIslandLvCnt] = 0;
    let html = `<div class="rewardsWrap timeLimitedIslandLvWrap_${timeLimitedIslandLvCnt}" id="timeLimitedIslandLvWrap_${timeLimitedIslandLvCnt}">
                <div class="form-group">
                    <label class="col-sm-2 control-label m-b">等级区间 </label>
                    <div class="col-sm-3 input-group">
                        <input type="text" style="text-align: center" class="form-control" name="timeLimitedIslandConfig[${timeLimitedIslandLvCnt}][start]" value="0">
                        <span class="input-group-addon">-</span>
                        <input type="text" style="text-align: center" class="form-control" name="timeLimitedIslandConfig[${timeLimitedIslandLvCnt}][end]" value="0">
                    </div>
                </div>
                <div class="opBtns ">
                    <botton  type="button" class="btn btn-primary addTimeLimitedIslandSpinsWrap"  onclick="addTimeLimitedIslandSpinsWrap(${timeLimitedIslandLvCnt})" >添加体力区间</botton>
                    <botton  type="button" class="btn btn-danger  delTimeLimitedIslandSpinsWrap"  onclick="delTimeLimitedIslandSpinsWrap(${timeLimitedIslandLvCnt})" >删除体力区间</botton>
                </div>
            </div>`;
    $(`#timeLimitedIslandStagesRewardsWrap`).children('.opBtns').before(html)
}
function delTimeLimitedIslandLvWrap(){
    if(timeLimitedIslandLvCnt > 0 && $(`#timeLimitedIslandLvWrap_${timeLimitedIslandLvCnt}`).length > 0){
        $(`#timeLimitedIslandLvWrap_${timeLimitedIslandLvCnt}`).remove();
        timeLimitedIslandLvCnt--
    }
}


// 体力区间配置
function addTimeLimitedIslandSpinsWrap(idx1){
    let idx2 = ++timeLimitedIslandSpinsMap[idx1]
    let key3 = `${idx1}_${idx2}`
    timeLimitedIslandShushuMap[key3] = 0
    let html = `<div class=" rewardsWrap timeLimitedIslandSpinsWrap_${key3}" id="timeLimitedIslandSpinsWrap_${key3}">
                <div class="form-group">
                    <label class="col-sm-2 control-label m-b">体力区间 </label>
                    <div class="col-sm-3 input-group">
                        <input type="text" style="text-align: center" class="form-control" name="timeLimitedIslandConfig[${idx1}][stages][${idx2}][start]" value="0">
                        <span class="input-group-addon">-</span>
                        <input type="text" style="text-align: center" class="form-control" name="timeLimitedIslandConfig[${idx1}][stages][${idx2}][end]" value="0">
                    </div>
                </div>
                <div class="opBtns ">
                    <botton type="button" class="btn btn-primary addTimeLimitedIslandShushuWrap"  onclick="addTimeLimitedIslandShushuWrap(${idx1}, ${idx2})" >添加数数区间</botton>
                    <botton type="button" class="btn btn-danger  delTimeLimitedIslandShushuWrap"  onclick="delTimeLimitedIslandShushuWrap(${idx1}, ${idx2})" >删除数数区间</botton>
                </div>
            </div>`;
    $(`#timeLimitedIslandLvWrap_${idx1}`).children('.opBtns').before(html)
}
function delTimeLimitedIslandSpinsWrap(idx1){
    let idx2 = timeLimitedIslandSpinsMap[idx1]
    let key3 = `${idx1}_${idx2}`
    if(idx2 > 0 && $(`#timeLimitedIslandSpinsWrap_${key3}`).length > 0){
        $(`#timeLimitedIslandSpinsWrap_${key3}`).remove();
        timeLimitedIslandSpinsMap[idx1]--
    }
}

// 数数区间配置
function addTimeLimitedIslandShushuWrap(idx1, idx2){
    let key3 = `${idx1}_${idx2}`;
    let idx3 = ++timeLimitedIslandShushuMap[key3];
    let key4 = `${idx1}_${idx2}_${idx3}`;
    timeLimitedIslandIslandsMap[key4] = -1;

    let optionsHtml = getShushuSelectorOptions()
    let html = `<div class=" rewardsWrap timeLimitedIslandShushuWrap_${key4}" id="timeLimitedIslandShushuWrap_${key4}">
                    <div class="form-group">
                        <label class="col-sm-2 control-label m-b">数数分组</label>
                        <div class="col-sm-3 input-group">
                            <select class="select2  " style="width: 100%" name="timeLimitedIslandConfig[${idx1}][stages][${idx2}][stages][${idx3}][shushu][]" multiple>
                                ${optionsHtml}
                            </select>
                        </div>
                    </div>`

    html += `
            <div class="opBtns ">
            <table class="table table-bordered ">
                <tr class="commonStageRewardTr">
                    <td>最终大奖</td>
                    <td class=" prizeShow showStagePrize"></td>
                    <td class=" ">
                        <input name="timeLimitedIslandConfig[${idx1}][stages][${idx2}][stages][${idx3}][finalPrize]" value="%5B%5D" class="prizeInput" type="hidden">
                        <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this, 'setCommonPrize', 1)">奖励配置</button>
                    </td>
            </tr>
            </table>
            <br>
                <botton type="button" class="btn btn-primary addTimeLimitedIslandStageTaskRewardTr"  onclick="addTimeLimitedIslandStageIsland( ${idx1}, ${idx2}, ${idx3})" >添加岛屿</botton>
                <botton type="button" class="btn btn-danger  delTimeLimitedIslandStageTaskRewardTr"  onclick="delTimeLimitedIslandStageIsland( ${idx1}, ${idx2}, ${idx3})" >删除岛屿</botton>
            </div>`

    html += ` </div>`

    $(`#timeLimitedIslandSpinsWrap_${key3}`).children('.opBtns').before(html)
    $('.select2').select2({})
}
function delTimeLimitedIslandShushuWrap(idx1, idx2){
    let key3 = `${idx1}_${idx2}`;
    let idx3 = timeLimitedIslandShushuMap[key3];
    let key4 = `${idx1}_${idx2}_${idx3}`;
    if(idx3 > 0 && $(`#timeLimitedIslandShushuWrap_${key4}`).length > 0){
        $(`#timeLimitedIslandShushuWrap_${key4}`).remove();
        timeLimitedIslandShushuMap[key3]--
    }
}

// 岛屿配置
function addTimeLimitedIslandStageIsland(idx1, idx2, idx3){
    let key4 = `${idx1}_${idx2}_${idx3}`;
    let idx4 = ++timeLimitedIslandIslandsMap[key4];
    let key5 = `${idx1}_${idx2}_${idx3}_${idx4}`;

    let optionsHtml = getTimeLimitedIslandOptions()
    let html = `<div class=" rewardsWrap timeLimitedIslandIslandWrap_${key5}" id="timeLimitedIslandIslandWrap_${key5}">
                    <div class="form-group">
                        <label class="col-sm-2 control-label m-b">岛屿id</label>
                        <div class="col-sm-3 input-group">
                            <select class="select2  " style="width: 100%" name="timeLimitedIslandConfig[${idx1}][stages][${idx2}][stages][${idx3}][islands][${idx4}][island]">
                                ${optionsHtml}
                            </select>
                        </div>
                    </div>`

    html += `<table class="table table-bordered ">
                <thead>
                    <th>建筑</th>
                    <th>奖品</th>
                    <th>奖励设置</th>
                </thead>
                <tbody class="timeLimitedIslandConfigTBody_${key5}" id="timeLimitedIslandConfigTBody_${key5}">
                    
                </tbody>
            </table>
    `

    html += ` </div>`

    $(`#timeLimitedIslandShushuWrap_${key4}`).children('.opBtns').before(html)

    let i = 0
    while(i<6){
        i++
        addTimeLimitedIslandStageIslandItem(idx1, idx2, idx3,idx4,i)
    }
    $('.select2').select2({})
}
function delTimeLimitedIslandStageIsland(idx1, idx2, idx3){
    let key4 = `${idx1}_${idx2}_${idx3}`;
    let idx4 = timeLimitedIslandIslandsMap[key4];
    let key5 = `${idx1}_${idx2}_${idx3}_${idx4}`;
    if(idx4 > 0 && $(`.timeLimitedIslandIslandWrap_${key5}`).length > 0){
        $(`#timeLimitedIslandIslandWrap_${key5}`).remove();
        timeLimitedIslandIslandsMap[key4]--
    }
}

// 岛屿建筑配置
function addTimeLimitedIslandStageIslandItem(idx1, idx2, idx3, idx4, idx5){
    let key5 = `${idx1}_${idx2}_${idx3}_${idx4}`;
    let text = ''
    let prizeName = ''
    if (idx5 <= 5 ){
        text = '建筑'+idx5
        prizeName = `timeLimitedIslandConfig[${idx1}][stages][${idx2}][stages][${idx3}][islands][${idx4}][buildings][${idx5}][prize]`
    }else{
        text = '本关大奖'
        prizeName = `timeLimitedIslandConfig[${idx1}][stages][${idx2}][stages][${idx3}][islands][${idx4}][completePrize]`
    }
    let html = `<tr class="commonStageRewardTr">
                    <td>${text}</td>
                    <td class=" prizeShow showStagePrize"></td>
                    <td class=" ">
                        <input name="${prizeName}" value="%5B%5D" class="prizeInput" type="hidden">
                        <button type="button" class="btn btn-outline btn-success" onclick="setPrize(this, 'setCommonPrize', 1)">奖励配置</button>
                    </td>
            </tr>`
    $(`#timeLimitedIslandConfigTBody_${key5}`).append(html)
}

// 任务配置








