function initReward_warmupNotice(type) {
    console.log('init ' + type)
    changetypeTo_warmupNotice();

    // 奖励回写
    console.log('reward_info ', reward_info)
    console.log('extraData ', extraData)
    if (!reward_info || !extraData) {
        return
    }

    const extra_data = JSON.parse(extraData)
    const nodeArr = $(`input[name="warmupNoticeConf[device]"]`)
    for (let idx = 0; idx < nodeArr.length; idx++) {
        nodeArr[idx].checked = extra_data['device'] === nodeArr[idx].value;
    }

    let html = ''
    for (const field in reward_info) {
        const langInfo = extra_data['conf'][field] ?? undefined
        if (langInfo === undefined) {
            continue
        }

        let contents = langInfo['contents'];

        let contentHtml = ""
        for (const idx in contents) {
            contentHtml += `<textarea style="margin-bottom: 5px" rows="2" placeholder="" name="warmupNoticeConf[conf][${field}][contents][]" class="form-control">${contents[idx]}</textarea>`
        }

        html += `    
            <tr>
                <td><input type="text" placeholder="" value="${reward_info[field]}" class="form-control" disabled></td>
                <td><input type="text" placeholder="" value="${field}" class="form-control" disabled></td>
                <td>${contentHtml}</td>
            </tr>`
    }

    $('#warmupNoticeBody').append(html)
}

function changetypeTo_warmupNotice() {
    $("#reward_info").empty();
    initWarmupNoticeWrap();
}

function initWarmupNoticeWrap() {
    var html = WarmupNoticeWrapStageTable();
    $("#reward_info").append(html);
}

function WarmupNoticeWrapStageTable() {
    return `
    <div hidden="hidden" class="form-group" >
        <label class="col-sm-1 control-label">生效平台:</label>
        <div class="col-sm-11">
            <label class="radio-inline">
                <input type="radio" name="warmupNoticeConf[device]" value="all" checked="checked"> 全部
            </label>
            <label class="radio-inline">
                <input type="radio" name="warmupNoticeConf[device]" value="android"> 安卓
            </label>
            <label class="radio-inline">
                <input type="radio" name="warmupNoticeConf[device]" value="ios"> 苹果
            </label>
        </div>
    </div>

    <div class="form-group" style="margin-top: 50px">
        <label class="col-sm-1 control-label">语言配置:</label>
        <div class="col-sm-11">
           <table class="table table-bordered">
                <thead>
                    <tr>
                        <td style="width: 10%">地区</td>
                        <td style="width: 10%">语言</td>
                        <td>正文</td>
                    <tr>
                </thead>
                 <tbody id="warmupNoticeBody"> </tbody>
           </table>    
        </div>
    </div>
    `;
}


